<?php

//  Funciones web para crear Reclamos en el sistema de GE. Zoom International Services (c) 2014
//  Agregado por Maria Neto el 26/09/2014
//  Modificado por Rosabin Toledo el 22/12/2014

function getProtecMercancia() {
	$r = array( "1" => "SI", "2" => "NO");
	return ZoomWS_Response($r);
}

function getTipodeReclamo() {
	$cache = new cache();
	$cache->setTime(172800);
	$contenido = $cache->getCache("getTipoRec");
	if(!empty($contenido)) {
		return ZoomWS_Response(unserialize($contenido));	
	}

	$query="SELECT codestatus,nombreweb as descripcion FROM calidad_estatus where tipoestatus ilike '%i%' and id_estatus<>5 order by descripcion asc";
	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			//$row['descripcion']=htmlentities($row['descripcion']);
			$respuesta[] = $row;
			//$respuesta[] = $row['descripcion'];
		}
	}	
	if(count($respuesta)==0) {
		return ZoomWS_Error("NO HAY ESTATUS PARA MOSTRAR");
	}else{
		$cache->finish(serialize($respuesta),false);
		return ZoomWS_Response($respuesta);
	}
}



//Busca la descripcion del reclamo - 31/10/2014
function getDescripcionReclamo($tiporeclamo) {
	/*$cache = new cache();
	$cache->setTime(172800);
	$contenido = $cache->getCache("getInfoDescrRec");
	if(!empty($contenido)) {
		return ZoomWS_Response(unserialize($contenido));	
	}*/

	//$query="SELECT descripcionweb as infodescripcion  FROM calidad_estatus where tipoestatus ilike '%i%' and id_estatus<>5 and codestatus='8'";
	$query="SELECT descripcionweb as infodescripcion  FROM calidad_estatus where tipoestatus ilike '%i%' and id_estatus<>5 and codestatus='".$tiporeclamo."'";
	$responde = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$responde[] = $row;
		}
	}	

	if(count($responde)==0) {
		return ZoomWS_Error("");
	}else{
		//$cache->finish(serialize($responde),false);
		return ZoomWS_Response($responde);
	}
}






function getPrioridad() {
	$r = array( "1" => "BAJA", "2" => "MEDIA", "3" => "ALTA", "4" => "CRITICA");
	return ZoomWS_Response($r);
}




function getGuiawebInactiva($tipobusqueda,$codguia) {

	//Validar si la guia est anulada

//agregar validaciones 

	if ($tipobusqueda==2)//Referencia
	{
		$where= " and referencia='".$codguia."'";
	}
	else//consulta de guia
	{
		$where= " and codguia=".$codguia;
	}
	$query="SELECT codguia, elerep FROM guiaweb where anulada=true ".$where; //'elerep']=='t

	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
			return  ZoomWS_Error('GE');
	}
	else
	{
		return  ZoomWS_Error('NO');
	}
}



//Calcula los dias trasncurridos
function dias_transcurridos($fecha_i,$fecha_f)
{
	$dias	= (strtotime($fecha_i)-strtotime($fecha_f))/86400;
	$dias 	= abs($dias); $dias = floor($dias);		
	return $dias;
}
// Ejemplo de uso:
//echo dias_transcurridos('2012-07-01','2012-07-18');
// Salida : 17









//$sistema=1; //Si el sistema es guia electronica
//$codvia='6';  //Si el sistema es guia electronica
function GuardarReclamo($nombrecontacto,
							$telefonocontacto,
							$emailcontacto,
							$codguia,
							$tipoenvio,
							$clienteenvioasegurado,
							$montoasegurado,
							$tiporeclamoini,
							$prioridad,
							$descripcionreclamo,
							$codcliente,
							$codusuario,
							$tipobusqueda,
							$sistema='10',
							$codvia='6'
						) {

	$nombrecontacto=limpiarCampo4($nombrecontacto);
	$telefonocontacto=limpiarCampo4($telefonocontacto);
	$emailcontacto=limpiarCampo4($emailcontacto);
	$tipoenvio=limpiarCampo4($tipoenvio);
	$clienteenvioasegurado=limpiarCampo4($clienteenvioasegurado);
	$montoasegurado=limpiarCampo4($montoasegurado);
	$tiporeclamoini=limpiarCampo4($tiporeclamoini);
	$prioridad=limpiarCampo4($prioridad);
	$descripcionreclamo=limpiarCampo4($descripcionreclamo);
	$codcliente=limpiarCampo4($codcliente);
	$codusuario=limpiarCampo4($codusuario);
	$tipobusqueda=limpiarCampo4($tipobusqueda);
	$codguia1=limpiarCampo4($codguia);

	If ((!$nombrecontacto)||(!$telefonocontacto)||(!$emailcontacto)||(!$codguia)||(!$tipoenvio)||(!$clienteenvioasegurado)||(!$tiporeclamoini)||(!$prioridad) ||(!$descripcionreclamo)    ){
			return ZoomWS_Error("Debe llenar todas los campos con la informacion requerida");
	}

	
	/*if(formatoTelefono($telefonocontacto)) {
			return ZoomWS_Error("El Formato del Telefono es Invalido. Ej:0414-1234567");
		return false;
	}*/

	/*if(!is_numeric($codguia)) {
			return ZoomWS_Error("En numero de envio debe ser numerico");
	}*/

	if (($tipoenvio=='D') && ($clienteenvioasegurado==1))
	{
		return ZoomWS_Error("Los Documentos no pueden tener Proteccion de Mercancia");
	}

	if (($montoasegurado) && (!is_numeric($montoasegurado)))  {
			return ZoomWS_Error("El Monto Asegurado (Bs) debe ser numerico");
	}

	if (($clienteenvioasegurado==1) && (!$montoasegurado))
	{
		return ZoomWS_Error("Si el envio tiene Proteccion de Mercancia debe ingresar el valor del Monto Asegurado");
	}

	if ($clienteenvioasegurado==1)
	{


		$query1="SELECT codcaso from calidad_casos_envios where codguia = '".$codguia."'";
		$result1 = pg_query($query1);	

		if(pg_num_rows($result1)>0) {
			return ZoomWS_Error("El envio ".$codguia." ya tiene asociado un reclamo identificado con el numero de caso # ".pg_result($result1,0,"codcaso").".  Puede escribanos al correo de reclamos@grupozoom.com o llamar por el 0800-SOS-ZOOM para que los operadores de Atencion al Cliente les suministre mayor informacion");
		}


		$asegurado='t';
		if($montoasegurado>500000){
			return ZoomWS_Error("El valor maximo que puede declarar al asegurar su envio es de Bs.F. 500.000.\n Debe ingresar una cantidad igual o menor a esta.");
		}
		if($montoasegurado<50){
			return ZoomWS_Error("El valor minimo que puede declarar al asegurar su envio es de Bs.F. 50.\n Debe ingresar una cantidad igual o mayor a esta y a la vez menor o igual a Bs.F. 500.000..");
		}
	}
	else
	{
		$montoasegurado='0';
		$asegurado='f';
	}


	IF ($tipobusqueda==1)
	{
		$where=" codguia='".$codguia1."'";
	
	}
	ELSE
	{
		$where=" referencia='".$codguia1."'";
	
	}



//Falta agregar guiaweb

//Verificar si la guia existe en GE o en canguro para poder realizar el reclamo
	$query="SELECT guia.codguia, guia.contactorem,guia.destinatario,guia.fecha,guia.referencia,guia.codoficinaori,guia.coddestinatario,guia.codoficinaope, ciudad.nombre as nombreciudad, guia.codtipoenv,guia.pesobru,guia.numeropie,guia.seguro,guia.descripcioncon,guia.codtipopag,  guia.codcliente,  guia.codoficinaori,  guia.valordec, cliente.nombre as nombrecliente, cliente.telefonoobl as telefonocliente, servicio.codservicio, servicio.codfamilia, guia.valordec as montoasegurado,guia.codoficinaori as oficinaopeori, guia.codestatus, guia.fechapro, estatus.codtipo
	FROM guia LEFT JOIN ciudad ON (guia.codciudaddes=ciudad.codciudad) LEFT JOIN  cliente on (guia.codcliente=cliente.codcliente) LEFT JOIN servicio USING (codservicio) 
	LEFT JOIN estatus ON (guia.codestatus=estatus.codestatus)
	WHERE ".$where;
	$result = pg_query($query);	

	if(pg_num_rows($result)==0) {

		$query="SELECT guiaweb.codguia, guiaweb.contactorem,guiaweb.destinatario,guiaweb.fecha,guiaweb.referencia,guiaweb.codoficinaori,guiaweb.coddestinatario,guiaweb.codoficinaope, ciudad.nombre as nombreciudad, guiaweb.codtipoenv,guiaweb.pesobru,guiaweb.numeropie,guiaweb.seguro,guiaweb.descripcioncon,guiaweb.codtipopag,  guiaweb.codcliente,  guiaweb.codoficinaori,  guiaweb.valordec, cliente.nombre as nombrecliente, cliente.telefonoobl as telefonocliente, servicio.codservicio, servicio.codfamilia, guiaweb.valordec as montoasegurado,guiaweb.codoficinaori as oficinaopeori, guiaweb.codestatus, guiaweb.fechapro, '1' as codtipo
		
		FROM guiaweb LEFT JOIN ciudad ON (guiaweb.codciudaddes=ciudad.codciudad) LEFT JOIN  cliente on (guiaweb.codcliente=cliente.codcliente) LEFT JOIN servicio USING (codservicio) WHERE ".$where;
		$result = pg_query($query);

		if(pg_num_rows($result)==0) {
			return ZoomWS_Error("El envio ".$codguia." no se encuentra registrado nuestros sistemas. Verifique, sino puede escribanos al correo de reclamos@grupozoom.com o debe llamar por el 0800-SOS-ZOOM para que el reclamo sea registrado por un operador de Atencion al Cliente");
		}
	}

	//SE encontraron varias guias, no se puede realizar el reclamo
	if(pg_num_rows($result)>1) {
		return ZoomWS_Error("No se puede realizar el reclamo ya que existen varios envios que contienen la referencia ".$codguia.".  Puede escribanos al correo de reclamos@grupozoom.com o llamar por el 0800-SOS-ZOOM para que los operadores de Atencion al Cliente les suministre mayor informacion");
	}

	//Nuevas validaciones en el sistema - 22/12/2014
	//	Un Cliente podr abrir un reclamo de un Envo ENTREGADO (status E) hasta 30 das despus de asignado el status
	//	Un Cliente podr abrir un reclamo de un Envo PENDIENTE  hasta 30 das despus de la fecha de creacin del Envo.
	//codestatus: 7  E  ENTREGADO AL DESTINO
	$estatusA=pg_result($result,0,"codestatus");
	$fechaproA=pg_result($result,0,"fechapro");
	$tipoestatusA=pg_result($result,0,"codtipo");


	$diastrans= dias_transcurridos(date('Y-m-01'),$fechaproA);
	//if ((($diastrans>'5')&& ($estatusA==7)) ||  (($diastrans>'30')&& ($tipoestatusA!=8)))
	//Modificado por Rosabin Toledo el 22/12/2014: se modifico la cantidad de dias permitidos despues de el estatus E, pas de 5 dias a 30 dias
	if ((($diastrans>'30')&& ($estatusA==7)) ||  (($diastrans>'30')&& ($tipoestatusA!=8)))
	{
			return ZoomWS_Error("Su reclamo no puede ser creado a traves de este sistema por haber superado los tiempos de vigencia estipulado por ZOOM. Por favor contactarnos a traves del 0800-SOS-ZOOM (0800-767-9666) o a traves del correo electronico reclamos@grupozoom.com");
	}
	//--



	$codguia=pg_result($result,0,"codguia");

//Verificamos si la guia ya tiene un caso asignado
	$query1="SELECT codcaso from calidad_casos_envios where codguia = '".$codguia."'";
	$result1 = pg_query($query1);	

	if(pg_num_rows($result1)>0) {
		return ZoomWS_Error("El envio ".$codguia." ya tiene asociado un reclamo identificado con el numero de caso # ".pg_result($result1,0,"codcaso").".  Puede escribanos al correo de reclamos@grupozoom.com o llamar por el 0800-SOS-ZOOM para que los operadores de Atencion al Cliente les suministre mayor informacion");
	}


// SECCION PARA CREAR UN NUEVO CASO, solo cuando esta definido el numero de guia
//	genericDB::execute("begin"); // comienzo de la transaccion para crear caso		//agregado el 11/12/2014----------------------------------

	$hayerror = false; // verifica si hay un error en la bd
	$caso = new genericDB("calidad_casos");

	$caso->set("remitente",pg_result($result,0,"contactorem"));
	$caso->set("nombrecontacto",$nombrecontacto);
	$caso->set("telefonocontacto",$telefonocontacto);
	$caso->set("emailcontacto",$emailcontacto);
	$caso->set("codusuariocalidad",'0');
	
	//$caso->set("codvia",'6'); 
	$caso->set("codvia",$codvia); 
	
	$caso->set("fecha_creacion","current_timestamp"); // fecha actual
	$caso->set("fecha_modificacion","current_timestamp"); // fecha actual
	$descripcionreclamo=htmlentities($descripcionreclamo);
	$caso->set("descripcion",$descripcionreclamo);
	$caso->set("codprioridad",$prioridad);
	$caso->set("recaudoslistos",'0');
	$caso->set("tiporeclamoini",$tiporeclamoini);
	$caso->set("fase_actual","A1");
	$caso->set("unidad_actual","ATC");
	$caso->set("clienteenvioasegurado",$asegurado);
	$caso->set("llamadadesde",'desconocido');
	//$idinfo = intval($_POST['idinfo']);
	$caso->set("idinfo",'0');
	$caso->set("codusuario",'999');
	//$caso->set("verificador",md5($_SESSION['_codusuario'].$codguia.$_POST['nombrecontacto'].rand(1,1000)));


	$verificador=md5($codguia.$nombrecontacto.rand(1,1000));
	$caso->set("verificador",$verificador);

	if(!$caso->Save()) $hayerror = true;

	// guardar informacion del envio
	if(!$hayerror) {
		$codcaso = $caso->getId();
		$tipo = "CASO";

		$infoenvio = new genericDB("calidad_casos_envios");
		$infoenvio->set("codcaso",$codcaso);
		$infoenvio->set("destinatario",pg_result($result,0,"destinatario"));
		$infoenvio->set("tiposervicio",pg_result($result,0,"codservicio"));
		$infoenvio->set("codguia",$codguia);

		$infoenvio->set("fechaenvio",pg_result($result,0,"fecha"));//$infoenvio->set("fechaenvio",fecha_pg(pg_result($result,0,"destinatario")));-->guiia.fecha
		//$REFERENCIA=stripslashes(pg_result($result,0,"referencia"));
		$infoenvio->set("referencia",pg_result($result,0,"referencia"));

		$infoenvio->set("oficinaori",pg_result($result,0,"codoficinaori"));
		$infoenvio->set("casillero",intval(pg_result($result,0,"coddestinatario")));
		$infoenvio->set("oficinaope",pg_result($result,0,"codoficinaope"));
		$infoenvio->set("ciudaddes",pg_result($result,0,"nombreciudad"));//nombre de la ciudad text
		$infoenvio->set("tipoenvio",pg_result($result,0,"codtipoenv"));
		$infoenvio->set("pesoinicial",pg_result($result,0,"pesobru"));
		$infoenvio->set("piezasinicial",pg_result($result,0,"numeropie"));
		
		$infoenvio->set("asegurado",(pg_result($result,0,"seguro")?pg_result($result,0,"seguro"):'f'));//$asegurado
		$DESCRIPCION=stripslashes(pg_result($result,0,"descripcioncon"));
		$infoenvio->set("descripcioncon",$DESCRIPCION);
		$infoenvio->set("montoreclamo",$montoasegurado);
		$infoenvio->set("oficinaopeori",pg_result($result,0,"oficinaopeori"));
		$infoenvio->set("codtipopag",pg_result($result,0,"codtipopag"));
		$infoenvio->set("codigocliente",intval(pg_result($result,0,"codcliente")));
		$infoenvio->set("nombrecliente",(pg_result($result,0,"nombrecliente"))?pg_result($result,0,"nombrecliente"):pg_result($result,0,"contactorem"));
		$infoenvio->set("codsucursalcliente",pg_result($result,0,"codoficinaori"));
		$infoenvio->set("telefonocliente",pg_result($result,0,"telefonocliente"));
		$infoenvio->set("montoasegurado",pg_result($result,0,"valordec"));
		$infoenvio->set("valordec",pg_result($result,0,"valordec"));

		if(!$infoenvio->Save()) $hayerror=true;


//agregado nuevo 11/11/2014W
		$fase = new genericDB("calidad_fases");
		$fasenueva = "A1";
		$fase->set("codcaso",$codcaso);
		$fase->set("codtipofase",$fasenueva);
		$fase->set("fecha_creacionfase","current_timestamp");
		$fase->set("fecha_cierrefase","null");
		$fase->set("unidadresponsable",'ATC');
		//$fase->set("ip",$_SERVER['REMOTE_ADDR']);
		$fase->set("codusuario",'999');
		//$fase->set("notificado",'f');
		$fase->set("descripcion","Caso creado a travs del sistema de Guia Electronica");
		//$fase->set("duracion","0");
		$fase->set("fecha_creacion","current_timestamp");
		//$fase->set("duracion_usuario","0");
		//$fase->set("fecha_asignacion","null");

		if(!$fase->Save()) $hayerror = true;	

// 		genericDB::execute2("commit"); 	

		//Historico para mostrarle al cliente en su consulta de casos realizados
		$infows = new genericDB("calidad_guias_ws");
		//$infows->set("codguiaws",$codcaso);
		$infows->set("codcaso",$codcaso);
		$infows->set("codguia",$codguia);
		$infows->set("tiporeclamoini",$tiporeclamoini);
		$infows->set("fechareclamo","current_timestamp"); // fecha actual
		$infows->set("codclientereal",intval(pg_result($result,0,"codcliente")));
		
		$codusurioweb=$codusuario; //Codigo del usuario que esta realizando el reclamo
		$infows->set("codusuarioweb",intval($codusurioweb));
		
		//$sistema=1; //Si el sistema es guia electronica
		$infows->set("sistema",$sistema);
		
		$codclientews=$codcliente;//Codigo del cliente que est realizando el reclamo
		$infows->set("codclientews",$codclientews);
		
		if(!$infows->Save()) $hayerror=true;
		
		Historial($codcaso,"ha creado el caso de la guia #".$codguia." con fase A1, tipo DM");



		if(!$hayerror) { // si no hay error se envia el correo al cliente
			if(esEmail($emailcontacto)) {

				include '/var/www/localhost/htdocs/mail/PHPMailer/class.phpmailer.php';

				//Se busca en base de datos la conexion para el correo
				$query="select * from conexionsmtp where codconexionsmtp=1";
				$result = pg_query($query);	

				$host=pg_result($result,0,"host");
				$puerto=pg_result($result,0,"puerto");
				$usuario=pg_result($result,0,"usuario");
				$clave=pg_result($result,0,"clave");

				//Create a new PHPMailer instance
				$mail = new PHPMailer();
				$mail->CharSet = "UTF-8";
				$mail->IsSMTP();
				$mail->SMTPAuth   = true;                  // enable SMTP authentication
				$mail->SMTPSecure = "tls";
				// Inicio de datos que deben tomarse de la base de datos 
				$mail->Host       = $host; // sets the SMTP server
				$mail->Port       = $puerto;//7825;                    // set the SMTP port for the ZOOM server
				$mail->Username   = $usuario;
				$mail->Password   = $clave;
				// Fin de datos que deben tomarse de la base de datos 
				$mail->Timeout       =   60;

				//Set an alternative reply-to address
				//Set who the message is to be sent from
				$mail->FromName = "ZOOM";
				$mail->From = $usuario."@grupozoom.com"; //EMAILSENDER; //"no-responder@grupozoom.com";
				$mail->Sender = $emailcontacto;

				//$mail->AddReplyTo('replyto@example.com','First Last');
				//$mail->AddReplyTo('no-responder@grupozoom.com', 'Zoom');
				//Set who the message is to be sent to
				//$to_mail1='rosabint@gmail.com';
				$to_mail1=$emailcontacto;
				//$to_mail1='rosabint@hotmail.com';

				$mail->AddAddress($to_mail1, 'Usuario');
				//Set the subject line
				//Read an HTML message body from an external file, convert referenced images to embedded, convert HTML into a basic plain-text alternative body
				$mail->Subject = "ZOOM: Reclamos - Apertura del Caso [#".$codcaso."]";
				//Read an HTML message body from an external file, convert referenced images to embedded, convert HTML into a basic plain-text alternative body
				//$msgHtml.= "Prueba de envios de correo desde DESARROLLO";	
				
				//abrir archivo 
				//$contenido = utf8_decode_seguro(file_get_contents(DIRCALIDAD."mailtemplates/notificacion_recepcion.html"));
				$contenido = utf8_decode_seguro(file_get_contents(MIDIR."include/mailtemplates/notificacion_recepcion.html"));
				$contenido = str_replace("{codcaso}",$codcaso,$contenido);
				$contenido = str_replace("{codguia}",$codguia,$contenido); //***** y Referencia XXXXXXX (incluir este ltimo campo si el envo lo tiene)
				$contenido = str_replace("{numguia}",$codguia,$contenido);
				$contenido = str_replace("{numerocaso}",$codcaso,$contenido);
				$contenido = str_replace("{urlrespuesta}",URLRESPUESTA,$contenido);
				$contenido = str_replace("{validacion}",$verificador,$contenido);
				$contenido = ''.str_replace("\n","<br>",$contenido).'';

				//SUSTITUIR EL ENLACE DEL TEXTO POR EL ENLACE
				ereg("\[(\enlace:|~|!)([0-9a-zA-Z:./-_#=&]{1,170})\]", $contenido, $result);
				if($result[1]=="enlace:") $contenido = str_replace($result[0],'<a href="'.$result[2].'" target="_blank">'.$result[2].'</a>',$contenido);
				//return $contenido;

				$msgHtml=$contenido;
				
				$mail->MsgHTML($msgHtml);

				$exito = $mail->Send();
				
				if($exito)
				{
					Historial($codcaso,"Se envi&oacute; el correo de notificaci&oacute;n al cliente");
				}
	
	


				/*include  "/var/www/localhost/htdocs/mail/class_smtp.php3";
				$sender_mail =EMAILSENDER;

				$subject = "Zoom: Apertura del caso [#".$codcaso."]";

				//abrir archivo 
				$contenido = utf8_decode_seguro(file_get_contents(DIRCALIDAD."mailtemplates/notificacion_recepcion.html"));
				$contenido = str_replace("{codcaso}",$codcaso,$contenido);
				$contenido = str_replace("{codguia}",$codguia,$contenido); //***** y Referencia XXXXXXX (incluir este ltimo campo si el envo lo tiene)
				$contenido = str_replace("{numguia}",$codguia,$contenido);
				$contenido = str_replace("{numerocaso}",$codcaso,$contenido);
				$contenido = str_replace("{urlrespuesta}",URLRESPUESTA,$contenido);
				$contenido = str_replace("{validacion}",$verificador,$contenido);
				$contenido = ''.str_replace("\n","<br>",$contenido).'';

				//SUSTITUIR EL ENLACE DEL TEXTO POR EL ENLACE
				ereg("\[(\enlace:|~|!)([0-9a-zA-Z:./-_#=&]{1,170})\]", $contenido, $result);
				if($result[1]=="enlace:") $contenido = str_replace($result[0],'<a href="'.$result[2].'" target="_blank">'.$result[2].'</a>',$contenido);
				//return $contenido;

				$mensaje=$contenido;

				if($mensaje<>'') //Enva correo si tiene el mensaje, sino no debe enviar nada.
				{
					//////////////////////////////////Inicio de proceso de envio del email//////////////////////////////////
					$sender_name = "Zoom";
					$to_name = "Zoom";

					//$to_mail[0]='marianeto39@gmail.com';
					//$to_mail[0]='mneto@grupozoom.com';
					$to_mail[0]=$emailcontacto;

					$text_body = $mensaje;
					$att[0]["source"] = "";
					$att[0]["name"] = "";
					$att[0]["size"] = "2MB";
					include "/var/www/localhost/htdocs/mail/mail.php3";
					//////////////////////////////////////Fin de proceso de envio del email//////////////////////////////////
					
					//Verifica si el correo fue enviado   -------------------: 1 = Enviado y 0 = No Enviado
					//$err = 1; //No enviado
					//$err = 0; //Enviado
					
					if ($err==0)
					{
						Historial($codcaso,"Se envi&oacute; el correo de notificaci&oacute;n al cliente");
					}
				}*/
			}
			else
			{
				return ZoomWS_Error("Error al verificar el formato del correo. Revise los datos e intente de nuevo.");
			}
		}
	} else {
		$hayerror = true;
	}

	if($hayerror) {
		//genericDB::execute("rollback"); // se hace un rollback en la base de datos --------------------------------------------11/12/2014




		return ZoomWS_Error("Error al Guardar. Revise los datos e intente de nuevo.");
	
	
	}
	else
	{
		$response = array();
		$response['resultado']="Se agrego con exito el reclamo numero (".$codcaso.") para en envio ".$codguia.". Usted recibira un correo electronico a la direccion: ".$emailcontacto.". En caso de dudas puede llamar al 0800-SOS-ZOOM para que los operadores de Atencion al Cliente les suministre mayor informacion";
		//$response['codcaso'] = $codcaso;
		
		
		$response['codcaso']=$codcaso;
		
		
		return ZoomWS_Response($response);









	}
}


//********************************************************************************************************************************
//* FUNCIONES GENERICAS - RECLAMOS
//********************************************************************************************************************************

//Se usa en el sistema de reclamos para guardar el historial de los casos registrados
function Historial($codcaso, $mensaje) {
	$codcaso = intval($codcaso);
	$codusuario = intval(999);
	if($codcaso ==0) return false;
	$query = "INSERT INTO calidad_historial (codcaso,codusuario,fecha_creacion,accion,ip) VALUES ('".$codcaso."','".$codusuario."',current_timestamp,'".pg_escape_string($mensaje)."','".$_SERVER['REMOTE_ADDR']."')";
	return pg_query($query);
}
	

//Verificamos el formato de la informacion del correo
function esEmail($email) {	
 return preg_match('|^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]{2,})+$|i', $email);
}


//Formato del contenido del correo enviado a los usuarios
function CreateHtml($contenido) {
	$contenido = ''.str_replace("\n","<br>",$contenido).'';
	return ReemPlazarTags($contenido);
}


function ReemplazarTags($contenido) {
	ereg("\[(\enlace:|~|!)([0-9a-zA-Z:./-_#=&]{1,170})\]", $contenido, $result);
	if($result[1]=="enlace:") $contenido = str_replace($result[0],'<a href="'.$result[2].'" target="_blank">'.$result[2].'</a>',$contenido);
	return $contenido;
}	


/*function formatoTelefono($contenido) {
	//if (!(ereg("^[0]{1}[24]{1}[1-9]{2}-{1}[0-9]{7}",$contenido))){
	//if(!ereg("^([(][0-9][)])([0-9]{2,5}[:blank:])([0-9]{3,10})$", $telefon))"+49 461 123456
	//if(!preg_match('/^\+[0-9]{1,3} [0-9]{2,5} [0-9]{3,20}$/', $telefon))
	
		
	if (!(ereg("^[0]{1}[24]{1}[1-9]{2}-{1}[0-9]{7}",$contenido))){
		return true;
	}
	else
		return false;



	//ereg("\[(\enlace:|~|!)([0-9a-zA-Z:./-_#=&]{1,170})\]", $contenido, $result);
	//if($result[1]=="enlace:") $contenido = str_replace($result[0],'<a href="'.$result[2].'" target="_blank">'.$result[2].'</a>',$contenido);
	//return $contenido;
}	*/





define("UTF_8", 1);
define("ASCII", 2);
define("ISO_8859_1", 3);
function codificacion($texto)
{
	$c = 0;
	$ascii = true;
	for ($i = 0;$i<strlen($texto);$i++) {
		 $byte = ord($texto[$i]);
		 if ($c>0) {
			 if (($byte>>6) != 0x2) {
				 return ISO_8859_1;
			 } else {
				 $c--;
			 }
		 } elseif ($byte&0x80) {
			 $ascii = false;
			 if (($byte>>5) == 0x6) {
				 $c = 1;
			 } elseif (($byte>>4) == 0xE) {
				 $c = 2;
			 } elseif (($byte>>3) == 0x14) {
				 $c = 3;
			 } else {
				 return ISO_8859_1;
			 }
		 }
	}
	return ($ascii) ? ASCII : UTF_8;
}

function utf8_decode_seguro($texto)
{
	 return (codificacion($texto)==ISO_8859_1) ? $texto : utf8_decode($texto);
} 
?>