<?
function getMunicipios($codciudad,$remitente = "f"){
	
	$codciudad=limpiarCampo2($codciudad);
	$codciudad = intval($codciudad);

	
	if($codciudad==0 || $codciudad=='') {
		return ZoomWS_Error("Error. Codigo de Ciudad Invalido");
	}
	
	$cache = new cache();
	$cache->setTime(3600); // tiempo de cache en segundos  
	$hash = "getMunicipios.".$codciudad.".".$remitente;
	
	$contenido = $cache->getCache($hash);
	
	if(!empty($contenido)) {
		return ZoomWS_Response(unserialize($contenido));	
	}
	
	$respuesta = array();
	if($remitente=="t"){ //BUSQUEDA DEL MUNICIPIO PARA CIUDADES DEL REMITENTE -- CIUDADES IPOSTEL
		/*$query = "SELECT list_municipios.listm_codigo AS codigo_municipio, list_municipios.listm_nombre AS nombre_municipio,list_ciudad.listc_codigo as codp_ciudad, list_ciudad.listc_nombre as ciudad from list_municipios, list_ciudad, list_ciudad_maestro where list_ciudad.listc_relacion2::text=list_ciudad_maestro.listcm_id::text and list_ciudad.listc_relacion::text=list_municipios.listm_codigo::text and list_ciudad_maestro.listcm_id=".$codciudad;*/
		$query = "SELECT list_municipios.listm_codigo AS codigo_municipio, list_municipios.listm_nombre AS nombre_municipio FROM list_municipios,list_ciudad, list_ciudad_maestro WHERE list_ciudad.listc_relacion2::text=list_ciudad_maestro.listcm_id::text AND list_ciudad.listc_relacion::text=list_municipios.listm_codigo::text AND list_ciudad_maestro.listcm_id=".$codciudad." ORDER BY list_municipios.listm_nombre";
		$r = pg_query($query);
		$num_rows=pg_num_rows($r);

	}else{ //BUSQUEDA DEL MUNICIPIO PARA CIUDADES DEL DESTINATARIO -- CIUDADES ZOOM
		//PRIMERA BUSQUEDA DEL MUNICIPIO
		$query="SELECT list_municipios.listm_codigo AS codigo_municipio, list_municipios.listm_nombre AS nombre_municipio FROM list_municipios,list_ciudad WHERE list_ciudad.listc_relacion=CAST(list_municipios.listm_codigo AS integer) AND list_ciudad.codciudadzoom=".$codciudad." ORDER BY list_municipios.listm_nombre";
		$r=0;
		$num_rows=0;
		$r = pg_query($query);
		$num_rows=pg_num_rows($r);

		if($num_rows==0){ //SI EN LA CONSULTA ANTERIOR LA CIUDAD ZOOM NO TIENE MUNICIPIO ASOCIADO, SE LISTAN LOS MUNICIPIOS DEL ESTADO.
			$codestado=getEstadoIpostel($codciudad); //BUSQUEDA DEL ESTADO DE LA CIUDAD

			//BUSQUEDA DE LOS MUNIPIOS DEL ESTADO DE LA CIUDAD CONSULTADA
			$query="SELECT DISTINCT list_municipios.listm_codigo AS codigo_municipio, list_municipios.listm_nombre AS nombre_municipio FROM list_municipios,list_ciudad_maestro,list_ciudad WHERE list_ciudad_maestro.listcm_id=list_ciudad.listc_relacion2 AND list_ciudad.listc_relacion=CAST(list_municipios.listm_codigo AS INTEGER) AND list_ciudad_maestro.listcm_idestado=".$codestado." ORDER BY list_municipios.listm_nombre";
			$r = pg_query($query);
			$num_rows=pg_num_rows($r);
			
		}
	}

	if($r && pg_num_rows($r)>0) {
		while($row = pg_fetch_assoc($r)) {
			$respuesta[] = $row;
		}	
	}

	if(count($respuesta)==0) {
		return ZoomWS_Error("NO HAY MUNICIPIOS PARA MOSTRAR.");
		//return ZoomWS_Error($query);
	}else{
		$cache->finish(serialize($respuesta),false);
		return ZoomWS_Response($respuesta);
		//return ZoomWS_Response($query);
	}
}

function getParroquias($codciudad,$codmunicipio,$remitente = "f"){
	
	$codciudad=limpiarCampo2($codciudad);
	$codmunicipio=limpiarCampo2($codmunicipio);
	$codciudad = intval($codciudad);
	$codmunicipio = intval($codmunicipio);
	
	if($codciudad==0 || $codciudad=='') {
		return ZoomWS_Error("Error. Codigo de Ciudad Invalido.");
	}

	if($codmunicipio==0 || $codmunicipio=='') {
		return ZoomWS_Error("Error. Codigo de Municipio Invalido.");
	}
	
	$cache = new cache();
	$cache->setTime(3600); // tiempo de cache en segundos  
	$hash = "getParroquias.".$codciudad.".".$codmunicipio.".".$remitente;
	
	$contenido = $cache->getCache($hash);
	
	if(!empty($contenido)) {
		return ZoomWS_Response(unserialize($contenido));	
	}
	
	$respuesta = array();
	if($remitente=="t"){ //BUSQUEDA DE LA PARROQUIA PARA CIUDADES DEL REMITENTE -- CIUDADES IPOSTEL
		$query="SELECT list_parroquia.listprr_codigo AS codigo_parroquia, list_parroquia.listprr_nombre AS nombre_parroquia,codigo_postal.codp_codigo AS codigo_postal FROM  list_parroquia,list_ciudad,codigo_postal WHERE CAST(list_ciudad.listc_codigo AS INTEGER)=CAST(list_parroquia.listprr_relacion AS INTEGER) AND CAST(list_ciudad.listc_codigo AS INTEGER)=CAST(codigo_postal.codp_ciudad AS INTEGER) AND CAST(codigo_postal.codp_parroquia AS INTEGER)=CAST(list_parroquia.listprr_codigo AS INTEGER) AND list_ciudad.listc_relacion2=".$codciudad." AND list_ciudad.listc_relacion=".$codmunicipio." ORDER BY list_parroquia.listprr_nombre";
		$r = pg_query($query);
		$num_rows=pg_num_rows($r);

	}else{ //BUSQUEDA DE LA PARROQUIA PARA CIUDADES DEL DESTINATARIO -- CIUDADES ZOOM
		$query="SELECT list_parroquia.listprr_codigo AS codigo_parroquia, list_parroquia.listprr_nombre AS nombre_parroquia,codigo_postal.codp_codigo AS codigo_postal FROM list_parroquia,list_ciudad,codigo_postal WHERE CAST(list_ciudad.listc_codigo AS INTEGER)=CAST(list_parroquia.listprr_relacion AS INTEGER) AND CAST(list_ciudad.listc_codigo AS INTEGER)=CAST(codigo_postal.codp_ciudad AS INTEGER) AND CAST(codigo_postal.codp_parroquia AS INTEGER)=CAST(list_parroquia.listprr_codigo AS INTEGER) AND list_ciudad.codciudadzoom=".$codciudad." AND list_ciudad.listc_relacion=".$codmunicipio."  ORDER BY list_parroquia.listprr_nombre";
		
		$r = pg_query($query);
		$num_rows=pg_num_rows($r);

		if($num_rows==0){ //SI EN LA CONSULTA ANTERIOR LA CIUDAD ZOOM NO TIENE PARROQUIA ASOCIADO, SE LISTAN LOS PARROQUIA DEL ESTADO Y MUNICIPIO.
			$codestado=getEstadoIpostel($codciudad); //BUSQUEDA DEL ESTADO DE LA CIUDAD
			
			//BUSQUEDA DE LAS PARROQUIAS DEL ESTADO Y MUNICIPIO DE LA CIUDAD CONSULTADA
			$query="SELECT DISTINCT list_parroquia.listprr_codigo AS codigo_parroquia, list_parroquia.listprr_nombre AS nombre_parroquia,codigo_postal.codp_codigo AS codigo_postal FROM list_parroquia,list_ciudad_maestro,list_ciudad,list_municipios,codigo_postal WHERE list_ciudad_maestro.listcm_id=list_ciudad.listc_relacion2 AND CAST(list_ciudad.listc_codigo AS INTEGER)=CAST (list_parroquia.listprr_relacion AS INTEGER) AND CAST(codigo_postal.codp_ciudad AS INTEGER)=CAST(list_parroquia.listprr_relacion AS INTEGER) AND CAST(codigo_postal.codp_parroquia AS INTEGER)=CAST(list_parroquia.listprr_codigo AS INTEGER) AND list_ciudad.listc_relacion=".$codmunicipio." AND list_ciudad_maestro.listcm_idestado=".$codestado." ORDER BY list_parroquia.listprr_nombre";

			$r = pg_query($query);
			$num_rows=pg_num_rows($r);
			
		}
	}

	if($r && pg_num_rows($r)>0) {
		while($row = pg_fetch_assoc($r)) {
			$respuesta[] = $row;
		}	
	}

	if(count($respuesta)==0) {
		return ZoomWS_Error("NO HAY PARROQUIAS PARA MOSTRAR.");
		//return ZoomWS_Error($query);
	}else{
		$cache->finish(serialize($respuesta),false);
		return ZoomWS_Response($respuesta);
		//return ZoomWS_Response($query);
	}
}



























/*
function getParroquiaIpostel($codciudad){
	
	$codciudad=limpiarCampo2($codciudad);
	//$codciudad = intval($codciudad);

	if($codciudad==0 || $codciudad=='') {
		return ZoomWS_Error("Error. Codigo de Ciudad Invalido");
	}

	$cache = new cache();
	$cache->setTime(3600); // tiempo de cache en segundos  
	$hash = "getParroquiaIpostel.".$codciudad;
	
	$contenido = $cache->getCache($hash);
	
	if(!empty($contenido)) {
		return ZoomWS_Response(unserialize($contenido));	
	}
	
	$query0 = "SELECT listc_codigo FROM list_ciudad WHERE listc_relacion2='".$codciudad."'";
	$result0 = pg_query($query0);
	if($result0 && pg_num_rows($result0)>0) {
		$codciudad1 = pg_result($result0,0,"listc_codigo");
	}

	$query = "SELECT list_parroquia.listprr_codigo AS codp_parroquia, list_parroquia.listprr_nombre AS parroquia FROM list_parroquia WHERE CAST(listprr_codigo AS INTEGER) IN (SELECT CAST(list_parroquia.listprr_codigo AS INTEGER) AS listprr_codigo FROM list_parroquia WHERE list_parroquia.listprr_relacion=".$codciudad1.") ORDER BY parroquia";
	
	$respuesta = array();
	$result = pg_query($query);
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$respuesta[] = $row;
		}		
	}
	if(count($respuesta)==0) {
		return ZoomWS_Error("NO HAY PARROQUIA DE IPOSTEL PARA MOSTRAR");
		//return ZoomWS_Error($query);
	}else{
		$cache->finish(serialize($respuesta),false);
		return ZoomWS_Response($respuesta);
		//return ZoomWS_Response($query);
	}
}*/
?>