<?php

/**
* Clase que implementa los Servicios Web asociados a la recolectas
*
* @author Ingeniero Luis Blanco
* @module Recolectas
* @modulegroup Servicios
* @package SERVICIOS
*/

include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'mainclass'.DIRECTORY_SEPARATOR.'class.mainclass.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'mainclass'.DIRECTORY_SEPARATOR.'class.entitieresponse.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'mainclass'.DIRECTORY_SEPARATOR.'class.entitylistresponse.manager.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'business'.DIRECTORY_SEPARATOR.'class.recolecta.manager.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'business'.DIRECTORY_SEPARATOR.'class.proveedor.manager.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'business'.DIRECTORY_SEPARATOR.'class.casillero.manager.php');

    
    function encodeToUtf8($string) {
        return mb_convert_encoding($string, "ISO-8859-1", mb_detect_encoding($string, "UTF-8, UTF-7, ISO-8859-1, ISO-8859-15", true));
    }


    /**
     * addRecolecta()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codRecolecta
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $codProveedor
     * @param mixed $fechaRecolecta
     * @param mixed $horaDesde
     * @param mixed $contenido
     * @param mixed $observacion
     * @param mixed $fechaSolicitud
     * @param mixed $horaSolicitud
     * @param mixed $inactivo
     * @param mixed $codTipoVehiculo
     * @param mixed $horaHasta
     * @param mixed $codTipoEnvio
     * @param mixed $codCasillero
     * @param mixed $codTipoMod
     * @param mixed $fechaMod
     * @param mixed $codServicio
     * @return
     */
    function addRecolecta(
        $codUsuario, 
        $tokenAuthorization, 
        $codRecolecta,
        $codClienteMaster, 
        $codCliente, 
        $codProveedor, 
        $fechaRecolecta, 
        $horaDesde,
        $contenido, 
        $observacion, 
        $fechaSolicitud, 
        $horaSolicitud, 
        $inactivo, 
        $codTipoVehiculo, 
        $horaHasta,
        $codTipoEnvio, 
        $codCasillero, 
        $codTipoMod, 
        $fechaMod, 
        $codServicio){
        
    	$Recolecta = new Recolecta();
        $RecolectaBusiness = new RecolectaBusiness();
                       
        //Asignacion de variables en el objeto Recolecta
        $Recolecta->codRecolecta = $RecolectaBusiness->getDecodeCampo($codRecolecta);
        $Recolecta->codClienteMaster = $RecolectaBusiness->getDecodeCampo($codClienteMaster);
        $Recolecta->codCliente = $RecolectaBusiness->getDecodeCampo($codCliente);
        $Recolecta->codProveedor = $RecolectaBusiness->getDecodeCampo($codProveedor);
        $Recolecta->fechaRecolecta = $RecolectaBusiness->getDecodeCampo($fechaRecolecta);
        $Recolecta->horaDesde = $RecolectaBusiness->getDecodeCampo($horaDesde);        
        $Recolecta->codUsuario = $RecolectaBusiness->getDecodeCampo($codUsuario);            
        $Recolecta->contenido = $RecolectaBusiness->getDecodeCampo($contenido);
       
        
        $Recolecta->observacion = $RecolectaBusiness->getDecodeCampo($observacion);
        $Recolecta->fechaSolicitud = $RecolectaBusiness->getDecodeCampo($fechaSolicitud);
        $Recolecta->horaSolicitud = $RecolectaBusiness->getDecodeCampo($horaSolicitud);
        $Recolecta->inactivo = $RecolectaBusiness->getDecodeCampo($inactivo);   
        $Recolecta->codTipoVehiculo = $RecolectaBusiness->getDecodeCampo($codTipoVehiculo);
        
        $Recolecta->codServicio = $RecolectaBusiness->getDecodeCampo($codServicio);    
        $Recolecta->horaHasta = $RecolectaBusiness->getDecodeCampo($horaHasta);
        $Recolecta->codTipoEnvio = $RecolectaBusiness->getDecodeCampo($codTipoEnvio);
        $Recolecta->codCasillero = $RecolectaBusiness->getDecodeCampo($codCasillero);
        $Recolecta->codTipoMod = $RecolectaBusiness->getDecodeCampo($codTipoMod);
        $Recolecta->fechaMod = $RecolectaBusiness->getDecodeCampo($fechaMod);
        
        $EntitieResponse = new EntitieResponse();           
                
        $EntitieResponse = $RecolectaBusiness->addRecolecta(
            $Recolecta, 
            $codUsuario, 
            $tokenAuthorization);  
        
    	return ZoomWS_Response($EntitieResponse);	
    }

    /**
     * editRecolecta()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codRecolecta
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $codProveedor
     * @param mixed $fechaRecolecta
     * @param mixed $horaDesde
     * @param mixed $contenido
     * @param mixed $observacion
     * @param mixed $fechaSolicitud
     * @param mixed $horaSolicitud
     * @param mixed $inactivo
     * @param mixed $codTipoVehiculo
     * @param mixed $horaHasta
     * @param mixed $codTipoEnvio
     * @param mixed $codCasillero
     * @param mixed $codTipoMod
     * @param mixed $fechaMod
     * @param mixed $codServicio
     * @return
     */
    function editRecolecta(
        $codUsuario, 
        $tokenAuthorization, 
        $codRecolecta, 
        $codClienteMaster, 
        $codCliente, 
        $codProveedor, 
        $fechaRecolecta, 
        $horaDesde,
        $contenido, 
        $observacion, 
        $fechaSolicitud, 
        $horaSolicitud, 
        $inactivo, 
        $codTipoVehiculo, 
        $horaHasta,
        $codTipoEnvio, 
        $codCasillero, 
        $codTipoMod, 
        $fechaMod, 
        $codServicio){
	
        $RecolectaBusiness = new RecolectaBusiness();
        
    	//Asignacion de variables en el objeto Recolecta
        $Recolecta = new Recolecta();
        //Asignacion de variables en el objeto Recolecta
        $Recolecta->codRecolecta = $RecolectaBusiness->getDecodeCampo($codRecolecta);
        $Recolecta->codClienteMaster = $RecolectaBusiness->getDecodeCampo($codClienteMaster);
        $Recolecta->codCliente = $RecolectaBusiness->getDecodeCampo($codCliente);
        $Recolecta->codProveedor = $RecolectaBusiness->getDecodeCampo($codProveedor);
        $Recolecta->fechaRecolecta = $RecolectaBusiness->getDecodeCampo($fechaRecolecta);
        $Recolecta->horaDesde = $RecolectaBusiness->getDecodeCampo($horaDesde);
        
        $Recolecta->codUsuario = $RecolectaBusiness->getDecodeCampo($codUsuario);
            
        $Recolecta->contenido = $RecolectaBusiness->getDecodeCampo($contenido);
        $Recolecta->observacion = $RecolectaBusiness->getDecodeCampo($observacion);
        $Recolecta->fechaSolicitud = $RecolectaBusiness->getDecodeCampo($fechaSolicitud);
        $Recolecta->horaSolicitud = $RecolectaBusiness->getDecodeCampo($horaSolicitud);
        $Recolecta->inactivo = $RecolectaBusiness->getDecodeCampo($inactivo);   
        $Recolecta->codTipoVehiculo = $RecolectaBusiness->getDecodeCampo($codTipoVehiculo);
        
        $Recolecta->codServicio = $RecolectaBusiness->getDecodeCampo($codServicio);    
        $Recolecta->horaHasta = $RecolectaBusiness->getDecodeCampo($horaHasta);   
        $Recolecta->codTipoEnvio = $RecolectaBusiness->getDecodeCampo($codTipoEnvio);
        $Recolecta->codCasillero = $RecolectaBusiness->getDecodeCampo($codCasillero);
        $Recolecta->codTipoMod = $RecolectaBusiness->getDecodeCampo($codTipoMod);
        $Recolecta->fechaMod = $RecolectaBusiness->getDecodeCampo($fechaMod);
        
        $EntitieResponse = new EntitieResponse();
        
        $EntitieResponse = $RecolectaBusiness->editRecolecta(
            $Recolecta, 
            $codUsuario, 
            $tokenAuthorization);
    
    	return ZoomWS_Response($EntitieResponse);	
    }

    /**
     * cancelRecolecta()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codRecolecta
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $codProveedor
     * @param mixed $fechaRecolecta
     * @param mixed $contenido
     * @param mixed $observacion
     * @param mixed $fechaSolicitud
     * @param mixed $codTipoMod
     * @param mixed $fechaMod
     * @return
     */
    function cancelRecolecta(
        $codUsuario, 
        $tokenAuthorization, 
        $codRecolecta, 
        $codClienteMaster, 
        $codCliente, 
        $codProveedor,
        $fechaRecolecta, 
        $contenido, 
        $observacion, 
        $fechaSolicitud, 
        $codTipoMod, 
        $fechaMod){
		   
        $RecolectaBusiness = new RecolectaBusiness();
        
        //Asignacion de variables en el objeto Recolecta
        $Recolecta = new Recolecta();
        //Asignacion de variables en el objeto Recolecta
        $Recolecta->codRecolecta = $RecolectaBusiness->getDecodeCampo($codRecolecta);
        $Recolecta->codClienteMaster = $RecolectaBusiness->getDecodeCampo($codClienteMaster);
        $Recolecta->codCliente = $RecolectaBusiness->getDecodeCampo($codCliente);
        $Recolecta->codProveedor = $RecolectaBusiness->getDecodeCampo($codProveedor);
        $Recolecta->fechaRecolecta = $RecolectaBusiness->getDecodeCampo($fechaRecolecta);
            
        $Recolecta->codUsuario = $RecolectaBusiness->getDecodeCampo($codUsuario);
            
        $Recolecta->contenido = $RecolectaBusiness->getDecodeCampo($contenido);
        $Recolecta->observacion = $RecolectaBusiness->getDecodeCampo($observacion);
        $Recolecta->fechaSolicitud = $RecolectaBusiness->getDecodeCampo($fechaSolicitud);           
        
        $Recolecta->codTipoMod = $RecolectaBusiness->getDecodeCampo($codTipoMod);
        $Recolecta->fechaMod = $RecolectaBusiness->getDecodeCampo($fechaMod);
        
        $EntitieResponse = new EntitieResponse();
        
        
        $EntitieResponse = $RecolectaBusiness->cancelRecolecta(
            $Recolecta, 
            $codUsuario, 
            $tokenAuthorization);
    
    	return ZoomWS_Response($EntitieResponse);	
    }


    /**
     * getRecolecta()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codRecolecta
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getRecolecta(
        $codUsuario, 
        $tokenAuthorization, 
        $codRecolecta, 
        $codClienteMaster, 
        $codCliente){
	     
        $EntitieResponse = new EntitieResponse(); 
        $RecolectaBusinessClass = new RecolectaBusiness();    
        $EntitieResponse = $RecolectaBusinessClass->getRecolecta(
            $codRecolecta, 
            $codClienteMaster, 
            $codCliente, 
            $codUsuario, 
            $tokenAuthorization);
    	
        
    	//return ZoomWS_Response($EntitieResponse);		
        return ZoomWS_Response($EntitieResponse);
    }

    /**
     * getRecolectas()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $codRecolecta
     * @param mixed $fechaDesdeSolicitud
     * @param mixed $fechaHastaSolicitud
     * @param mixed $fechaDesdeRecolecta 
     * @param mixed $fechaHastaRecolecta
     * @param mixed $estatus
     * @param mixed $codTipoEnvio
     * @param mixed $cantidadRegistros
     * @param mixed $orderBy
     * @param mixed $parentsOptionView 
     * @return
     */
    function getRecolectas(
        $codUsuario, 
        $tokenAuthorization, 
        $codClienteMaster, 
        $codCliente, 
        $codRecolecta, 
        $fechaDesdeSolicitud, 
        $fechaHastaSolicitud, 
        $fechaDesdeRecolecta, 
        $fechaHastaRecolecta, 
        $estatus, 
        $codTipoEnvio, 
        $cantidadRegistros, 
        $orderBy,
        $parentsOptionView){
	
        $RecolectaList = new EntitieListResponse();
        $RecolectaBusinessClass = new RecolectaBusiness();
        $RecolectaList = $RecolectaBusinessClass->getRecolectas(
        $codClienteMaster, 
        $codCliente, 
        $codUsuario, 
        $tokenAuthorization, 
        $codRecolecta, 
        $RecolectaBusinessClass->getDateInFormatByReport($fechaDesdeSolicitud), 
        $RecolectaBusinessClass->getDateInFormatByReport($fechaHastaSolicitud), 
        $RecolectaBusinessClass->getDateInFormatByReport($fechaDesdeRecolecta), 
        $RecolectaBusinessClass->getDateInFormatByReport($fechaHastaRecolecta), 
        $estatus, 
        $codTipoEnvio, 
        $cantidadRegistros, 
        $orderBy,
        $parentsOptionView);
        
    	return ZoomWS_Response($RecolectaList);	
    }
    
    
    
    /**
     * getRecolectasByReport()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $codRecolecta
     * @param mixed $fechaDesdeSolicitud
     * @param mixed $fechaHastaSolicitud
     * @param mixed $fechaDesdeRecolecta 
     * @param mixed $fechaHastaRecolecta
     * @param mixed $estatus
     * @param mixed $codTipoEnvio
     * @param mixed $cantidadRegistros
     * @param mixed $orderBy
     * @param mixed $parentsOptionView 
     * @return
     */
    function getRecolectasByReport(
        $codUsuario, 
        $tokenAuthorization, 
        $codClienteMaster, 
        $codCliente, 
        $codRecolecta, 
        $fechaDesdeSolicitud, 
        $fechaHastaSolicitud, 
        $fechaDesdeRecolecta, 
        $fechaHastaRecolecta, 
        $estatus, 
        $codTipoEnvio, 
        $cantidadRegistros, 
        $orderBy,
        $parentsOptionView){
        
        $RecolectaList = new EntitieListResponse();
        $RecolectaBusinessClass = new RecolectaBusiness();
        $RecolectaList = $RecolectaBusinessClass->getRecolectasByReport(
            $codUsuario, 
            $tokenAuthorization, 
            $codClienteMaster, 
            $codCliente, 
            $codRecolecta, 
            $RecolectaBusinessClass->getDateInFormatByReport($fechaDesdeSolicitud), 
            $RecolectaBusinessClass->getDateInFormatByReport($fechaHastaSolicitud), 
            $RecolectaBusinessClass->getDateInFormatByReport($fechaDesdeRecolecta), 
            $RecolectaBusinessClass->getDateInFormatByReport($fechaHastaRecolecta), 
            $estatus, 
            $codTipoEnvio, 
            $cantidadRegistros, 
            $orderBy,
            $parentsOptionView);
    	
    	return ZoomWS_Response($RecolectaList);	
    }
    
     /**
     * addProveedor()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $nombre
     * @param mixed $direccion
     * @param mixed $telefono
     * @param mixed $fax
     * @param mixed $estatus
     * @param mixed $codCiudad
     * @param mixed $codRuta
     * @param mixed $contacto
     * @param mixed $urbanizacion
     * @return
     */
    function addProveedor(
        $codUsuario, 
        $tokenAuthorization, 
        $codClienteMaster, 
        $codCliente, 
        $nombre, 
        $direccion, 
        $telefono,
        $fax, 
        $estatus, 
        $codCiudad, 
        $codRuta, 
        $contacto, 
        $urbanizacion, 
        $telefonoCelular){
	    
        $ProveedorBusiness = new ProveedorBusiness(); 
        
        //Asignacion de variables en el objeto Proveedor
        $Proveedor = new Proveedor();
        
        $ProveedorBusiness->register_business_log("Direccion antes de codificar");
        $ProveedorBusiness->register_business_log($direccion);
        
        $ProveedorBusiness->register_business_log("Direccion despues de funcion  limpiarCampo2");
        $ProveedorBusiness->register_business_log($ProveedorBusiness->limpiarCampo2($direccion));
                
        $Proveedor->codClienteMaster = $ProveedorBusiness->getDecodeCampo($codClienteMaster);
        $Proveedor->codCliente = $ProveedorBusiness->getDecodeCampo($codCliente);
        $Proveedor->nombre = $ProveedorBusiness->getDecodeCampo($nombre);
        $Proveedor->direccion = $ProveedorBusiness->getDecodeCampo($direccion);
                
        $Proveedor->telefono = $ProveedorBusiness->getDecodeCampo($telefono);
        $Proveedor->fax = $ProveedorBusiness->getDecodeCampo($fax);
        $Proveedor->inactivo = $ProveedorBusiness->getDecodeCampo($estatus);
        $Proveedor->codCiudad = $ProveedorBusiness->getDecodeCampo($codCiudad);
        $Proveedor->codRuta = $ProveedorBusiness->getDecodeCampo($codRuta);
        $Proveedor->contacto = $ProveedorBusiness->getDecodeCampo($contacto);
        $Proveedor->urbanizacion = $ProveedorBusiness->getDecodeCampo($urbanizacion);
        $Proveedor->telefonoCelular = $ProveedorBusiness->getDecodeCampo($telefonoCelular);
        
       	$EntitieResponse = new EntitieResponse();     
        
        $ProveedorBusiness->register_business_log("Direccion despues de codificar");
        $ProveedorBusiness->register_business_log($Proveedor->direccion);
           
        $EntitieResponse = $ProveedorBusiness->addProveedor(
            $Proveedor, 
            $codUsuario, 
            $tokenAuthorization);           
    
    	return ZoomWS_Response($EntitieResponse);	
    }

    /**
     * editProveedor()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codProveedor
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $nombre
     * @param mixed $direccion
     * @param mixed $telefono
     * @param mixed $fax
     * @param mixed $estatus
     * @param mixed $codCiudad
     * @param mixed $codRuta
     * @param mixed $contacto
     * @param mixed $urbanizacion
     * @return
     */
    function editProveedor(
        $codUsuario, 
        $tokenAuthorization, 
        $codProveedor, 
        $codClienteMaster, 
        $codCliente, 
        $nombre, 
        $direccion, 
        $telefono,
        $fax, 
        $estatus, 
        $codCiudad, 
        $codRuta, 
        $contacto, 
        $urbanizacion, 
        $telefonoCelular){
	    
        $ProveedorBusiness = new ProveedorBusiness();
        //Asignacion de variables en el objeto Proveedor
        $Proveedor = new Proveedor();
        
        $Proveedor->codProveedor = $ProveedorBusiness->getDecodeCampo($codProveedor);
        $Proveedor->codClienteMaster = $ProveedorBusiness->getDecodeCampo($codClienteMaster);
        $Proveedor->codCliente = $ProveedorBusiness->getDecodeCampo($codCliente);
        $Proveedor->nombre = $ProveedorBusiness->getDecodeCampo($nombre);
        $Proveedor->direccion = $ProveedorBusiness->getDecodeCampo($direccion);
        $Proveedor->telefono = $ProveedorBusiness->getDecodeCampo($telefono);
        $Proveedor->fax = $ProveedorBusiness->getDecodeCampo($fax);
        $Proveedor->inactivo = $ProveedorBusiness->getDecodeCampo($estatus);
        $Proveedor->codCiudad = $ProveedorBusiness->getDecodeCampo($codCiudad);
        $Proveedor->codRuta = $ProveedorBusiness->getDecodeCampo($codRuta);
        $Proveedor->contacto = $ProveedorBusiness->getDecodeCampo($contacto);
        $Proveedor->urbanizacion = $ProveedorBusiness->getDecodeCampo($urbanizacion);
        $Proveedor->telefonoCelular = $ProveedorBusiness->getDecodeCampo($telefonoCelular);
        
       	$EntitieResponse = new EntitieResponse();     
            
        $EntitieResponse = $ProveedorBusiness->editProveedor(
            $Proveedor, 
            $codUsuario, 
            $tokenAuthorization);           
               
    	return ZoomWS_Response($EntitieResponse);	
    }





    /**
     * deleteProveedor()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codProveedor
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $nombre
     * @param mixed $direccion
     * @param mixed $telefono
     * @param mixed $fax
     * @param mixed $estatus
     * @param mixed $codCiudad
     * @param mixed $codRuta
     * @param mixed $contacto
     * @param mixed $urbanizacion
     * @return
     */
    /*function deleteProveedor(
        $codUsuario, 
        $tokenAuthorization, 
        $codProveedor, 
        $codClienteMaster, 
        $codCliente, 
        $nombre, 
        $direccion, 
        $telefono,
        $fax, 
        $estatus, 
        $codCiudad, 
        $codRuta, 
        $contacto, 
        $urbanizacion, 
        $telefonoCelular){
	    
        $ProveedorBusiness = new ProveedorBusiness();
        //Asignacion de variables en el objeto Proveedor
        $Proveedor = new Proveedor();
        
        $Proveedor->codProveedor = $ProveedorBusiness->getDecodeCampo($codProveedor);
        $Proveedor->codClienteMaster = $ProveedorBusiness->getDecodeCampo($codClienteMaster);
        $Proveedor->codCliente = $ProveedorBusiness->getDecodeCampo($codCliente);
        $Proveedor->nombre = $ProveedorBusiness->getDecodeCampo($nombre);
        $Proveedor->direccion = $ProveedorBusiness->getDecodeCampo($direccion);
        $Proveedor->telefono = $ProveedorBusiness->getDecodeCampo($telefono);
        $Proveedor->fax = $ProveedorBusiness->getDecodeCampo($fax);
        $Proveedor->inactivo = $ProveedorBusiness->getDecodeCampo($estatus);
        $Proveedor->codCiudad = $ProveedorBusiness->getDecodeCampo($codCiudad);
        $Proveedor->codRuta = $ProveedorBusiness->getDecodeCampo($codRuta);
        $Proveedor->contacto = $ProveedorBusiness->getDecodeCampo($contacto);
        $Proveedor->urbanizacion = $ProveedorBusiness->getDecodeCampo($urbanizacion);
        $Proveedor->telefonoCelular = $ProveedorBusiness->getDecodeCampo($telefonoCelular);
        
       	$EntitieResponse = new EntitieResponse();     
            
        $EntitieResponse = $ProveedorBusiness->deleteProveedor(
            $Proveedor, 
            $codUsuario, 
            $tokenAuthorization);           
               
    	return ZoomWS_Response($EntitieResponse);	
    }*/



    /**
     * getProveedor()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codProveedor
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getProveedor(
        $codUsuario, 
        $tokenAuthorization, 
        $codProveedor, 
        $codClienteMaster, 
        $codCliente){
		    
        $EntitieResponse = new EntitieResponse();        
        $ProveedorBusinessClass = new ProveedorBusiness();
        $EntitieResponse = $ProveedorBusinessClass->getProveedor(
            $codProveedor, 
            $codClienteMaster, 
            $codCliente, 
            $codUsuario, 
            $tokenAuthorization);
        
    	return ZoomWS_Response($EntitieResponse);	
    }

    /**
     * getProveedores()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getProveedores(
        $codUsuario, 
        $tokenAuthorization, 
        $codClienteMaster, 
        $codCliente){
	
    	$ProveedorList = new EntitieListResponse();
        $ProveedorBusinessClass = new ProveedorBusiness();
        $ProveedorList = $ProveedorBusinessClass->getProveedores(
            $codClienteMaster, 
            $codCliente, 
            $codUsuario, 
            $tokenAuthorization);  
        
    	return ZoomWS_Response($ProveedorList);	
    }    
    
    /**
     * getProveedoresByReport()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $nombreProveedor
     * @param mixed $estatus
     * @param mixed $codCiudad
     * @param mixed $contactoProveedor
     * @param mixed $cantidadRegistros
     * @param mixed $orderBy
     * @return
     */
    function getProveedoresByReport(
        $codUsuario, 
        $tokenAuthorization, 
        $codClienteMaster, 
        $codCliente, 
        $nombreProveedor, 
        $estatus, 
        $codCiudad, 
        $nombreCiudad, 
        $contactoProveedor, 
        $cantidadRegistros, 
        $orderBy,
        $parentsOptionView){
        
        $ProveedorList = new EntitieListResponse();
        $ProveedorBusinessClass = new ProveedorBusiness();
        $ProveedorList = $ProveedorBusinessClass->getProveedores_ClienteByReport(
            $codUsuario, 
            $tokenAuthorization, 
            $codClienteMaster, 
            $codCliente, 
            $nombreProveedor, 
            $estatus, 
            $codCiudad,
            $nombreCiudad, 
            $contactoProveedor, 
            $cantidadRegistros, 
            $orderBy,
            $parentsOptionView);  
        
    	return ZoomWS_Response($ProveedorList);		
    }
    
    /**
     * getCasilleros()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getCasilleros($codUsuario, $tokenAuthorization, $codClienteMaster, $codCliente){
	
    	$CasilleroList = new EntitieListResponse();
        $CasilleroBusinessClass = new CasilleroBusiness();
        $CasilleroList = $CasilleroBusinessClass->getCasilleros_Cliente(
            $codClienteMaster, 
            $codCliente, 
            $codUsuario, 
            $tokenAuthorization);  
        
    	return ZoomWS_Response($CasilleroList);	
    }
    
?>