<?php

//  Funciones web para el calculo de tarifas. Zoom International Services (c) 2011 - Carlos De Oliveira

/*
	MODIFICADO POR FELIX UTRERA -- 12/12/2012
	- Se agregan la funciones getTipoServicio y getOficinas
	- Se modifica la funcion CalcularTarifa agregando los parametros: tipo de servicio, oficina a retirar y cantidad de piezas.
*/
function getTipoTarifa() {
	$r = array( "1" => "COD", "2" => "NACIONAL", "3" => "INTERNACIONAL");
	return ZoomWS_Response($r);
}

//function getTipoServicio() {
function getModalidadTarifa() {
	$r = array( "1" => "RETIRAR POR OFICINA", "2" => "PUERTA A PUERTA");
	return ZoomWS_Response($r);
}

function getTipoEnvio() {
	$r = array( "D" => "DOCUMENTO", "M" => "MERCANCIA");
	return ZoomWS_Response($r);
}

function getCiudades($filtro = "origen") {
	//echo "entre 22<br>";
	$cache = new cache();
	$cache->setTime(172800);
	$contenido = $cache->getCache("getCiudades.".$filtro);
	if(!empty($contenido)) {
		return ZoomWS_Response(unserialize($contenido));	
	}

	if($filtro=="origen") $query = "SELECT ciudad.codciudad, ciudad.nombre AS nombre_ciudad,estado.nombre AS nombre_estado FROM ciudad INNER JOIN oficina ON oficina.codciudad=ciudad.codciudad INNER JOIN estado ON ciudad.codestado = estado.codestado WHERE (ciudad.inactivo='f' OR ciudad.inactivo IS NULL) AND (oficina.inactivo<>'t' OR oficina.inactivo=null) AND oficina.estacionope='t' AND estado.codpais='124' ORDER BY ciudad.nombre";

	if($filtro=="nacional") $query="SELECT ciudad.codciudad,ciudad.nombre AS nombre_ciudad,estado.nombre AS nombre_estado FROM ciudad,estado,pais WHERE (ciudad.inactivo='f' OR ciudad.inactivo IS NULL) AND ciudad.codestado=estado.codestado AND estado.codpais=pais.codpais AND pais.codpais=124 ORDER BY ciudad.nombre";

	if($filtro=="cod") $query="SELECT ciudad.codciudad,ciudad.nombre AS nombre_ciudad,estado.nombre AS nombre_estado FROM ciudad,estado,pais WHERE ciudad.codestado=estado.codestado AND (ciudad.inactivo='f' OR ciudad.inactivo IS NULL) AND ciudad.cod='t' AND estado.codpais=pais.codpais AND pais.codpais=124 ORDER BY ciudad.nombre";

	if($filtro=="remitente") $query = "SELECT list_ciudad_maestro.listcm_id AS codciudad, list_ciudad_maestro.listcm_nombre AS nombre_ciudad, list_estado.liste_nombre AS nombre_estado FROM list_ciudad_maestro LEFT JOIN list_estado ON (list_ciudad_maestro.listcm_idestado::text=list_estado.liste_codigo::text) ORDER BY list_ciudad_maestro.listcm_nombre";

	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$row['nombre_ciudad']=htmlentities($row['nombre_ciudad']);
			$respuesta[] = $row;
		}		
	}	
	if(count($respuesta)==0) {
		return ZoomWS_Error("NO HAY CIUDADES PARA MOSTRAR");
	}else{
		$cache->finish(serialize($respuesta),false);
		return ZoomWS_Response($respuesta);
	}
}

function getPaises ($tipo='todos') {   
	//echo "entre 22<br>";
	$cache = new cache();
	$cache->setTime(172800);
	$contenido = $cache->getCache("getPaises".$tipo);
	if(!empty($contenido)) {
		return ZoomWS_Response(unserialize($contenido));	
	}

	$where='';
	if ($tipo=='1') {//para la aplicacion movil solo muestra los paises con oficinas
		$where=' AND codpais in (124,1,29)';
	}

	$query="SELECT codpais,nombre AS nombre_pais FROM pais WHERE (inactivo<>'t' OR inactivo IS NULL) ".$where." ORDER BY nombre_pais";

	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$row['nombre_pais']=htmlentities($row['nombre_pais']);
			$respuesta[] = $row;
		}		
	}	
	if(count($respuesta)==0) {
		return ZoomWS_Error("NO HAY PAISES PARA MOSTRAR");
	}else{
		$cache->finish(serialize($respuesta),false);
		return ZoomWS_Response($respuesta);
	}
}

function CalcularTarifa(	$tipo_tarifa,
							$tipo_servicio,
							$ciudad_origen,
							$ciudad_destino,
							$oficina_destino,
							$cant_piezas,
							$peso,
							$valor_mercancia,
							$valor_declarado,
							$id_pais_des=0,
							$tipo_envio=0,
							$zip_code=0,
							$alto=0,
							$ancho=0,
							$largo=0
							) {
	$calculo=false;
	if($tipo_tarifa==1 || $tipo_tarifa==2) {
		$tarifa = new ZoomTarifaNacional();
		$tarifa->setTipoTarifa($tipo_tarifa);
		$tarifa->setTipoServicio($tipo_servicio);
		$tarifa->setIdCiudadOrigen($ciudad_origen);
		$tarifa->setIdCiudadDestino($ciudad_destino);
		$tarifa->setIdOficinaDestino($oficina_destino);
		$tarifa->setCantPiezas($cant_piezas);
		$tarifa->setPesoBruto($peso);
		$tarifa->setValorMercancia($valor_mercancia);
		$tarifa->setValorDeclarado($valor_declarado);
		
		if(!$tarifa->CalcularTarifaNac()) {
			return ZoomWS_Error($tarifa->getError());	
		}else{
			$calculo=true;
		}
	}else if($tipo_tarifa==3) {
		$tarifa = new ZoomTarifaInternacional();
		$tarifa->setTipoTarifa($tipo_tarifa);
		$tarifa->setIdCiudadOrigen($ciudad_origen);
		$tarifa->setIdPaisDestino($id_pais_des);
		$tarifa->setTipoEnvio($tipo_envio);
		$tarifa->setCantPiezas($cant_piezas);
		$tarifa->setPesoBruto($peso);
		$tarifa->setZipCode($zip_code);
		$tarifa->setAlto($alto);
		$tarifa->setAncho($ancho);
		$tarifa->setLargo($largo);
		$tarifa->setValorDeclarado($valor_declarado);

		if(!$tarifa->CalcularTarifaInt()) {
			return ZoomWS_Error($tarifa->getError());	
		}else{
			$calculo=true;
		}
	}else{
		return ZoomWS_Error("El Codigo del Tipo de Tarifa debe ser 1,2 o 3");
		//return ZoomWS_Error($sestipotarifa);
	}

	if($calculo){
		$response = array();
		$response['flete'] = number_format($tarifa->getFlete(),2,",",".");
		$response['seguro'] = number_format($tarifa->getSeguro(),2,",",".");
		$response['combustible'] = number_format($tarifa->getCombustible(),2,",",".");
		$response['subtotal'] = number_format($tarifa->getSubtotal(),2,",",".");
		$response['franqueo_postal'] = number_format($tarifa->getTasaPostal(),2,",",".");
		$response['iva'] = number_format($tarifa->getTotalIVA(),2,",",".");
		$response['total'] = number_format($tarifa->getTotalAPagar(),2,",",".");
		
		return ZoomWS_Response($response);
	}else{
		return ZoomWS_Error("Hubo un error en la Calculadora.");
	}
}

function getOficinas($codciudad,$codservicio) {

	//SI EL SERVICIO ES COD:
	if($codservicio==1)
	{
		/* MODIFICADO POR FELIX UTRERA -- PARA OBTENER LAS OFICINAS TAL CUAL GE Y GC. -- 01/10/2015 */
		//$cod="AND (oficina.codtipoofi in (1,2,3) OR (oficina.cod='t' and oficina.codtipoofi in (4,5)))/AND ciudad.cod='t'";
		$cod="AND (oficina.codtipoofi in (1,2,3) OR (oficina.cod='t' and oficina.codtipoofi in (4,5)))";
	}
	else
	{
		$cod="";
	}
	//$cod=explode("/",$cod);

	/* MODIFICADO POR FELIX UTRERA -- PARA OBTENER LAS OFICINAS TAL CUAL GE Y GC. -- 01/10/2015 */
	//$query="SELECT distinct(oficina.codoficina) AS codoficina,oficina.nombre FROM oficina,ruta,circuito WHERE oficina.codoficina=ruta.codoficinaret AND ruta.codcircuito=circuito.codcircuito AND circuito.codoficina=(select ciudad.codoficina from ciudad where codciudad='".$codciudad."' ".$cod[1].") AND (oficina.inactivo='false' or oficina.inactivo is NULL) AND (ruta.inactivo='false' or ruta.inactivo is NULL) ".$cod[0]." AND ruta.pesomax>0 ORDER BY nombre";
	$query="SELECT DISTINCT(oficina.codoficina) AS codoficina, oficina.nombre FROM oficina,ruta, ciudad  WHERE oficina.codoficina=ruta.codoficinaret AND codoficinaope=(SELECT ciudad.codoficina FROM ciudad WHERE codciudad=".$codciudad.") AND oficina.codciudad=".$codciudad." AND oficina.inactivo<>true AND ruta.inactivo<>true AND oficina.codciudad=ciudad.codciudad AND (oficina.inactivo='false' OR oficina.inactivo IS NULL) AND (ruta.inactivo='false' OR ruta.inactivo IS NULL) AND ruta.pesomax>0 ".$cod." ORDER BY oficina.nombre";
	
	$response = db::getArrayKey($query);
	if(count($response)==0) {
		return ZoomWS_Error("NO HAY OFICINAS PARA MOSTRAR");
	}
	else{
		return ZoomWS_Response($response);
	}
}

//FUNCION UTILIZADA PARA OBTENER LAS OFICINAS PARA EL SISTEMA GUA ELCTRNICA, ES PARECIDA A LA FUNCION getOficinas
function getOficinasGE($codciudad,$retirarofi=0,$codservicio=0) {
	if($retirarofi==1){

		//SI EL SERVICIO ES COD:
		if($codservicio==1)
		{
			/* MODIFICADO POR FELIX UTRERA -- PARA OBTENER LAS OFICINAS TAL CUAL GE Y GC. -- 01/10/2015 */
			//$cod="AND (oficina.codtipoofi in (1,2,3) OR (oficina.cod='t' and oficina.codtipoofi in (4,5)))/AND ciudad.cod='t'";
			$cod="AND (oficina.codtipoofi in (1,2,3) OR (oficina.cod='t' and oficina.codtipoofi in (4,5)))";
		}
		else
		{
			$cod="";
		}

		//$cod=explode("/",$cod);


		/* MODIFICADO POR FELIX UTRERA -- PARA OBTENER LAS OFICINAS TAL CUAL GE Y GC. -- 01/10/2015 */
		//$query="SELECT distinct(oficina.codoficina) AS codoficina,oficina.nombre FROM oficina,ruta,circuito WHERE oficina.codoficina=ruta.codoficinaret AND ruta.codcircuito=circuito.codcircuito AND circuito.codoficina=(select ciudad.codoficina from ciudad where codciudad='".$codciudad."' ".$cod[1].") AND (oficina.inactivo='false' or oficina.inactivo is NULL) AND (ruta.inactivo='false' or ruta.inactivo is NULL) ".$cod[0]." AND ruta.pesomax>0 ORDER BY oficina.nombre";
		
		$query="SELECT DISTINCT(oficina.codoficina) AS codoficina, oficina.nombre, oficina.direccion FROM oficina,ruta, ciudad  WHERE oficina.codoficina=ruta.codoficinaret AND codoficinaope=(SELECT ciudad.codoficina FROM ciudad WHERE codciudad=".$codciudad.") AND oficina.codciudad=".$codciudad." AND oficina.inactivo<>true AND ruta.inactivo<>true AND oficina.codciudad=ciudad.codciudad AND (oficina.inactivo='false' OR oficina.inactivo IS NULL) AND (ruta.inactivo='false' OR ruta.inactivo IS NULL) AND ruta.pesomax>0 ".$cod." ORDER BY oficina.nombre";

	}else{
		$query="SELECT oficina.codoficina,oficina.nombre, oficina.direccion FROM oficina INNER JOIN ciudad ON (oficina.codoficina=ciudad.codoficinaope) WHERE (oficina.inactivo='f' OR oficina.inactivo IS NULL) AND (ciudad.inactivo='f' OR ciudad.inactivo IS NULL) AND ciudad.codciudad=".$codciudad."";
		
	}

	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$respuesta[] = $row;
		}		
	}	
	if(count($respuesta)==0) {
		return ZoomWS_Error("NO HAY OFICINAS PARA MOSTRAR");
	}
	else{
		return ZoomWS_Response($respuesta);
	}
}

function getEstatus() {	
	$query="SELECT estatus.codestatus, estatus.siglas, estatus.nombreweb AS nombre, estatus.color, estatus.icono FROM estatus WHERE estatus.codtipo<>'3' AND estatus.codtipo<>'6' AND (estatus.inactivo IS NULL OR estatus.inactivo='f') AND estatus.nombreweb IS NOT NULL AND estatus.web='t' AND (estatus.nomostrar='f' OR estatus.nomostrar IS NULL) ORDER BY estatus.nombreweb";
	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$respuesta[] = $row;
		}		
	}	
	if(count($respuesta)==0) {
		return ZoomWS_Error("NO HAY ESTATUS PARA MOSTRAR");
	}
	else{
		return ZoomWS_Response($respuesta);
	}
}


/* 
FELIX UTRERA -- 01/10/2015
FUNCION QUE PERMITE OBTENER EL TIPO DE RUTA DE ACUERDO A UNA CIUDAD ORIGEN Y UNA CIUDAD DESTINO
POR AHORA VAMOS A IDENTIFICAR SI LA RUTA ES METROPILTANA O NO
LA RESPUESTA PARA UNA RUTA METROPOLITANA ES 1 DE RESTO ES NACIONAL
*/
function getTipoRutaEnvio($codciudadori,$codciudaddes) {

	$query="SELECT codtipopes FROM origendestino WHERE codciudadori=buscaciudad (buscaofiope (".$codciudadori.")) AND codciudaddes=buscaciudad (buscaofiope (".$codciudaddes."))";
	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$respuesta[] = $row['codtipopes'];
		}		
	}	
	if(count($respuesta)==0) {
		return ZoomWS_Error("NO EXISTE TIPO DE RUTA PARA LAS CIUDADES ORIGEN Y DESTINO INGRESADAS");
	}
	else{
		return ZoomWS_Response($respuesta);
	}
}
?>