<?php
function getLastTracking($tipo_busqueda,$codigo,$codigo_cliente) {
	$codigo=limpiarCampo2($codigo);
	$tipo_busqueda=limpiarCampo2($tipo_busqueda);
	$codigo_cliente=limpiarCampo2($codigo_cliente);
	$codigo_cliente = intval($codigo_cliente);
	
	$maxguiavalue=getMaxGuiaValue(); //OBTENGO EL VALOR MAXIMO PARA UN CODIGO DE GUIA

	if($tipo_busqueda==1) $codigo = intval($codigo); else $codigo = str_replace(" ","_",$codigo);

	if($tipo_busqueda!=1 && $tipo_busqueda!=2){
		return ZoomWS_Error("Error. El tipo de busqueda debe ser 1 o 2.");
	}
	
	if($tipo_busqueda==1 && ($codigo==0 || (strlen($codigo) < 8 || $codigo > $maxguiavalue) || $codigo=='')) {
		return ZoomWS_Error("Error. Numero de Guia invalido");
	}else if ($tipo_busqueda==2 && ($codigo=='0' || $codigo=='' || strlen($codigo) < 4)){
		return ZoomWS_Error("Error. Numero de Referencia invalido");
	}
	
	if($codigo_cliente==0 || $codigo_cliente=='') {
		return ZoomWS_Error("Error. Codigo de Cliente Invalido");
	}

	$cache = new cache();
	$cache->setTime(3600); // tiempo de cache en segundos  
	$hash = "getLastTracking.".$tipo_busqueda.".".$codigo.".".$codigo_cliente;
	
	$contenido = $cache->getCache($hash);
	if(!empty($contenido)) {
		return ZoomWS_Response(unserialize($contenido));	
	}

	$query="SELECT guia.referencia,coalesce(tracking.nombre::VARCHAR,'') AS receptor,'$codigo_cliente' AS codigo_cliente,tracking.codguia AS guia,tracking.fecha,tracking.codestatus AS codigo_estatus,estatus.siglas,estatus.nombreweb AS descripcion_estatus,coalesce(tracking.hora::VARCHAR,'') AS hora,tracking.fechapro,coalesce(tracking.sello::VARCHAR,'') AS sello,estatus.codtipo FROM tracking INNER JOIN estatus ON (tracking.codestatus=estatus.codestatus) INNER JOIN guia ON (tracking.codguia=guia.codguia) LEFT JOIN casillero ON (guia.coddestinatario=casillero.codcasillero) INNER JOIN servicio ON (guia.codservicio = servicio.codservicio) WHERE {where} AND estatus.codtipo<>'3' AND estatus.codtipo<>'6' AND estatus.web='t' AND (estatus.nomostrar='f' OR estatus.nomostrar IS NULL) AND ((servicio.casillero = 'f' AND guia.codcliente = '$codigo_cliente') OR (servicio.casillero = 't' AND casillero.codcliente = '$codigo_cliente')) ORDER BY tracking.codtracking DESC LIMIT 1";

	if($tipo_busqueda=='1')  { // busqueda por guias
		$query= str_replace("{where}","tracking.codguia='$codigo'",$query);
		//$query = str_replace("{where2}","",$query);
	} else {
		//$query= str_replace("{where1}","",$query);
		//$query = str_replace("{where2}","guia.referencia = '$codigo'",$query);
		$codigoup=strtoupper($codigo);
		$codigolo=strtolower($codigo);
		$query = str_replace("{where}","(guia.referencia = '$codigoup' OR guia.referencia = '$codigolo')",$query);
		/*$txtcodguia=$codigo;
		$txtcodguiaup=strtoupper($txtcodguia);
		$txtcodguialo=strtolower($txtcodguia);
		$query = str_replace("{where}","guia.referencia IS NOT NULL AND ((reverse_str(referencia) LIKE reverse_str('%".$txtcodguialo."') or referencia LIKE '".$txtcodguialo."%') OR (reverse_str(referencia) LIKE reverse_str('%".$txtcodguiaup."') OR referencia LIKE '".$txtcodguiaup."%') OR (reverse_str(referencia) LIKE reverse_str('%".$txtcodguia."') OR referencia LIKE '".$txtcodguia."%'))",$query);*/
	}
	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$row['fecha'] = db_fecha($row['fecha']);
			if($row['codtipo']!=8){
				$row['hora']='';
			}
			$respuesta[] = $row;
		}		
	}	
	if(count($respuesta)==0) {
		return ZoomWS_Error("Error. No se ha encontrado el tracking asociado");
	}
	$cache->finish(serialize($respuesta),false);
	return ZoomWS_Response($respuesta);
}


function getInfoTracking($tipo_busqueda,$codigo,$codigo_cliente) {
	$codigo=limpiarCampo2($codigo);
	$tipo_busqueda=limpiarCampo2($tipo_busqueda);
	$codigo_cliente=limpiarCampo2($codigo_cliente);
	$codigo_cliente = intval($codigo_cliente);
	
	if($tipo_busqueda==1) $codigo = intval($codigo); else $codigo = str_replace(" ","_",$codigo);
	
	$maxguiavalue=getMaxGuiaValue(); //OBTENGO EL VALOR MAXIMO PARA UN CODIGO DE GUIA

	if($tipo_busqueda!=1 && $tipo_busqueda!=2){
		return ZoomWS_Error("Error. El tipo de busqueda debe ser 1 o 2.");
	}
	
	if($tipo_busqueda==1 && ($codigo==0 || (strlen($codigo) < 8 || $codigo > $maxguiavalue) || $codigo=='')) {
		return ZoomWS_Error("Error. Numero de Guia invalido");
	}else if ($tipo_busqueda==2 && ($codigo=='0' || $codigo=='' || strlen($codigo) < 4)){
		return ZoomWS_Error("Error. Numero de Referencia invalido");
	}

	if($codigo_cliente==0 || $codigo_cliente=='') {
		return ZoomWS_Error("Error. Codigo de Cliente Invalido");
	}

	$cache = new cache();
	$cache->setTime(0); // tiempo de cache en segundos  
	$hash = "getTracking.".$tipo_busqueda.".".$codigo.".".$codigo_cliente;
	$contenido = $cache->getCache($hash);
	if(!empty($contenido)) {
		return ZoomWS_Response(unserialize($contenido));	
	}
	$query="SELECT guia.referencia, coalesce(tracking.nombre::VARCHAR,'') AS receptor, '$codigo_cliente' AS codigo_cliente, tracking.codguia AS guia, tracking.fecha, tracking.codestatus AS codigo_estatus, estatus.siglas, estatus.nombreweb AS descripcion_estatus, coalesce(tracking.hora::VARCHAR,'') AS hora, tracking.fechapro, coalesce(tracking.sello::VARCHAR,'') AS sello, estatus.codtipo FROM tracking INNER JOIN estatus ON (tracking.codestatus = estatus.codestatus) INNER JOIN guia ON (guia.codguia = tracking.codguia) INNER JOIN servicio ON (guia.codservicio = servicio.codservicio) LEFT JOIN casillero AS casillero_t ON (guia.coddestinatario = casillero_t.codcasillero) WHERE {where} AND estatus.codtipo<>'3' AND estatus.codtipo<>'6' AND estatus.web='t' AND (estatus.nomostrar='f' OR estatus.nomostrar IS NULL) AND ((servicio.casillero = 'f' AND guia.codcliente = '$codigo_cliente') OR (servicio.casillero = 't' AND casillero_t.codcliente = '$codigo_cliente')) ORDER BY tracking.codtracking DESC";

	if($tipo_busqueda=='1')  { // busqueda por guias
		$query= str_replace("{where}","tracking.codguia='$codigo'",$query);
	} else {
		$codigoup=strtoupper($codigo);
		$codigolo=strtolower($codigo);
		$query = str_replace("{where}","(guia.referencia = '$codigoup' OR guia.referencia = '$codigolo')",$query);
		/*$txtcodguia=$codigo;
		$txtcodguiaup=strtoupper($txtcodguia);
		$txtcodguialo=strtolower($txtcodguia);
		$query = str_replace("{where}","guia.referencia IS NOT NULL AND ((reverse_str(referencia) LIKE reverse_str('%".$txtcodguialo."') or referencia LIKE '".$txtcodguialo."%') OR (reverse_str(referencia) LIKE reverse_str('%".$txtcodguiaup."') OR referencia LIKE '".$txtcodguiaup."%') OR (reverse_str(referencia) LIKE reverse_str('%".$txtcodguia."') OR referencia LIKE '".$txtcodguia."%'))",$query);*/
	}
	registrar_log($query);
	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$row['fecha'] = db_fecha($row['fecha']);
			if($row['codtipo']!=8){
				$row['hora']='';
			}
			$respuesta[] = $row;
		}		
	}	
	if(count($respuesta)==0) {
		return ZoomWS_Error("Error. No se ha encontrado el tracking asociado");
	}
	$cache->finish(serialize($respuesta),false);
	return ZoomWS_Response($respuesta);
}

/*
Agregado por Manuel Alejandro Hernández Giuliani
02/09/2013
getTracking
Esta función busca el tracking de la guía por nro de guia o por referencia, a diferencia de getInfoTracking,
esta función no requiere código de cliente.

MODIFICADO POR: FELIX UTRERA -- 25/10/2013
- AGREGANDO VALIDACIONES A LOS CODIGOS. NO PUEDEN ESTAR VACIOS, DEBEN TENER UNA LONGITUD MAYOR A 7 DIGITOS.
- SE MODIFICA EL QUERY YA QUE AL NO REQUERIR CODIGO DE CLIENTE NO ES NECESARIO INCLUIR LA TABLA CASILLERO.
*/

/*function getTracking($tipo_busqueda,$codigo) {
	$codigo=limpiarCampo2($codigo);
	$tipo_busqueda=limpiarCampo2($tipo_busqueda);
	if($tipo_busqueda==1) $codigo = intval($codigo); else $codigo = str_replace(" ","_",$codigo);
	$maxguiavalue=getMaxGuiaValue(); //OBTENGO EL VALOR MAXIMO PARA UN CODIGO DE GUIA

	if($tipo_busqueda!=1 && $tipo_busqueda!=2){
		return ZoomWS_Error("Error. El tipo de busqueda debe ser 1 o 2.");
	}
	
	if($tipo_busqueda==1 && ($codigo==0 || (strlen($codigo) < 8 || $codigo > $maxguiavalue) || $codigo=='')) {
		return ZoomWS_Error("Error. Numero de Guia invalido");
	}else if ($tipo_busqueda==2 && ($codigo=='0' || $codigo=='' || strlen($codigo) < 4)){
		return ZoomWS_Error("Error. Numero de Referencia invalido");
	}
   
    $cache = new cache();
    $cache->setTime(0); // tiempo de cache en segundos
    $hash = "getTracking2.".$tipo_busqueda.".".$codigo;
    $contenido = $cache->getCache($hash);
    if(!empty($contenido)) {
        return ZoomWS_Response(unserialize($contenido));
    }

	$query = "SELECT guia.referencia, coalesce(tracking.nombre::VARCHAR,'') AS receptor, tracking.codguia AS guia, tracking.fecha, tracking.codestatus AS codigo_estatus, estatus.siglas, estatus.nombreweb AS descripcion_estatus, coalesce(tracking.hora::VARCHAR,'') AS hora, tracking.fechapro, coalesce(tracking.sello::VARCHAR,'') AS sello, estatus.codtipo FROM tracking INNER JOIN estatus ON tracking.codestatus = estatus.codestatus INNER JOIN guia ON guia.codguia = tracking.codguia INNER JOIN servicio ON guia.codservicio = servicio.codservicio WHERE {where} AND estatus.codtipo<>'3' AND estatus.codtipo<>'6' AND estatus.web='t' AND (estatus.nomostrar='f' OR estatus.nomostrar IS NULL) ORDER BY tracking.codguia, tracking.codtracking DESC";

    if($tipo_busqueda=='1')  { // busqueda por guias
        $query= str_replace("{where}","tracking.codguia='$codigo'",$query);
    } else {
        //$query = str_replace("{where}","guia.referencia = '$codigo'",$query);
		$txtcodguia=$codigo;
		$txtcodguiaup=strtoupper($txtcodguia);
		$txtcodguialo=strtolower($txtcodguia);
		$query = str_replace("{where}","guia.referencia IS NOT NULL AND ((reverse_str(referencia) LIKE reverse_str('%".$txtcodguialo."') OR referencia LIKE '".$txtcodguialo."%') OR (reverse_str(referencia) LIKE reverse_str('%".$txtcodguiaup."') OR referencia LIKE '".$txtcodguiaup."%') OR (reverse_str(referencia) LIKE reverse_str('%".$txtcodguia."') OR referencia LIKE '".$txtcodguia."%'))",$query);
    }
    registrar_log($query);
    $respuesta = array();
    $result = pg_query($query);
    if($result && pg_num_rows($result)>0) {
        while($row = pg_fetch_assoc($result)) {
            $row['fecha'] = db_fecha($row['fecha']);
            if($row['codtipo']!=8){
                $row['hora']='';
            }
            $respuesta[] = $row;
        }
    }
    if(count($respuesta)==0) {
        return ZoomWS_Error("Error. No se ha encontrado el tracking asociado");
    }
    $cache->finish(serialize($respuesta),false);
    return ZoomWS_Response($respuesta);
}*/
?>