<?php

//  Funciones web para el calculo de tarifas. Zoom International Services (c) 2011 - Carlos De Oliveira

/*
	MODIFICADO POR FELIX UTRERA -- 12/12/2012
	- Se agregan la funciones getTipoServicio y getOficinas
	- Se modifica la funcion CalcularTarifa agregando los parametros: tipo de servicio, oficina a retirar y cantidad de piezas.
*/
function getTipoTarifa() {
	$r = array( "1" => "COD", "2" => "NACIONAL");
	return ZoomWS_Response($r);
}

//function getTipoServicio() {
function getModalidadTarifa() {
	$r = array( "1" => "RETIRAR POR OFICINA", "2" => "PUERTA A PUERTA");
	return ZoomWS_Response($r);
}

function getCiudades($filtro = "origen") {
	//echo "entre 22<br>";
	$cache = new cache();
	$cache->setTime(172800);
	$contenido = $cache->getCache("getCiudades.".$filtro);
	if(!empty($contenido)) {
		return ZoomWS_Response(unserialize($contenido));	
	}
	//estado.nombre AS nombre_estado
	if($filtro=="origen"){
		$query = "	SELECT ciudad.codciudad, ciudad.nombre AS nombre_ciudad,estado.nombre AS nombre_estado FROM ciudad
					INNER JOIN oficina ON oficina.codciudad=ciudad.codciudad 
					INNER JOIN estado ON ciudad.codestado = estado.codestado
					WHERE (oficina.inactivo<>'t' OR oficina.inactivo=null) 
					AND oficina.estacionope='t' 
					AND estado.codpais='124' ORDER BY ciudad.nombre";
	}
					
	//if($filtro=="nacional") $query = "SELECT codciudad,nombre FROM ciudad WHERE inactivo='f' ORDER BY nombre ASC";
	if($filtro=="nacional") $query="select ciudad.codciudad,ciudad.nombre AS nombre_ciudad,estado.nombre AS nombre_estado from ciudad,estado,pais where (ciudad.inactivo='f' OR ciudad.inactivo is null) AND ciudad.codestado=estado.codestado AND estado.codpais=pais.codpais AND pais.codpais=124 order by ciudad.nombre";

	//if($filtro=="cod") $query ="SELECT codciudad,nombre FROM ciudad WHERE inactivo='f' and cod='t' ORDER BY nombre ASC";
	if($filtro=="cod") $query="select ciudad.codciudad,ciudad.nombre AS nombre_ciudad,estado.nombre AS nombre_estado from ciudad,estado,pais where ciudad.codestado=estado.codestado and (ciudad.inactivo='f' or ciudad.inactivo is null) and ciudad.cod='t' AND estado.codpais=pais.codpais AND pais.codpais=124 order by ciudad.nombre";
	

	if($filtro=="remitente") $query = "SELECT list_ciudad_maestro.listcm_id AS codciudad, list_ciudad_maestro.listcm_nombre AS nombre_ciudad, list_estado.liste_nombre AS nombre_estado FROM list_ciudad_maestro left join list_estado on (list_ciudad_maestro.listcm_idestado::text=list_estado.liste_codigo::text) ORDER BY list_ciudad_maestro.listcm_nombre";

	//$response = db::getArrayKey($query);
	//$cache->finish(serialize($response),false);
	//return ZoomWS_Response($response);
	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$respuesta[] = $row;
		}		
	}	
	if(count($respuesta)==0) {
		return ZoomWS_Error("NO HAY CIUDADES PARA MOSTRAR");
	}else{
		$cache->finish(serialize($respuesta),false);
		return ZoomWS_Response($respuesta);
	}
}
 
function CalcularTarifa(	$tipo_tarifa,
							$tipo_servicio,
							$ciudad_origen,
							$ciudad_destino,
							$oficina_destino,
							$cant_piezas,
							$peso,
							$valor_mercancia,
							$valor_declarado 
							) {

	$tarifa = new ZoomTarifa();
	$tarifa->setTipoTarifa($tipo_tarifa);
	$tarifa->setTipoServicio($tipo_servicio);
	$tarifa->setIdCiudadOrigen($ciudad_origen);
	$tarifa->setIdCiudadDestino($ciudad_destino);
	$tarifa->setIdOficinaDestino($oficina_destino);
	$tarifa->setCantPiezas($cant_piezas);
	$tarifa->setPesoBruto($peso);
	$tarifa->setValorMercancia($valor_mercancia);
	$tarifa->setValorDeclarado($valor_declarado);
	
	if(!$tarifa->CalcularTarifa()) {
		return ZoomWS_Error($tarifa->getError());	
	}
	else{
		$response = array();
		$response['flete'] = number_format($tarifa->getFlete(),2,",",".");
		$response['seguro'] = number_format($tarifa->getSeguro(),2,",",".");
		$response['subtotal'] = number_format($tarifa->getSubtotal(),2,",",".");
		$response['franqueo_postal'] = number_format($tarifa->getTasaPostal(),2,",",".");
		$response['iva'] = number_format($tarifa->getTotalIVA(),2,",",".");
		$response['total'] = number_format($tarifa->getTotalAPagar(),2,",",".");
		return ZoomWS_Response($response);
	}
}

function getOficinas($codciudad,$codservicio) {

	//SI EL SERVICIO ES COD:
	if($codservicio==1)
	{
		$cod="AND (oficina.codtipoofi in (1,2,3) OR (oficina.cod='t' and oficina.codtipoofi in (4,5)))/AND ciudad.cod='t'";
	}
	else
	{
		$cod="";
	}
	$cod=explode("/",$cod);

	$query="SELECT distinct(oficina.codoficina) AS codoficina,oficina.nombre FROM oficina,ruta,circuito WHERE oficina.codoficina=ruta.codoficinaret AND ruta.codcircuito=circuito.codcircuito AND circuito.codoficina=(select ciudad.codoficina from ciudad where codciudad='".$codciudad."' ".$cod[1].") AND (oficina.inactivo='false' or oficina.inactivo is NULL) AND (ruta.inactivo='false' or ruta.inactivo is NULL) ".$cod[0]." AND ruta.pesomax>0 ORDER BY nombre";
	$response = db::getArrayKey($query);
	if(count($response)==0) {
		return ZoomWS_Error("NO HAY OFICINAS PARA MOSTRAR");
	}
	else{
		return ZoomWS_Response($response);
	}
}

function getEstatus() {

	$query="SELECT estatus.codestatus, estatus.siglas, estatus.nombreweb AS nombre FROM estatus WHERE estatus.codtipo<>'3' AND estatus.codtipo<>'6' AND (estatus.inactivo IS NULL OR estatus.inactivo='f') AND estatus.nombreweb IS NOT NULL AND estatus.web='t' AND (estatus.nomostrar='f' OR estatus.nomostrar IS NULL) ORDER BY estatus.nombreweb";
	$respuesta = array();
	$result = pg_query($query);	
	if($result && pg_num_rows($result)>0) {
		while($row = pg_fetch_assoc($result)) {
			$respuesta[] = $row;
		}		
	}	
	if(count($respuesta)==0) {
		return ZoomWS_Error("NO HAY ESTATUS PARA MOSTRAR");
	}
	else{
		return ZoomWS_Response($respuesta);
	}
}
?>