<?php

/**
* Clase RecolectaBusiness clase que contiene los metodos y reglas de negocios asociados a una recolecta
*
* @author Ingeniero Luis Blanco
* @module Recolectas
* @modulegroup Servicios
* @package CLASES BUSINESS
*/

class MainBusiness {
    
    /**
     * MainBusiness::validateAuthentication()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @return
     */
    function validateAuthentication($codUsuario, $tokenAuthorization){
        
        $validAuthenticate = MainClass::COD_OPERATION_SUCESFULLY;
        $tokenValue = MainClass::COD_USUARIO_WEBSERVICES . MainClass::COD_TOKEN_AUTHORIZATION;
        $tokenAuthorizationValidate = md5($tokenValue);
        
        if($codUsuario != MainClass::COD_USUARIO_WEBSERVICES){
            $validAuthenticate = MainClass::COD_OPERATION_FAILED;             
        }
        
        if($tokenAuthorization != $tokenAuthorizationValidate){
            $validAuthenticate = MainClass::COD_OPERATION_FAILED;             
        }
        
        return $validAuthenticate;
    }
    
    /**
     * MainBusiness::imprime()
     * 
     * @param mixed $valorImprimir
     * @return
     */    
    function imprime($valorImprimir){
	   echo "<br> $valorImprimir <br>";
    }
    
    /**
     * MainBusiness::imprimeObjeto()
     * 
     * @param mixed $objectoImprimir
     * @return
     */    
    function imprimeObjeto($objectoImprimir){
        var_dump($objectoImprimir);
    }
    
    /**
     * MainBusiness::imprimeVariable()
     * 
     * @param mixed $variableImprimir
     * @param mixed $valorImprimir
     * @return
     */    
    function imprimeVariable($variableImprimir, $valorImprimir){
	   echo "<br> El valor de la variable $variableImprimir es: $valorImprimir <br>";
    }    
    
    /**
     * MainBusiness::imprimeVariableResaltada()
     * 
     * @param mixed $variableImprimir
     * @param mixed $valorImprimir
     * @return
     */   
    function imprimeVariableResaltada($variableImprimir, $valorImprimir){
	   echo "<br> El valor de la variable <strong>$variableImprimir</strong> es: <strong>$valorImprimir</strong> <br>";
    }
    
    /**
     * MainBusiness::imprimeTipoDatoVariable()
     * 
     * @param mixed $variableImprimir
     * @param mixed $valorImprimir
     * @return
     */    
    function imprimeTipoDatoVariable($variableImprimir, $valorImprimir){        
        echo "<br> El valor de la variable <strong>$variableImprimir</strong>; con valor:  <strong>$valorImprimir</strong>; El tipo de Dato es: <strong>" . gettype ($valorImprimir) . "</strong><br />\n";
    }
    
    /**
     * MainBusiness::register_business_log()
     * 
     * @param mixed $registerValue     
     * @return
     */ 
    function register_business_log($registerValue)  {
		$variable = print_r($registerValue,true);
		$archivo = APPDIR."log_business.txt";		
		$fh = fopen($archivo, 'a') or die("No se puede abrir log");
		$marca = date("d-m-Y H:i:s").",".$variable."\n";
		fwrite($fh, $marca);
		fclose($fh);
	}
    
    /**
     * RecolectaBusiness::getDateInFormatByReport()
     * 
     * @param mixed $DateOldFormat
     * @return
     */
    function getDateInFormatByReport($DateOldFormat){
        
        $this->register_business_log($DateOldFormat);
        //cambia el formato de la fecha de ddmmyyyy a yyyy-mm-dd
        if(isset($DateOldFormat) && $DateOldFormat != MainClass::COD_STRING_EMPTY && $DateOldFormat != MainClass::COD_STRING_ALL){
            
            $Day    = substr($DateOldFormat, 0, 2);    
            $Month  = substr($DateOldFormat, 2, 2);  
            $Year   = substr($DateOldFormat, 4, 8);  	
			
			$NewDate = array(
				0 => $Year, 
				1 => $Month,
				2=> $Day
			);
            
            $this->register_business_log($Year);
            
			$DateNewFormat = "$Year-$Month-$Day";
            $this->register_business_log($DateNewFormat);
            return $DateNewFormat;
        }else{
            
            return MainClass::COD_STRING_ALL;     
        }
    }
    
    /**
     * getDecodeCampo()
     * 
     * @param mixed $currentValue     
     * @return
     */
	function getDecodeCampo($currentValue){
		
        //Procedemos a corregir la encondificacion que genera la clase ZoomWebServices
        //$currentValue = $this->encodeToUtf8($currentValue);
        //Procedemos a reemplazar los caracteres especiales por caracteres simples sin acento
        //$currentValue = $this->replaceCaracter($currentValue);

        $newValue = urldecode($currentValue);
		//$newValue = trim(htmlentities($newValue));
        
        //$newValue = $this->replaceHtmlCaracter($newValue);
        
        //$newValue = $currentValue;                
		return $newValue;
	}      
    
    /**
     * encodeToUtf8()
     * 
     * @param mixed $currentValue     
     * @return
     */
    function encodeToUtf8($currentValue) {
        return mb_convert_encoding($currentValue, "ISO-8859-1", mb_detect_encoding($currentValue, "UTF-8, UTF-7, ISO-8859-1, ISO-8859-15", true));
    }   

    /**
     * replaceCaracter()
     * 
     * @param mixed $currentValue     
     * @return
     */
    function replaceCaracter($currentValue) {

        $specialCaracters = array ('á','é','í','ó','ú','ñ','Á','É','Í','Ó','Ú','Ñ');
        $newCaracters = array ('a','e','i','o','u','n','A','E','I','O','U','N');

        return str_replace($specialCaracters, $newCaracters, $currentValue);
    }
    
    /**
     * replaceCaracter()
     * 
     * @param mixed $currentValue     
     * @return
     */
    function replaceHtmlCaracter($currentValue) {

        $specialCaracters = array (
                                    '&aacute;',
                                    '&eacute;',
                                    '&iacute;',
                                    '&oacute;',
                                    '&uacute;',
                                    '&ntilde;',
                                    '&AACUTE;',
                                    '&EACUTE;',
                                    '&IACUTE;',
                                    '&OACUTE;',
                                    '&UACUTE;',
                                    '&NTILDE;', 
                                    '&ATILDE;',
                                    '&ETILDE;',
                                    '&ITILDE;',
                                    '&OTILDE;',
                                    '&UTILDE;',
                                    '&Atilde;',
                                    '&Etilde;',
                                    '&Itilde;',
                                    '&Otilde;',
                                    '&Utilde;',
                                    );
                                    
        $newCaracters = array 
                            (
                            'a',
                            'e',
                            'i',
                            'o',
                            'u',
                            'n',
                            'A',
                            'E',
                            'I',
                            'O',
                            'U',
                            'N',
                            'A',
                            'E',
                            'I',
                            'O',
                            'U',
                            'a',
                            'e',
                            'i',
                            'o',
                            'u',
                            );

        return str_replace($specialCaracters, $newCaracters, $currentValue);
    }
    
    //Funcion que permite limpiar los campos
	function limpiarCampo2($campo){
		$campo=urldecode($campo);
		$campo=trim(htmlentities($campo));
		return $campo;
	}
    
}//END CLASS RecolectaDAL

?>


