<?php

/**
* Clase ProveedorBusiness clase que contiene los metodos y reglas de negocios asociados a un proveedor
*
* @author Ingeniero Luis Blanco
* @module Recolectas
* @modulegroup Servicios
* @package CLASES BUSINESS
*/

include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'mainclass'.DIRECTORY_SEPARATOR.'class.mainclass.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'business'.DIRECTORY_SEPARATOR.'class.main.manager.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'mainclass'.DIRECTORY_SEPARATOR.'class.proveedor.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'dal'.DIRECTORY_SEPARATOR.'class.proveedor.dal.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'dal'.DIRECTORY_SEPARATOR.'class.recolecta.dal.php');

class ProveedorBusiness extends MainBusiness{
     
    var $ProveedorDAL;
         
    
    /**
     * ProveedorBusiness::__construct()
     * 
     * @return
     */
    public function __construct()
    {
        $this->ProveedorDAL = new ProveedorDAL();   
        $this->RecolectaDAL = new RecolectaDAL();         
    }
    
    /**
     * ProveedorBusiness::getCodProveedor()
     * 
     * @return
     */
    function getCodProveedor(){
        
        $codProveedor = MainClass::COD_STRING_EMPTY;
        
         try {
            
            $dataBaseResult = $this->ProveedorDAL->getCodProveedor(); 
        	if($dataBaseResult && pg_num_rows($dataBaseResult)>0) {        		
                 $codProveedor = pg_result($dataBaseResult,'0',"valormax");
                 $codProveedor ++;
        	}else{
        	     $codProveedor = MainClass::COD_ENTITY_ID;           
        	}
                        
        } catch (Exception $excp) {
             $codProveedor = MainClass::COD_ENTITY_ID; 
        }
                
        return $codProveedor; 
    } 
    
    /**
     * ProveedorBusiness::getProveedor_Enyity()
     * 
     * @param mixed $codProveedor
     * @return
     */
    function getProveedor_Enyity($codProveedor){
        
       	$Entity = new Proveedor();
        
        try {
            
            $dataBaseResult = $this->ProveedorDAL->getProveedor($codProveedor);        		
        
        	if($dataBaseResult && pg_num_rows($dataBaseResult)>0) {
        		while($dataBaseRow = pg_fetch_assoc($dataBaseResult)) {
        				                    
                    $Entity->codProveedor       = $dataBaseRow["codproveedor"];
                    $Entity->codCliente         = $dataBaseRow["codcliente"];                    
                    $Entity->nombre             = trim($dataBaseRow["nombre"]);
                    
                    $Entity->direccion          = trim($dataBaseRow["direccion"]);
                    $Entity->telefono           = trim($dataBaseRow["telefono"]);
                    $Entity->fax                = $dataBaseRow["fax"];
                    $Entity->inactivo           = $dataBaseRow["inactivo"];
                    $Entity->codCiudad          = $dataBaseRow["codciudad"];
                    $Entity->codRuta            = $dataBaseRow["codruta"];
                    $Entity->contacto           = trim($dataBaseRow["contacto"]);
                    $Entity->urbanizacion       = trim($dataBaseRow["urbanizacion"]);
                    
                    $Entity->codEstado          = $dataBaseRow["codestado"];
                    $Entity->nombreEstado       = trim($dataBaseRow["nombreestado"]);
                    $Entity->nombreCiudad       = trim($dataBaseRow["nombreciudad"]);
                    
                   
        		}		
        	}else{
        	    $Entity->codProveedor = MainClass::COD_ENTITY_ID;           
        	}
                        
        } catch (Exception $excp) {
            $Entity->codProveedor = MainClass::COD_ENTITY_ID;  
        }               
                
        return $Entity;                 
    }
    
    /**
     * ProveedorBusiness::getProveedor_Cliente()
     * 
     * @param mixed $codProveedor
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getProveedor_Cliente($codProveedor, $codClienteMaster, $codCliente){
        
       	$Entity = new Proveedor();
        $IsClientParents = MainClass::COD_OPERATION_FAILED;        
        if($codClienteMaster != $codCliente){ $IsClientParents = MainClass::COD_OPERATION_SUCESFULLY; }
        
        try {
            
            if($IsClientParents == MainClass::COD_OPERATION_SUCESFULLY){
                    $dataBaseResult = $this->ProveedorDAL->getProveedor_ClienteParents($codProveedor, $codClienteMaster, $codCliente); 
            }else{
                    $dataBaseResult = $this->ProveedorDAL->getProveedor_Cliente($codProveedor, $codClienteMaster);                    
            } 
            
        	if($dataBaseResult && pg_num_rows($dataBaseResult)>0) {
        		while($dataBaseRow = pg_fetch_assoc($dataBaseResult)) {
        				                    
                    $Entity->codProveedor       = $dataBaseRow["codproveedor"];
                    
                    //Aqui se define el esquema de Cliente Master a la hora de retornar la lista de proveedores
                    //de un cliente que no sea el Cliente directo del Sistema Recolecta
                    if($IsClientParents == MainClass::COD_OPERATION_SUCESFULLY){
                        $Entity->codClienteMaster   = $dataBaseRow["codcliente"];
                        $Entity->codCliente         = $dataBaseRow["codclienteparent"];                            
                    }else{
                        $Entity->codClienteMaster   = $dataBaseRow["codcliente"];
                        $Entity->codCliente         = $dataBaseRow["codcliente"];
                    }
                                       
                    $Entity->nombre             = trim($dataBaseRow["nombre"]);                    
                    $Entity->direccion          = trim($dataBaseRow["direccion"]);
                    $Entity->telefono           = trim($dataBaseRow["telefono"]);
                    $Entity->fax                = $dataBaseRow["fax"];
                    $Entity->inactivo           = $dataBaseRow["inactivo"];
                    $Entity->codCiudad          = $dataBaseRow["codciudad"];
                    $Entity->codRuta            = $dataBaseRow["codruta"];
                    $Entity->contacto           = trim($dataBaseRow["contacto"]);
                    $Entity->urbanizacion       = trim($dataBaseRow["urbanizacion"]);
                    $Entity->telefonoCelular    = trim($dataBaseRow["celular"]);
                    
                    //Se agrega la informacion correspondiente al Estado
                    $dataBaseResultEstado = $this->ProveedorDAL->getEstadoByCiudad($Entity->codCiudad);
                    if($dataBaseResultEstado && pg_num_rows($dataBaseResultEstado)>0) {
        		          while($dataBaseRow = pg_fetch_assoc($dataBaseResultEstado)) {        			 
                    
                                $Entity->codEstado          = $dataBaseRow["codestado"];
                                $Entity->nombreEstado       = trim($dataBaseRow["nombreestado"]);
                                $Entity->nombreCiudad       = trim($dataBaseRow["nombreciudad"]);
                                
        		      }		
    	           }                   
                   
       		}		
        	}else{
        	    $Entity->codProveedor = MainClass::COD_ENTITY_ID;           
        	}
                        
        } catch (Exception $excp) {
            $Entity->codProveedor = MainClass::COD_ENTITY_ID;  
        }               
                
        return $Entity;                 
    }
    
    /**
     * ProveedorBusiness::getProveedor()
     * 
     * @param mixed $codProveedor
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @return
     */
    function getProveedor($codProveedor, $codClienteMaster, $codCliente, $codUsuario, $tokenAuthorization){
        
       	$EntitieResponse = new EntitieResponse();    
        $EntitieResponse->codResponse = MainClass::COD_RESPONSE_SUCCESSFULLY;
        $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_SUCCESSFULLY;    
        $EntitieResponse->entityName = MainClass::ENTITY_NAME_PROVEEDOR;
        
        
        try {
            
            //Se procede a validar todas las reglas de negocio asociadas a la consulta de recolectas 
            if($this->validateBusinessRule_GetProveedores($codClienteMaster, $EntitieResponse->codResponse, $EntitieResponse->messageResponse, $codUsuario, $tokenAuthorization) == MainClass::COD_OPERATION_SUCESFULLY){                
                
                $Entity = new Proveedor();	
                $Entity = $this->getProveedor_Cliente($codProveedor, $codClienteMaster, $codCliente);
                
                if($Entity->codProveedor != MainClass::COD_ENTITY_ID){
                    $EntitieResponse->entity = $Entity;                    
                }else{
                    $EntitieResponse->codResponse = MainClass::COD_RESPONSE_ERROR_017;
                    $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_ERROR_017; 
                }
                                                  
            }
                        
        } catch (Exception $excp) {
            $EntitieResponse->codResponse = MainClass::COD_RESPONSE_ERROR_100;
            $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_ERROR_100; 
        }
                
        return $EntitieResponse;                 
    }
    
    /**
     * ProveedorBusiness::getProveedores()
     * 
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @return
     */
    function getProveedores($codClienteMaster, $codCliente, $codUsuario, $tokenAuthorization){
        
       	$ProveedorList = new EntitieListResponse();    
        $ProveedorList->codResponse = MainClass::COD_RESPONSE_SUCCESSFULLY;
        $ProveedorList->messageResponse = MainClass::MSG_RESPONSE_SUCCESSFULLY; 
        $ProveedorList->entityName = MainClass::ENTITY_NAME_PROVEEDOR;
        $IsClientParents = MainClass::COD_OPERATION_FAILED;        
        if($codClienteMaster != $codCliente){ $IsClientParents = MainClass::COD_OPERATION_SUCESFULLY; }
                
        try {
            
            //Se procede a validar todas las reglas de negocio asociadas a la consulta de recolectas 
            if($this->validateBusinessRule_GetProveedores($codClienteMaster, $ProveedorList->codResponse, $ProveedorList->messageResponse, $codUsuario, $tokenAuthorization) == MainClass::COD_OPERATION_SUCESFULLY){                
                
                if($IsClientParents == MainClass::COD_OPERATION_SUCESFULLY){
                    $dataBaseResult = $this->ProveedorDAL->getProveedores_ClienteParents($codClienteMaster, $codCliente); 
                }else{
                    $dataBaseResult = $this->ProveedorDAL->getProveedores($codClienteMaster);                    
                }
                
            	if($dataBaseResult && pg_num_rows($dataBaseResult)>0) {
            		while($dataBaseRow = pg_fetch_assoc($dataBaseResult)) {
            			$Entity = new Proveedor();	
                        
                        $Entity->codProveedor       = $dataBaseRow["codproveedor"];
                        
                        //Aqui se define el esquema de Cliente Master a la hora de retornar la lista de recolectas
                        //de un cliente que no sea el Cliente directo del Sistema Recolecta
                        if($IsClientParents == MainClass::COD_OPERATION_SUCESFULLY){
                             $Entity->codClienteMaster   = $dataBaseRow["codcliente"];
                             $Entity->codCliente         = $dataBaseRow["codclienteparent"];
                        }else{                              
                            $Entity->codClienteMaster   = $dataBaseRow["codcliente"];
                            $Entity->codCliente         = $dataBaseRow["codcliente"];                 
                        }
                        
                        $Entity->nombre             = trim($dataBaseRow["nombre"]);                        
                        $Entity->direccion          = trim($dataBaseRow["direccion"]);
                        $Entity->telefono           = trim($dataBaseRow["telefono"]);
                        $Entity->fax                = $dataBaseRow["fax"];
                        $Entity->inactivo           = $dataBaseRow["inactivo"];
                        $Entity->codCiudad          = $dataBaseRow["codciudad"];
                        $Entity->codRuta            = $dataBaseRow["codruta"];
                        $Entity->contacto           = trim($dataBaseRow["contacto"]);
                        $Entity->urbanizacion       = trim($dataBaseRow["urbanizacion"]);
                        $Entity->telefonoCelular    = trim($dataBaseRow["celular"]);
                        
                        $Entity->codEstado          = $dataBaseRow["codestado"];
                        $Entity->nombreEstado       = trim($dataBaseRow["nombreestado"]);
                        $Entity->nombreCiudad       = trim($dataBaseRow["nombreciudad"]);
                        
                        $ProveedorList->add($Entity);                    
            		}		
            	}else{
            	    $ProveedorList->codResponse = MainClass::COD_RESPONSE_ERROR_030;
                    $ProveedorList->messageResponse = MainClass::MSG_RESPONSE_ERROR_030;           
            	}                                   
            }
                        
        } catch (Exception $excp) {
            $ProveedorList->codResponse = MainClass::COD_RESPONSE_ERROR_100;
            $ProveedorList->messageResponse = MainClass::MSG_RESPONSE_ERROR_100; 
        }        
             
        return $ProveedorList;                 
    }
    
    /**
     * ProveedorBusiness::getProveedores_ClienteByReport()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $nombreProveedor
     * @param mixed $estatus
     * @param mixed $codCiudad
     * @param mixed $contactoProveedor
     * @param mixed $cantidadRegistros
     * @param mixed $orderBy
     * @return
     */
    function getProveedores_ClienteByReport(
                $codUsuario, 
                $tokenAuthorization, 
                $codClienteMaster,
                $codCliente, 
                $nombreProveedor, 
                $estatus, 
                $codCiudad, 
                $nombreCiudad, 
                $contactoProveedor, 
                $cantidadRegistros, 
                $orderBy,
                $parentsOptionView){
        
       	$ProveedorList = new EntitieListResponse();    
        $ProveedorList->codResponse = MainClass::COD_RESPONSE_SUCCESSFULLY;
        $ProveedorList->messageResponse = MainClass::MSG_RESPONSE_SUCCESSFULLY; 
        $ProveedorList->entityName = MainClass::ENTITY_NAME_PROVEEDOR;
        $IsClientParents = MainClass::COD_OPERATION_FAILED;        
        if($codClienteMaster != $codCliente){ $IsClientParents = MainClass::COD_OPERATION_SUCESFULLY; }
                
        try {
            
            //Se procede a validar todas las reglas de negocio asociadas a la consulta de proveedores en formato reporte 
            if($this->validateBusinessRule_GetProveedorsByReport($codUsuario, $tokenAuthorization, $codClienteMaster, $ProveedorList->codResponse, $ProveedorList->messageResponse, $estatus) == MainClass::COD_OPERATION_SUCESFULLY){                
                
                if($IsClientParents == MainClass::COD_OPERATION_SUCESFULLY){
                    $dataBaseResult = $this->ProveedorDAL->getProveedores_ClienteParentsByReport($codClienteMaster, $codCliente, $nombreProveedor, $estatus, $codCiudad,$nombreCiudad, $contactoProveedor, $cantidadRegistros, $orderBy); 
                }else{
                    $dataBaseResult = $this->ProveedorDAL->getProveedores_ClienteByReport(
                        $codClienteMaster, 
                        $nombreProveedor, 
                        $estatus, 
                        $codCiudad, 
                        $nombreCiudad, 
                        $contactoProveedor, 
                        $cantidadRegistros, 
                        $orderBy,
                        $parentsOptionView);                    
                }
                
            	if($dataBaseResult && pg_num_rows($dataBaseResult)>0) {
            		while($dataBaseRow = pg_fetch_assoc($dataBaseResult)) {
            			$Entity = new Proveedor();	
                        
                        $Entity->codProveedor       = $dataBaseRow["codproveedor"];
                        
                        //Aqui se define el esquema de Cliente Master a la hora de retornar la lista de recolectas
                        //de un cliente que no sea el Cliente directo del Sistema Recolecta
                        if($IsClientParents == MainClass::COD_OPERATION_SUCESFULLY){
                             $Entity->codClienteMaster   = $dataBaseRow["codcliente"];
                             $Entity->codCliente         = $dataBaseRow["codclienteparent"];
                        }else{                              
                            $Entity->codClienteMaster   = $dataBaseRow["codcliente"];
                            $Entity->codCliente         = $dataBaseRow["codcliente"];                 
                        }
                        
                        $Entity->nombre             = trim($dataBaseRow["nombre"]);                        
                        $Entity->direccion          = trim($dataBaseRow["direccion"]);
                        $Entity->telefono           = trim($dataBaseRow["telefono"]);
                        $Entity->fax                = $dataBaseRow["fax"];
                        $Entity->inactivo           = $dataBaseRow["inactivo"];
                        $Entity->codCiudad          = $dataBaseRow["codciudad"];
                        $Entity->codRuta            = $dataBaseRow["codruta"];
                        $Entity->contacto           = trim($dataBaseRow["contacto"]);
                        $Entity->urbanizacion       = trim($dataBaseRow["urbanizacion"]);
                        $Entity->telefonoCelular    = trim($dataBaseRow["celular"]);
                        
                        $Entity->codEstado          = $dataBaseRow["codestado"];
                        $Entity->nombreEstado       = trim($dataBaseRow["nombreestado"]);
                        $Entity->nombreCiudad       = trim($dataBaseRow["nombreciudad"]);
                                            
                        $ProveedorList->add($Entity);                    
            		}		
            	}else{
            	    $ProveedorList->codResponse = MainClass::COD_RESPONSE_ERROR_030;
                    $ProveedorList->messageResponse = MainClass::MSG_RESPONSE_ERROR_030;           
            	}                                   
            }
                        
        } catch (Exception $excp) {
            $ProveedorList->codResponse = MainClass::COD_RESPONSE_ERROR_100;
            $ProveedorList->messageResponse = MainClass::MSG_RESPONSE_ERROR_100; 
        }        
             
        return $ProveedorList;                 
    }    
    
    /**
     * ProveedorBusiness::validateBusinessRule_InsertProveedor()
     * 
     * @param mixed $Proveedor
     * @param mixed $codResponse
     * @param mixed $messageResponse
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @return
     */
    public function validateBusinessRule_InsertProveedor(&$Proveedor,&$codResponse,&$messageResponse, $codUsuario, $tokenAuthorization){
        
        $processCompleted = MainClass::COD_OPERATION_SUCESFULLY;                  
        $processCompleted = $this->validateBusinessRule($Proveedor, $codResponse, $messageResponse, $codUsuario, $tokenAuthorization);        
        $Proveedor->codProveedor = $this->getCodProveedor();
        
        return $processCompleted;              
    }
    
    /**
     * ProveedorBusiness::validateBusinessRule_UpdateProveedor()
     * 
     * @param mixed $Proveedor
     * @param mixed $codResponse
     * @param mixed $messageResponse
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @return
     */
    public function validateBusinessRule_UpdateProveedor(&$Proveedor,&$codResponse,&$messageResponse, $codUsuario, $tokenAuthorization){
        
        $processCompleted = MainClass::COD_OPERATION_SUCESFULLY;  
        
        //Aplicamos las reglas de negocios de edicion de proveedor
        
        //Validamos que el Cliente Exista
        if($this->validateCliente($Proveedor->codClienteMaster) == MainClass::COD_OPERATION_FAILED){        
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_001;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_001;
             return $processCompleted;            
        }
        
        //Validamos que el proveedor Exista
        if($this->validateProveedor($Proveedor->codProveedor, $Proveedor->codClienteMaster) == MainClass::COD_OPERATION_FAILED){
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_026;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_026;
             return $processCompleted;             
        }
                 
        //Aplicamos las reglas negocio generales del Proceso                
        $processCompleted = $this->validateBusinessRule($Proveedor, $codResponse, $messageResponse, $codUsuario, $tokenAuthorization);
                
        return $processCompleted;                
    }
    
     /**
      * ProveedorBusiness::validateBusinessRule()
      * 
      * @param mixed $Proveedor
      * @param mixed $codResponse
      * @param mixed $messageResponse
      * @param mixed $codUsuario
      * @param mixed $tokenAuthorization
      * @return
      */
     public function validateBusinessRule(&$Proveedor,&$codResponse,&$messageResponse, $codUsuario, $tokenAuthorization){
             
        $processCompleted = MainClass::COD_OPERATION_SUCESFULLY;
        
        $Proveedor->nombre = strtoupper($Proveedor->nombre);
        $Proveedor->direccion = strtoupper($Proveedor->direccion);
        $Proveedor->contacto = strtoupper($Proveedor->contacto);
        $Proveedor->urbanizacion = strtoupper($Proveedor->urbanizacion);
        
        //Asignamos las variables de inactivo
        if($Proveedor->inactivo == MainClass::COD_ENTITY_ACTIVO_STRING){            
             $Proveedor->inactivo = MainClass::COD_ENTITY_ACTIVO_VALUE;  
        }else{
           $Proveedor->inactivo = MainClass::COD_ENTITY_INACTIVO_VALUE;
        }
        
        //Validamos que los valores requeridos hayan sido suministrados        
        if(!isset($Proveedor->nombre) || $Proveedor->nombre == MainClass::COD_STRING_EMPTY){
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_018;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_018;
             return $processCompleted;             
        }
        
        if(!isset($Proveedor->direccion) || $Proveedor->direccion == MainClass::COD_STRING_EMPTY){
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_019;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_019;
             return $processCompleted;             
        }
        
        if(!isset($Proveedor->inactivo) || $Proveedor->inactivo == MainClass::COD_STRING_EMPTY){
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_020;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_020;
             return $processCompleted;             
        }
        
         if(!isset($Proveedor->codCiudad) || $Proveedor->codCiudad == MainClass::COD_STRING_EMPTY){
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_021;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_021;
             return $processCompleted;             
        }
        
        //if(!isset($Proveedor->codRuta) || $Proveedor->codRuta == MainClass::COD_STRING_EMPTY){
//             $processCompleted = MainClass::COD_OPERATION_FAILED;
//             $codResponse = MainClass::COD_RESPONSE_ERROR_022;
//             $messageResponse = MainClass::MSG_RESPONSE_ERROR_022;
//             return $processCompleted;             
//        }

        if(!isset($Proveedor->codRuta) || $Proveedor->codRuta == MainClass::COD_STRING_EMPTY){
             $Proveedor->codRuta = 0;             
             return $processCompleted;             
        }
        
        if(!isset($Proveedor->contacto) || $Proveedor->contacto == MainClass::COD_STRING_EMPTY){
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_023;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_023;
             return $processCompleted;             
        }
        
        if(!isset($Proveedor->urbanizacion) || $Proveedor->urbanizacion == MainClass::COD_STRING_EMPTY){
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_024;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_024;
             return $processCompleted;             
        }
        
        if(!isset($Proveedor->telefonoCelular) || $Proveedor->telefonoCelular == MainClass::COD_STRING_EMPTY){
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_031;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_031;
             return $processCompleted;             
        }
        
        //Validamos que la ciudad asociada al Proveedor coincida con la ciudad asociada al cliente        
        //if($this->validateCodCiudadCliente($Proveedor->codCiudad, $Proveedor->codClienteMaster) == MainClass::COD_OPERATION_FAILED){        
//             $processCompleted = MainClass::COD_OPERATION_FAILED;
//             $codResponse = MainClass::COD_RESPONSE_ERROR_025;
//             $messageResponse = MainClass::MSG_RESPONSE_ERROR_025;
//             return $processCompleted;            
//        }
        
               
        return $processCompleted;              
    }   
    
    /**
     * ProveedorBusiness::validateBusinessRule_GetProveedores()
     * 
     * @param mixed $codCliente
     * @param mixed $codResponse
     * @param mixed $messageResponse
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @return
     */
    public function validateBusinessRule_GetProveedores($codCliente, &$codResponse, &$messageResponse, $codUsuario, $tokenAuthorization){
        
        $processCompleted = MainClass::COD_OPERATION_SUCESFULLY;  
        
        //Aplicamos las reglas de negocios de consulta de proveedores
        //Validamos la autenticacion de la persona que invoca el servicio debe estar invocado desde el usuario asignado al Sistema Guia Electronica
        if($this->validateAuthentication($codUsuario, $tokenAuthorization) == MainClass::COD_OPERATION_FAILED){       
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_099;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_099;             
             return $processCompleted;            
        }
        
        //Validamos que el Cliente Exista dentro del Sistema
        if($this->validateCliente($codCliente) == MainClass::COD_OPERATION_FAILED){        
             $processCompleted = MainClass::COD_OPERATION_FAILED;
             $codResponse = MainClass::COD_RESPONSE_ERROR_001;
             $messageResponse = MainClass::MSG_RESPONSE_ERROR_001;
             return $processCompleted;            
        }  
                
        return $processCompleted;                
    }
    
    
    /**
     * ProveedorBusiness::validateBusinessRule_GetProveedorsByReport()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codCliente
     * @param mixed $codResponse
     * @param mixed $messageResponse
     * @param mixed $estatus
     * @return
     */
    public function validateBusinessRule_GetProveedorsByReport($codUsuario, $tokenAuthorization, $codCliente, &$codResponse, &$messageResponse, &$estatus){
        
        $processCompleted = MainClass::COD_OPERATION_SUCESFULLY;  
               
        //Asignamos las variables de inactivo
        if($estatus != MainClass::COD_STRING_ALL){
            if($estatus == MainClass::COD_ENTITY_ACTIVO_STRING){            
             $estatus = MainClass::COD_ENTITY_ACTIVO_VALUE;  
            }else{
               $estatus = MainClass::COD_ENTITY_INACTIVO_VALUE;
            }   
        }        
        
        //Aplicamos las reglas negocio generales del Proceso                
        $processCompleted = $this->validateBusinessRule_GetProveedores($codCliente, $codResponse, $messageResponse, $codUsuario, $tokenAuthorization);
                
        return $processCompleted;                
    }
    
    /**
     * ProveedorBusiness::validateCliente()
     * 
     * @param mixed $codCliente
     * @return
     */
    function validateCliente($codCliente){
        
        $proveedorExists = MainClass::COD_OPERATION_SUCESFULLY;
        
        try {
            
            $dataBaseResult = $this->RecolectaDAL->getCliente($codCliente); 
        	if($dataBaseResult && pg_num_rows($dataBaseResult)>0) {        		
                 $codProveedor = pg_result($dataBaseResult,'0',"codcliente");
                 
                 if(!isset($codProveedor) || $codProveedor == MainClass::COD_STRING_EMPTY){
                    $proveedorExists = MainClass::COD_OPERATION_FAILED;
                 }
                 
        	}else{
        	     $proveedorExists = MainClass::COD_OPERATION_FAILED;          
        	}
                        
        } catch (Exception $excp) {
             $proveedorExists = MainClass::COD_OPERATION_FAILED; 
        }
        
        return $proveedorExists;        
    }
        
    /**
     * ProveedorBusiness::validateProveedor()
     * 
     * @param mixed $codProveedor
     * @param mixed $codCliente
     * @return
     */
    function validateProveedor($codProveedor, $codCliente){
        
        $proveedorExists = MainClass::COD_OPERATION_SUCESFULLY;
        
        try {
            
            $dataBaseResult = $this->ProveedorDAL->getProveedor_Cliente($codProveedor, $codCliente); 
        	if($dataBaseResult && pg_num_rows($dataBaseResult)>0) {        		
                 $codProveedor = pg_result($dataBaseResult,'0',"codproveedor");
                 
                 if(!isset($codProveedor) || $codProveedor == MainClass::COD_STRING_EMPTY){
                    $proveedorExists = MainClass::COD_OPERATION_FAILED;
                 }
                 
        	}else{
        	     $proveedorExists = MainClass::COD_OPERATION_FAILED;          
        	}
                        
        } catch (Exception $excp) {
             $proveedorExists = MainClass::COD_OPERATION_FAILED; 
        }
        
        return $proveedorExists;        
    }
    
    /**
     * ProveedorBusiness::validateCodCiudadCliente()
     * 
     * @param mixed $codCiudadProveedor
     * @param mixed $codCliente
     * @return
     */
    function validateCodCiudadCliente($codCiudadProveedor, $codCliente){
        
        $codCiudadIsValid = MainClass::COD_OPERATION_SUCESFULLY;
        
        try {
            
            $dataBaseResult = $this->ProveedorDAL->getOficina_Cliente($codCliente); 
        	if($dataBaseResult && pg_num_rows($dataBaseResult)>0) {        		
                 $codCiudad = pg_result($dataBaseResult,'0',"codciudad");
                 
                 if(!isset($codCiudad) || $codCiudad == MainClass::COD_STRING_EMPTY){
                    $codCiudadIsValid = MainClass::COD_OPERATION_FAILED;
                 }else if($codCiudadProveedor != $codCiudad){
                    $codCiudadIsValid = MainClass::COD_OPERATION_FAILED;
                 }                 
                 
        	}else{
        	     $codCiudadIsValid = MainClass::COD_OPERATION_FAILED;          
        	}
                        
        } catch (Exception $excp) {
             $codCiudadIsValid = MainClass::COD_OPERATION_FAILED; 
        }
        
        return $codCiudadIsValid;        
    }
    
    /**
     * ProveedorBusiness::addProveedor()
     * 
     * @param mixed $Proveedor
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @return
     */
    public function addProveedor($Proveedor, $codUsuario, $tokenAuthorization){
	            
        $EntitieResponse = new EntitieResponse();  
        $EntitieResponse->entityName = MainClass::ENTITY_NAME_PROVEEDOR;   
        $IsClientParents = MainClass::COD_OPERATION_FAILED;        
        if($Proveedor->codClienteMaster != $Proveedor->codCliente){ $IsClientParents = MainClass::COD_OPERATION_SUCESFULLY; }        
                
        try {
            
            //Se procede a validar todas las reglas de negocio asociadas a la creacion de una recolecta 
            if($this->validateBusinessRule_InsertProveedor($Proveedor, $EntitieResponse->codResponse, $EntitieResponse->messageResponse, $codUsuario, $tokenAuthorization) == "true"){                
                $dataBaseResult = $this->ProveedorDAL->addProveedor($Proveedor);
                if($dataBaseResult == MainClass::COD_OPERATION_SUCESFULLY){
                    //Actualizamos la tabla de codigos de proveedor
                    $this->ProveedorDAL->editMaximoProveedor($Proveedor->codProveedor);
                    
                    //Aqui validamos si el codigo del cliente Master y el codigo del cliente Coinciden
                    //en caso de coincidir se trata del Cliente directo de ZOOM quien crea la recolecta
                    //en caso de que no es un cliente indirecto de zoom quien esta creando la recolecta 
                    //procedemos a crear la relacion entre el cliente indirecto, el cliente ZOOM y la recolecta
                    if($IsClientParents == MainClass::COD_OPERATION_SUCESFULLY){
                        $this->ProveedorDAL->addProveedorSysGuiaElectronica($Proveedor); 
                    } 
                                        
                    $EntitieResponse->codResponse = MainClass::COD_RESPONSE_SUCCESSFULLY_004;
                    $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_SUCCESSFULLY_004;
                }else{                    
                    $EntitieResponse->codResponse = MainClass::COD_RESPONSE_ERROR_029;
                    $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_ERROR_029;                    
                }                    
            }                        	
                        
        } catch (Exception $excp) {
            $EntitieResponse->codResponse = MainClass::COD_RESPONSE_ERROR_100;
            $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_ERROR_100; 
        }   
                         
        $EntitieResponse->entity = $Proveedor;  
        return $EntitieResponse;    	
    }
    
    /**
     * ProveedorBusiness::editProveedor()
     * 
     * @param mixed $Proveedor
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @return
     */
    public function editProveedor($Proveedor, $codUsuario, $tokenAuthorization){
	            
        $EntitieResponse = new EntitieResponse();  
        $EntitieResponse->entityName = MainClass::ENTITY_NAME_PROVEEDOR;          
                
        try {
            
            //Se procede a validar todas las reglas de negocio asociadas a la creacion de una recolecta 
            if($this->validateBusinessRule_UpdateProveedor($Proveedor, $EntitieResponse->codResponse, $EntitieResponse->messageResponse, $codUsuario, $tokenAuthorization) == "true"){                
                $dataBaseResult = $this->ProveedorDAL->editProveedor($Proveedor);
                if($dataBaseResult == MainClass::COD_OPERATION_SUCESFULLY){
                                                                                
                    $EntitieResponse->codResponse = MainClass::COD_RESPONSE_SUCCESSFULLY_005;
                    $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_SUCCESSFULLY_005;
                }else{                    
                    $EntitieResponse->codResponse = MainClass::COD_RESPONSE_ERROR_027;
                    $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_ERROR_027;                    
                }                    
            }                        	
                        
        } catch (Exception $excp) {
            $EntitieResponse->codResponse = MainClass::COD_RESPONSE_ERROR_100;
            $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_ERROR_100; 
        }
                         
        $EntitieResponse->entity = $Proveedor;  
        return $EntitieResponse;    	
    }
        




    
    /**
     * ProveedorBusiness::deleteProveedor()
     * 
     * @param mixed $Proveedor
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @return
     */
    /*public function deleteProveedor($Proveedor, $codUsuario, $tokenAuthorization){
	            
        $EntitieResponse = new EntitieResponse();  
        $EntitieResponse->entityName = MainClass::ENTITY_NAME_PROVEEDOR;          
                
        try {
            
            //Se procede a validar todas las reglas de negocio asociadas a la creacion de una recolecta 
            if($this->validateBusinessRule_UpdateProveedor($Proveedor, $EntitieResponse->codResponse, $EntitieResponse->messageResponse, $codUsuario, $tokenAuthorization) == "true"){                
                $dataBaseResult = $this->ProveedorDAL->deleteProveedor($Proveedor);
                if($dataBaseResult == MainClass::COD_OPERATION_SUCESFULLY){
                                                                                
                    $EntitieResponse->codResponse = MainClass::COD_RESPONSE_SUCCESSFULLY_005;
                    $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_SUCCESSFULLY_005;
                }else{                    
                    $EntitieResponse->codResponse = MainClass::COD_RESPONSE_ERROR_027;
                    $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_ERROR_027;                    
                }                    
            }                        	
                        
        } catch (Exception $excp) {
            $EntitieResponse->codResponse = MainClass::COD_RESPONSE_ERROR_100;
            $EntitieResponse->messageResponse = MainClass::MSG_RESPONSE_ERROR_100; 
        }
                         
        $EntitieResponse->entity = $Proveedor;  
        return $EntitieResponse;    	
    }*/
        







    /**
     * ProveedorBusiness::validateNull()
     * 
     * @return
     */
    public function validateNull(){
        
        
    }
            
}//END CLASS RecolectaBusiness

?>