<?
//Agregado por Maria Neto el 01/10/2014


// clase de abstraccin de datos para postgresql
// Carlos De Oliveira (ult modf: mar 2011)
class genericDB {   	
		// private attributes
		var $_field;
		var $_value;
		var $_type;
		var $_pk;
		var $_table;
		var $_message;
		var $_newfield;
		var $result;
		var $_isnew;
		var $_debug;
		var $_size;
		
				
		//Agregado por mMaria Neto el 11/12/2014
		function execute($query){
			@pg_Exec($query);
		}
		
		//Agregado por mMaria Neto el 11/12/2014
		function execute2($query){
			@pg_Exec($query);
			pg_freeresult($query);
		}

		function genericDB($table) // constructor
		{			
			// se obtiene la informacion de los campos y clave primaria
			$this->_table = $table;
			$this->_field = array();
			$this->_value = array();
  			$this->_type = array();
			$this->_newfield = array();
			$this->_isnew = false;
			$this->_debug = false;
			
			$query = "
				SELECT
					pg_attribute.attname					
				FROM
					pg_index,
					pg_class,
					pg_attribute
				WHERE
					pg_class.oid = '".$this->_table."'::regclass
					AND	indrelid = pg_class.oid
					AND pg_attribute.attrelid = pg_class.oid
					AND pg_attribute.attnum = any(pg_index.indkey)
					AND indisprimary;";
					
			$r = pg_query($query);
			$a = pg_fetch_assoc($r);
			$this->_pk = $a["attname"]; // Sets primary key
			
			pg_free_result($r);
		
			$query = " SELECT
						a.attnum,
						a.attname AS field,
						t.typname AS type,
						a.attlen AS length,
						a.atttypmod AS lengthvar,
						a.attnotnull AS notnull
					FROM
						pg_class c,
						pg_attribute a,
						pg_type t
					WHERE
						c.relname = '".$this->_table."'
						and a.attnum > 0
						and a.attrelid = c.oid
						and a.atttypid = t.oid
					ORDER BY a.attnum";
					

			$r = pg_query($query);
			if($r && pg_num_rows($r)>0) {
				while($row = pg_fetch_array($r)) {
					$campo = $row['field'];
					if($row['field']!=$this->_pk) $this->_field[] = $campo;						
					$this->_type[$campo] = $row['type'];
					$this->_size[$campo] = $row['lengthvar'];
				}
			}
		
						
			$this->_value[$this->_pk] = (strpos($this->_type[$this->_pk],"int")!==false)?0:"";
			//$this->_value[$this->_pk] = 0;
			$this->_message = array(
					"msg_delete" => "El registro fue eliminado.",
					"msg_update" => "Registro actualizado.",
					"msg_insert" => "Registro guardado."
			 );
		}				
		
		function Debug($value) {
			if(is_bool($value)) $this->_debug = $value;
		}
		
		function isNew() { // verifica si cuando se salva un registro se crea uno nuevo o se actualiza uno antiguo (solo despues de ->Save();
			return $this->_isnew;
		}

		function setId($value)
		{
			$this->_value[$this->_pk] = $value;
		}

		function getId()
		{
			return $this->_value[$this->_pk];		
		}

		function getFields()
		{
			return $this->_field;
		}

		function value($field)
		{
			return($this->_value[$field]);
		}

		function assign($field, $value) // igual a la function set
		{
			if(in_array($field,$this->_field)) { 
			     $tipo = $this->_type[$field];
				 if(strpos($tipo,"int")!==false) {
					$value = intval($value);	 
				 }				 
				 if(strpos($tipo,"float")!==false) {
					$value = floatval($value); 
				 }
 				 if(strpos($tipo,"varchar")!==false || strpos($tipo,"text")!==false) {
					$value = pg_escape_string($value);
				 }
				 if(strpos($tipo,"varchar")!==false) { 
					$size = intval($this->_size[$field])-5;
					if(strlen($value)>$size) $value = substr($value,0,$size);
				 }
				 $this->_value[$field] = $value;			
				 if(!in_array($field,$this->_newfield)) $this->_newfield[] = $field;
			} 
		}

		function set($field, $value) { // alias para la function assign
			$this->assign($field, $value);
		}
		
		function get($field) {
			return($this->_value[$field]);
		}
		// get data 
		function Read()
		{
			$query = "SELECT * FROM ".$this->_table." where ".$this->_pk." = '".$this->_value[$this->_pk]."'";
			if($this->_debug) echo($query."<br>\n");
			$result = pg_query($query);
			if(pg_num_rows($result)>0) 
			{
				$this->_newfield = array();
				$row = pg_fetch_array($result);
				foreach($this->_field as $k) $this->_value[$k] = $row[$k];
				return true;				
			}
			return false;
		}
		
		function ReadAll()
		{
			$query = "SELECT * FROM ".$this->_table." where ".$this->_pk." = '".$this->_value[$this->_pk]."'";
			if($this->_debug) echo($query."<br>\n");
			$result = pg_query($query);
			if(pg_num_rows($result)>0) 
			{
				$row = pg_fetch_array($result);
				foreach($this->_field as $k) {
					$this->_value[$k] = $row[$k];
					$this->_newfield[] = $k;
				}
				return true;				
			}
			return false;
		}
		
		function getRow($iditem = "") { 
			if($iditem=="")  $iditem= $this->_value[$this->_pk];
			$query = "SELECT ".implode(", ",$this->_field)." FROM ".$this->_table." where ".$this->_pk." = ".$iditem." LIMIT 1";
			if($this->_debug) echo($query."<br>\n");
			$result = pg_query($query);
			if(pg_num_rows($result)>0) 
			{
				return pg_fetch_assoc($result);
			}
			$arr = array();
			foreach($this->_field as $k) $arr[$k]="";
			return $arr;			
		}
		
		function ExistsItem($iditem) // verify if exists a query in database
		{
			$result = pg_query("SELECT * FROM ".$this->_table." WHERE ".$this->_pk." =  '$iditem';");
			return ($result && pg_num_rows($result)>0);
		}		
				
		function Save()
		{
			$arraypost=array();
			$this->_isnew = false;
			if(count($this->_newfield)==0) return true;
			foreach($this->_newfield as $k) 
			{	
				$necesitacomillas = true;
				$valor ="";
				$valor = $this->_value[$k];				
				$tipo = $this->_type[$k];				
				if(strtolower($valor)=="current_timestamp" || strtolower($valor)=="now()") $necesitacomillas = false;
				if(strtolower($valor)=="null") $necesitacomillas=false;
				if($necesitacomillas) $valor = "'".$valor."'"; 
				$arraypost[]="$k=".$valor;				
				$campos[] = $k;
				$valores[] = $valor;
			}
			if(in_array("ip",$this->_field)) {
				$campos[] = "ip";
				$valores[] = "'".$_SERVER['REMOTE_ADDR']."'";
			}
			if(in_array("fecha_modificacion",$this->_field) && !in_array("fecha_modificacion",$this->_newfield)) {
				$campos[] = "fecha_modificacion";
				$valores[] = "current_timestamp";
			}
			$query = "SELECT * FROM ".$this->_table." where ".$this->_pk." = '".intval($this->_value[$this->_pk])."' LIMIT 1;";
			if($this->_debug) echo($query."<br>\n");
			$result = pg_query($query);			
			if($result && pg_num_rows($result)>0)
			{				
				$query = "UPDATE ".$this->_table." SET ".implode(", ",$arraypost)." WHERE ".$this->_pk." = '".$this->_value[$this->_pk]."'";
				//echo($query."<br>");
				if($this->_debug) echo($query."<br>\n");
				pg_query($query);
				$this->_newfield = array();
				$this->result = $this->_message['msg_update'];
			} else {
				$has = "";
				if(!empty($this->_pk)) { $has = " returning ".$this->_pk; }							
				$query = "INSERT INTO ".$this->_table." (".implode(", ",$campos).") VALUES (".implode(", ",$valores).")".$has;				
				//echo($query."<br>\n");
				if($this->_debug) echo($query."<br>\n");
				$result = pg_query($query);	
				if($result===false) {
					//echo($query);
					//exit();	
				}
				if(pg_num_rows($result)>0) { 
					$row = pg_fetch_array($result);
					$this->_value[$this->_pk] = $row[0];	
					$this->_newfield = array();			
				}
				$this->_isnew = true;
				$this->result = $this->_message['msg_insert'];						
				$this->result = "INSERT INTO ".$this->_table." SET ".implode(', ',$arraypost);
			}
			return true;
		}		
		

		function Delete()
		{
			if($this->Read()) { 
				pg_query("DELETE FROM ".$this->_table." WHERE ".$this->_pk."= '".$this->_value[$this->_pk]."';");			
				$this->result = $this->_message['msg_delete'];
				return true;
			}
			return false;
		}

}	


?>