<?php

// ******************************************************************
// CLASE PRINCIPAL PARA EL CALCULO DE TARIFAS
// ******************************************************************
	

class ZoomTarifa {	

	// Parametros de entrada
	var $_sestipotarifa;
	var $_sescodservicio;
	var $_id_ciudad_origen;
	var $_id_ciudad_destino;
	var $_id_oficina_destino;
	var $_cant_piezas;
	var $_peso_bruto;
	var $_valor_mercancia;
	var $_valor_declarado;
	
	var $_today;
	
	// para calcular
	var $_flete; 
	var $_seguro;
	var $_subtotalfle;
	var $_totaliva;
	var $_tasapos;
	var $_totalpag;
	var $_combustible;
	
	//PARAMETROS PARA EL CALCULO DE TARIFA INTERNACIONAL
	var $_id_pais_destino;
	var $_tipoenvio;
	var $_zipcode;
	var $_alto;
	var $_ancho;
	var $_largo;
	
	// errores
	var $hayerror;
	var $mensaje_de_error;
	
	function ZoomTarifa() {
		$this->hayerror = false;
		$this->mensaje_de_error = "";	
		$this->_today= date("Y-m-d");
	}
	
	function setTipoTarifa($sestipotarifa) { // 1 COD, 2 NACIONAL, 3 INTERNACIONAL
		$this->_sestipotarifa = intval($sestipotarifa);	
	}
	
	function setTipoServicio($sescodservicio) { // 1 RETIRAR POR OFICINA, 2 PUERTA A PUERTA
		$this->_sescodservicio = intval($sescodservicio);	
	}

	function setIdCiudadOrigen($id_ciudad_origen) {
		$this->_id_ciudad_origen = intval($id_ciudad_origen);	
	}
	
	function setIdCiudadDestino($id_ciudad_destino) {
		$this->_id_ciudad_destino = intval($id_ciudad_destino);
	}

	function setIdOficinaDestino($id_oficina_destino) {
		$this->_id_oficina_destino = intval($id_oficina_destino);
	}
	
	function setCantPiezas($cant_piezas) {
		$this->_cant_piezas = intval($cant_piezas);	
	}

	function setPesoBruto($peso_bruto) {
		$this->_peso_bruto = floatval($peso_bruto);	
	}

	function setValorMercancia($valor_mercancia) {
		$this->_valor_mercancia = floatval($valor_mercancia);	
	}

	function setValorDeclarado($valor_declarado) {	
		$this->_valor_declarado = floatval($valor_declarado);	
	}
	
	//INTERNACIONAL
	function setIdPaisDestino($id_pais_destino) {
		$this->_id_pais_destino = intval($id_pais_destino);
	}

	function setZipCode($zipcode) {
		$this->_zipcode = intval($zipcode);
	}
	
	function setTipoEnvio($tipoenvio) { // D - DOCUMENTO, M - MERCANCIA
		if($tipoenvio=='D'){
			$this->_tipoenvio = 1;
		}else if($tipoenvio=='M'){
			$this->_tipoenvio = 2;
		}else{
			$this->_tipoenvio = 0;
		}
	}
	
	function setAlto($alto){
		$this->_alto = intval($alto);
	}

	function setAncho($ancho){
		$this->_ancho = intval($ancho);
	}

	function setLargo($largo){
		$this->_largo = intval($largo);
	}

	// FUNCIONES CALCULADAS		
	function getFlete() {
		return round($this->_flete,2);	
	}

	function getSeguro() {
		return round($this->_seguro,2);	
	}
	
	function getSubtotal() {
		return round($this->_subtotalfle,2);	
	}

	function getTotalIVA() {
		return round($this->_totaliva,2);	
	}

	function getTasaPostal() {
		return round($this->_tasapos,2);	
	}
	
	function getTotalAPagar() {
		return round($this->_totalpag,2);	
	}
	
	//INTERNACIONAL
	function getCombustible() {
		return round($this->_combustible,2);	
	}
	//FUNCION QUE RETORNA LOS MENSAJES DE ERROR
	function getError() {		
		return $this->mensaje_de_error;	
	}
}
?>