<?php

class ZoomTarifaInternacional extends ZoomTarifa {
	function CalcularTarifaInt() {
		$sestipotarifa = $this->_sestipotarifa;
		$id_ciudad_origen = $this->_id_ciudad_origen;
		$id_pais_destino = $this->_id_pais_destino;
		$tipoenvio = $this->_tipoenvio;
		$cant_piezas = $this->_cant_piezas;
		$peso_bruto = $this->_peso_bruto;
		$zipcode = $this->_zipcode;
		$alto=$this->_alto;
		$ancho=$this->_ancho;
		$largo=$this->_largo;

		$valor_declarado = $this->_valor_declarado;
		
		

		// VALIDACIONES
		if($id_ciudad_origen==0 || $id_ciudad_origen=='' || !(is_numeric($id_ciudad_origen))) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "El valor de La ciudad del Remitente es incorrecto";
			return false;
		}

		if($id_pais_destino==0 || $id_pais_destino=='' || !(is_numeric($id_pais_destino))) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "El valor del Pais del Destinatario es incorrecto";
			return false;
		}

		if($cant_piezas<0 || $cant_piezas=='' || !(is_numeric($cant_piezas))) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "El valor de La Cantidad de Piezas es incorrecto";
			return false;	
		}

		if($peso_bruto<0 || $peso_bruto=='' || !(is_numeric($peso_bruto))) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "El valor del Peso Bruto es incorrecto";
			return false;	
		}
		
		if(	$tipoenvio!=1 && $tipoenvio!=2 ) {
			$this->hayerror = true;
			$this->mensaje_de_error = "El codigo del Tipo de Envio debe ser D o M";					
			return false;
		}

		//VALOR DEL RANGO PARA LA CLAVE DE APROBACIN
		$query="SELECT valormin, valormax, porcentaje FROM seguroint WHERE '".date("Y-m-d")."'>=fechaini ORDER BY fechaini DESC LIMIT 1";
		$number=0;
		$result = pg_query($query);
		$number = pg_num_rows($result);
		if ($number>0){
			$row = db::getRow($query);
			$valormin = $row['valormin'];
			$valormax = $row['valormax'];
			$porcentaje = $row['porcentaje'];
		}
		
		//MNIMO VALOR DEL SEGURO
		$query="SELECT min(valormin) AS valormin, fechaini FROM seguroint WHERE '".date("Y-m-d")."'>=fechaini GROUP BY fechaini ORDER BY fechaini DESC LIMIT 1";
		$number=0;
		$result = pg_query($query);
		$number = pg_num_rows($result);
		if ($number>0){
			$row = db::getRow($query);
			$valorminseg = $row['valormin'];
		}

		if($valor_declarado!='' && $tipoenvio==2){
			if (($valor_declarado>$valormax || $valor_declarado<$valorminseg) || !(is_numeric($valor_declarado))) {
				$this->hayerror = true;	
				$this->mensaje_de_error = "El Valor Declarado debe tener un monto mayor a ".$valorminseg." y menor a ".$valormax;
				return false;
			}
		}else{
			$valor_declarado=0;
		}

		if (($alto==0 || $ancho==0 || $largo==0) && $tipoenvio==2){
			$this->hayerror = true;	
			$this->mensaje_de_error = "Los campos Alto, Ancho y Largo no pueden estar Vacios.";
			return false;
		}

		if ($alto>0 && $ancho>0 && $largo>0){
			$alto=$alto/100;
			$ancho=$ancho/100;
			$largo=$largo/100;
			
			$pesovol=($alto*$ancho*$largo)*200;
			$pesovol=round($pesovol,2);
			//$txthpesovol=round($pesovol,2);
		}
		
		if ($tipoenvio==2 && $pesovol>0 && $peso_bruto>0){
			if ($pesovol>$peso_bruto){
				$peso_bruto=$pesovol;
			}
		}

		$query="SELECT funiva('".date("Y-m-d")."', 2,".$id_ciudad_origen.") AS ivaint,funcomplemento('".date("Y-m-d")."', 2,".$id_ciudad_origen.") AS complementoint";
		$fila = db::getRow($query);
		$ivanac = $fila['ivaint'];
		$complementonac = $fila['complementoint'];


		//BUSCO LA ZONA DEL PAIS DESTINO
		$query="SELECT codzona FROM pais WHERE codpais=".$id_pais_destino;
		$codzona = db::getScalar($query);

		//SI EL ZIP CODE ES DE MIAMI, LA ZONA ES 0
		if ($zipcode>0 && $id_pais_destino==1){
			$query="SELECT zipcode FROM zipcode WHERE zipcode='".$zipcode."'";
			$number=0;
			$result = pg_query($query);
			$number = pg_num_rows($result);
			if ($number>0){
				$codzona=0;
			}
		}

		//CALCULO DEL PESO MXIMO PERMITIDO
		$query="SELECT max(pesomax) AS pesomax FROM basicointcol WHERE codzona=".$codzona." and codservicio=".$sestipotarifa." AND codtipoenv=".$tipoenvio." and '".date("Y-m-d")."'>=fechaini GROUP BY basicointcol.fechaini ORDER BY fechaini DESC LIMIT 1";
		$number=0;
		$result = pg_query($query);
		$number = pg_num_rows($result);
		$pesomax=0;
		if ($number>0){
			$row = db::getRow($query);
			$pesomax = $row['pesomax'];
		}

		//CALCULO DEL SOBREPESO
		if ($peso_bruto>$pesomax){
			$kilossob=ceil(($peso_bruto-$pesomax)/0.5);
			$query="SELECT ".$kilossob."*min(sobrepeso)*fundolar('".date("Y-m-d")."') AS sobrepeso FROM sobrepesointcol WHERE codservicio=".$sestipotarifa." AND codzona=".$codzona." AND ".$peso_bruto.">=pesomin AND ".$peso_bruto."<=pesomax AND '".date("Y-m-d")."'>=fechaini GROUP BY sobrepesointcol.fechaini ORDER BY fechaini DESC LIMIT 1";
			$number=0;
			$result = pg_query($query);
			$number = pg_num_rows($result);
			$sobrepeso=0;
			if ($number>0){
				$row = db::getRow($query);
				$sobrepeso = $row['sobrepeso'];
				$sobrepeso=$sobrepeso+($sobrepeso*($complementonac/100));
				$sobrepeso=round($sobrepeso,2);
			}
			//CONDICIN PARA CALCULAR EL BASICO
			$condicionbas=" pesomax=".$pesomax;
		}
		else{
			$kilossob=0;
			//CONDICIN PARA CALCULAR EL BASICO
			$condicionbas=" $peso_bruto>=pesomin and $peso_bruto<=pesomax ";
		}


		//CALCULO DEL BASICO
		$query="SELECT (basico*fundolar('".date("Y-m-d")."')) AS basico from basicointcol WHERE $condicionbas AND codzona=$codzona AND codservicio=$sestipotarifa AND codtipoenv=$tipoenvio AND '".date("Y-m-d")."'>=fechaini ORDER BY fechaini DESC LIMIT 1";
		$number=0;
		$result = pg_query($query);
		$number = pg_num_rows($result);
		$basico=0;
		if ($number>0){
			$row = db::getRow($query);
			$basico = $row['basico'];
			$basico=$basico+($basico*($complementonac/100));
			$basico=round($basico,2);
		}

		//CALCULO DE RECARGO FIJO
		$query="SELECT * FROM otros WHERE codotros2=2 and fecha<='".date("Y-m-d")."' ORDER BY fecha DESC LIMIT 1";
		$row1 = db::getRow($query);
		$valor1 = $row1['valor1'];
		$valor2 = $row1['valor2'];
		
		if($peso_bruto>$valor2){
			$basico=$basico+$valor1;
		}
		$peso=$peso_bruto*1000;
		
		//$subtotalfle=number_format($basico,2,".","")+number_format($sobrepeso,2,".","");
		$subtotalfle=$basico+$sobrepeso;
		$subtotalfle=round($subtotalfle,2);
		$this->_flete = $subtotalfle;

		//CALCULO DEL FRANQUEO
		$query= "SELECT funfpo(".$peso.",0,".$sestipotarifa.",'".date('Y-m-d')."',".$id_pais_destino.",".$this->_flete.") AS tasapos";
		$number=0;
		$result = pg_query($query);
		$number = pg_num_rows($result);
		if ($number>0) {
			$row = db::getRow($query);
			$tasapos = $row['tasapos'];
		} else {
			$tasapos=0;
		}

		if ($valor_declarado>0){
			//APLICA EL PORCENTAJE GENERAL (PARA TODOS)
			$query="SELECT seguro,porcentaje FROM seguroint WHERE valormin<=".$valor_declarado." AND valormax>=".$valor_declarado." AND' ".date("Y-m-d")."'>=fechaini ORDER BY fechaini DESC LIMIT 1";
			$number=0;
			$result = pg_query($query);
			$number = pg_num_rows($result);
			if ($number>0){
				$row = db::getRow($query);
				$seguro = $row['seguro'];
				if ($seguro==0 || $seguro==''){
					$seguro=$valor_declarado*$row['porcentaje'];
				}
			}
		}
		
		$subtotalfle+=$seguro;
		
		//CALCULO DEL RECARGO POR COMBUSTIBLE
		$query="SELECT valor1 FROM otros WHERE codotros2=931 AND fecha<='".date("Y-m-d")."' ORDER BY fecha DESC LIMIT 1";
		$number=0;
		$result = pg_query($query);
		$number = pg_num_rows($result);
		$cargocom=0;
		if ($number>0){
			$row = db::getRow($query);
			//$cargocom = $subtotalfle*pg_result($result2,0,"valor1")/100;
			$cargocom = $subtotalfle*$row['valor1']/100;
		}
		$subtotalfle+=$cargocom;
		
		
		//$this->_seguro = round($seguro,2);
		$this->_seguro = $seguro;
		$this->_combustible = round($cargocom,2);
		$this->_totaliva = round($subtotalfle*($ivanac/100),2);
		$this->_tasapos = $tasapos;
		$this->_totalpag=round($subtotalfle + $this->_totaliva + $this->_tasapos,2);

		return true;
	}
}
?>