<?php
// ******************************************************************
// (c) 2011 - Carlos De Oliveira - Zoom International Services C.A.
// ******************************************************************
	
// ******************************************************************
// MODIFICADO POR FELIX UTRERA -- 12/12/2012
// - Se incluyen los WEBSERVICES getOficinas, getTipoServicio.
// - Se incluye la validacin para el peso maximo por ciudad y por oficina.
// - Se modifica el clculo de tarifa para incluir los servicios de "RETIRAR POR OFICINA" y "PUERTA A PUERTA".
// - Se actualiza el proceso de calculo de tarifa para igualarlo al tarifario de la pgina web.
// ******************************************************************
class ZoomTarifaNacional extends ZoomTarifa {
	function CalcularTarifaNac() {
		//$sescodservicio,$id_ciudad_origen, $id_ciudad_destino, $cant_piezas, $peso_bruto, $valor_declarado, $valor_mercancia
		$sestipotarifa = $this->_sestipotarifa;
		$sescodservicio = $this->_sescodservicio;
		$id_ciudad_origen = $this->_id_ciudad_origen;
		$id_ciudad_destino = $this->_id_ciudad_destino;
		$id_oficina_destino = $this->_id_oficina_destino;
		$cant_piezas = $this->_cant_piezas;
		$peso_bruto = $this->_peso_bruto;
		$valor_mercancia = $this->_valor_mercancia;				
		$valor_declarado = $this->_valor_declarado;

		$today = date("Y-m-d");		
		
		// validaciones
		/*if(	$sestipotarifa!=1 && $sestipotarifa!=2 ) {
			$this->hayerror = true;
			$this->mensaje_de_error = "El codigo del Tipo de Tarifa debe ser 1 o 2";					
			return false;
		}*/

		if($sescodservicio!=1 && $sescodservicio!=2) {
			$this->hayerror = true;
			$this->mensaje_de_error = "El codigo de la modalidad debe ser 1 o 2";					
			return false;
		}

		if($id_ciudad_origen==0 || $id_ciudad_origen=='' || !(is_numeric($id_ciudad_origen))) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "El valor de La ciudad del remitente es incorrecto";
			return false;
		}

		if($id_ciudad_destino==0 || $id_ciudad_destino=='' || !(is_numeric($id_ciudad_destino))) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "El valor de La ciudad del destinatario es incorrecto";
			return false;
		}

		if($sescodservicio==1) {
			if($id_oficina_destino==0 || $id_oficina_destino=='' || !(is_numeric($id_oficina_destino))) {
				$this->hayerror = true;	
				$this->mensaje_de_error = "El valor de La oficina a retirar es incorrecto";
				return false;
			}
		}

		if($cant_piezas<0 || $cant_piezas=='' || !(is_numeric($cant_piezas))) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "El valor de La Cantidad de Piezas es incorrecto";
			return false;	
		}

		if($peso_bruto<0 || $peso_bruto=='' || !(is_numeric($peso_bruto))) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "El valor del Peso Bruto es incorrecto";
			return false;	
		}
		
		if($sestipotarifa == 1){
			if($valor_mercancia!=''){
				if($valor_mercancia < 0 || !(is_numeric($valor_mercancia))) {
					$this->hayerror = true;	
					$this->mensaje_de_error = "El Valor de La Mercancia es incorrecto";
					return false;	
				}
			}
		}
		else{
			$valor_mercancia=0;
		}
		
		if($valor_declarado!=''){
			if($valor_declarado < 50 || !(is_numeric($valor_declarado))) {
				$this->hayerror = true;	
				$this->mensaje_de_error = "El Valor Declarado es incorrecto";
				return false;	
			}
		}
		// ********************************** VALIDACION PESO BRUTO CONTRA EL PESO MAXIMO *********************
		//PESO MAXIMO DE LA OFICINA PORQUE FUE SELECCIONADO EL SERVICIO RETIRAR POR OFICINA
		if($sescodservicio==1){
			$query="SELECT oficina.nombre as nombreofides, ruta.pesomax as pesomax FROM oficina,ruta WHERE oficina.codoficina=ruta.codoficinaret AND ruta.codoficinaret=".$id_oficina_destino." and ruta.retirarofi='t' and ruta.inactivo<>'t' and ruta.pesomax>0";
			$result = pg_query($query);
			while($row = pg_fetch_assoc($result)) {
				$nombreofides = $row['nombreofides'];
				$pesomax = (floatval($row['pesomax']))/1000;
				//$row['fecha'] = db_fecha($row['fecha']);
				//$respuesta[] = $row;
			}
			
			if ($peso_bruto > $pesomax){
				$this->hayerror = true;	
				$this->mensaje_de_error = "El peso maximo de la Oficina $nombreofides es de $pesomax Kg(s). Verifique.";
				return false;
			}
		}
		//PESO MAXIMO POR CIUDAD
		else if($sescodservicio!=1) {
			//PESO MAXIMO CIUDAD COD
			if($sestipotarifa==1) {
				$query="select ciudad.nombre,ciudad.pesomax from ciudad,estado,pais where ciudad.codciudad=".$id_ciudad_destino." AND ciudad.codestado=estado.codestado and (ciudad.inactivo='f' or ciudad.inactivo is null) and ciudad.cod='t' AND estado.codpais=pais.codpais AND pais.codpais=124 order by ciudad.nombre";
				$result = pg_query($query);
				while($row = pg_fetch_assoc($result)) {
				$nombreciudad = $row['nombre'];
				$pesomax = (floatval($row['pesomax']))/1000;
				//$row['fecha'] = db_fecha($row['fecha']);
				//$respuesta[] = $row;
				}
				$pesopie=$peso_bruto/$cant_piezas;
				if ($pesopie > $pesomax){
					$this->hayerror = true;	
					$this->mensaje_de_error = "El peso maximo de la Ciudad $nombreciudad es de $pesomax Kg(s) por pieza. Verifique.";
					return false;
				}
			}
			//PESO MAXIMO CIUDAD NACIONAL
			else{
				$query="select ciudad.nombre,ciudad.pesomax from ciudad,estado,pais where (ciudad.inactivo='f' OR ciudad.inactivo is null) and ciudad.codciudad=".$id_ciudad_destino." AND ciudad.codestado=estado.codestado AND estado.codpais=pais.codpais AND pais.codpais=124 order by ciudad.nombre";
				$result = pg_query($query);
				while($row = pg_fetch_assoc($result)){
					$nombreciudad = $row['nombre'];
					$pesomax = (floatval($row['pesomax']))/1000;
				}
				$pesopie=$peso_bruto/$cant_piezas;
				if ($pesopie > $pesomax){
					$this->hayerror = true;	
					$this->mensaje_de_error = "El peso maximo de la Ciudad $nombreciudad es de $pesomax Kg(s) por pieza. Verifique.";
					return false;
				}
			}
		}
		// ********************************** CALCULOS COMUNES *****************************
		// ivanac (igual cod)
		$query = "select funiva('$today', 1,$id_ciudad_origen) as ivanac";
		$ivanac = floatval(db::getScalar($query));
		
		$query = "SELECT funcomplemento('$today', 1,$id_ciudad_origen) as complementonac";
		$complementonac = floatval(db::getScalar($query));

		$codtipobas=0;
		$codtiposob=0;
		
		//servicio retiro por oficina
		if ($sescodservicio==1)
		{
			//TIPO DE SERVICIO BASICO
			$query="select codtipobas from tipobas where codservicio=".$sestipotarifa."";
			$fila = db::getRow($query);
			$codtipobas = floatval($fila['codtipobas']);

			//TIPO DE SERVICIO SOBREPESO
			$query="select codtiposob from tiposob where codservicio=".$sestipotarifa."";
			$fila = db::getRow($query);
			$codtiposob = floatval($fila['codtiposob']);

		}
		
		// codigo de oficina operaciones destino
		$codoficinaopedes = intval(db::getScalar("SELECT codoficinaope FROM ciudad WHERE codciudad = '$id_ciudad_destino'"));
		
		// codtipopes (explicar)			
		$query = "	SELECT origendestino.codtipopes FROM origendestino
						INNER JOIN oficina ON origendestino.codciudaddes=oficina.codciudad
						WHERE origendestino.codciudadori= '$id_ciudad_origen'
						AND oficina.codoficina='$codoficinaopedes'";
		$codtipopes = intval(db::getScalar($query));
		
		//kilos de sobrepeso
		//$query="SELECT (CASE WHEN $peso_bruto*1000>funpesomax_age($sescodservicio,$codtipopes,0,0,'$today') THEN CEIL($peso_bruto-funpesomax_age($sescodservicio,$codtipopes,0,0,'$today')/1000) ELSE 0 END) as kilossob";

		$query="SELECT (CASE WHEN $peso_bruto*1000>funpesomax_age($sestipotarifa,$codtipopes,0,0,'$today',$codtipobas) THEN CEIL($peso_bruto-funpesomax_age($sestipotarifa,$codtipopes,0,0,'$today',$codtipobas)/1000) ELSE 0 END) as kilossob";	
		$kilossob=db::getScalar($query);
		
		// basico		
		//$query="SELECT funbasiconac_age($sescodservicio, $peso_bruto*1000, $codtipopes, 0, $kilossob,funpesomax_age( $sescodservicio, $codtipopes, 0, 0, '$today'), '$today') AS basico";
		$query="SELECT funbasiconac_age($sestipotarifa, $peso_bruto*1000, $codtipopes, 0, $kilossob,funpesomax_age( $sestipotarifa, $codtipopes, 0, 0, '$today',$codtipobas), '$today',$codtipobas) AS basico";
		$basico= floatval(db::getScalar($query));
		$basico= round($basico+($basico*($complementonac/100)),2);
		
		// calcular traslado
		$codtraslado = intval(db::getScalar("SELECT codtraslado FROM ciudad WHERE codciudad = '$id_ciudad_destino'"));
		$query="SELECT funtraslado_age($codtraslado,'$today') AS traslado";
		$traslado = floatval(db::getScalar($query));
		$traslado= $traslado + ($traslado*($complementonac/100));		
		
		//sobrepeso
		//$query = "SELECT funsobrepesonac_age($kilossob, $sescodservicio, $peso_bruto*1000, $codtipopes, '$today') AS sobrepeso";
		$query = "SELECT funsobrepesonac_age($kilossob, $sestipotarifa, $peso_bruto*1000, $codtipopes, '$today',$codtiposob) AS sobrepeso";	
		$sobrepeso = db::getScalar($query);
		$sobrepeso=$sobrepeso+($sobrepeso*($complementonac/100));


		//$query = "SELECT funfranqueopos($peso_bruto*1000,$codtipopes,$sestipotarifa,'$today',0) as tasapos";
		//$this->_tasapos = floatval(db::getScalar($query));
		
		
		$this->_seguro = 0;			
		if($this->_valor_declarado>0) {
			$query="	SELECT seguro,porcentaje FROM seguro 
						WHERE valormin<='$valor_declarado' AND valormax>='$valor_declarado' 
						AND '$today'>=fechaini ORDER BY seguro.fechaini DESC";
			$fila = db::getRow($query);	
			$this->_seguro = floatval($fila['seguro']);
			$porcentaje = floatval($fila['porcentaje']);		
			$this->_seguro = !empty($this->_seguro)?$this->_seguro:($valor_declarado*$porcentaje);
			$this->_seguro=$this->_seguro+($this->_seguro*($complementonac/100));
		}

		if($sestipotarifa==2) {				
			$this->_flete=$basico+$sobrepeso+$traslado;		

			$query = "SELECT funfpo($peso_bruto*1000,$codtipopes,$sestipotarifa,'$today',0,".$this->_flete.") as tasapos";
			$this->_tasapos = floatval(db::getScalar($query));

			$this->_subtotalfle = $basico + $sobrepeso  + $traslado+ $this->_seguro;		
			$this->_totaliva = $this->_subtotalfle*($ivanac/100);
			$this->_totalpag=$this->_subtotalfle + $this->_totaliva + $this->_tasapos;
		}
		// solo para COD
		if($sestipotarifa==1) {	
			$comision = 0;
			if($this->_valor_mercancia>0) {
				$query = "	SELECT comision,porcentaje FROM comision WHERE $valor_mercancia>=valormin AND $valor_mercancia<=valormax and modalidad=2 AND '$today'>=fechaini order by comision.fechaini desc";
				$fila = db::getRow($query);
				$comision = floatval($fila['comision']);
				$comision = $comision>0?$comision:(floatval($fila['porcentaje'])*$valor_mercancia/100);
			} else {
				if($sobrepeso>0) {
					$query = "	SELECT porcentaje FROM comision WHERE modalidad=1 AND porcentaje>0 AND '$today'>=fechaini ORDER BY comision.fechaini DESC";
					$comision = floatval(db::getScalar($query))*$this->_subtotalfle/100;					
				} else {
					$query = "	SELECT comision FROM comision WHERE modalidad=1 and comision>0 and '$today'>=fechaini ORDER BY comision.fechaini DESC LIMIT 1";
					$comision = floatval(db::getScalar($query));
				}
			}				
			$comision=$comision+($comision*$complementonac/100);
			//$this->_flete=$basico+$sobrepeso+$traslado+$comision;
			$this->_flete=$basico+$sobrepeso+$traslado;
			
			$query = "SELECT funfpo($peso_bruto*1000,$codtipopes,$sestipotarifa,'$today',0,".$this->_flete.") as tasapos";
			$this->_flete=$this->_flete+$comision;
			$this->_tasapos = floatval(db::getScalar($query));

			$this->_subtotalfle = $this->_flete +  $this->_seguro;		
			$this->_totaliva = $this->_subtotalfle*($ivanac/100);
			$this->_totalpag=$this->_subtotalfle + $this->_totaliva + $this->_tasapos;
			$this->_combustible=0;
		}
		// *******************************************************
		
		return true;
	}
}
?>