<?php

// ******************************************************************
// (c) 2011 - Carlos De Oliveira - Zoom International Services C.A.
// ******************************************************************
	

class ZoomTarifa {	

	// varametros de entrada
	var $_sescodservicio;
	var $_id_ciudad_origen;
	var $_id_ciudad_destino;
	var $_peso_bruto;
	var $_valor_declarado;
	var $_valor_mercancia;
	var $_today;
	// para calcular
	var $_flete; 
	var $_seguro;
	var $_subtotalfle;
	var $_totaliva;
	var $_tasapos;
	var $_totalpag;
	
		
	// errores
	var $hayerror;
	var $mensaje_de_error;
	
	function ZoomTarifa() {
		$this->hayerror = false;
		$this->mensaje_de_error = "";	
		$this->_today= date("Y-m-d");
	}
	
	function setTipoServicio($sescodservicio) { // 1 nacional, 2 COD
		$this->_sescodservicio = intval($sescodservicio);	
	}
	
	function setIdCiudadOrigen($id_ciudad_origen) {
		$this->_id_ciudad_origen = intval($id_ciudad_origen);	
	}
	
	function setIdCiudadDestino($id_ciudad_destino) {
		$this->_id_ciudad_destino = intval($id_ciudad_destino);
	}
	
	function setPesoBruto($peso_bruto) {
		$this->_peso_bruto = floatval($peso_bruto);	
	}
	
	
	function setValorMercancia($valor_mercancia) {
		$this->_valor_mercancia = floatval($valor_mercancia);	
		$this->_valor_declarado = floatval($valor_mercancia);	
	}
	
	
	// funciones calculadas		
	function getFlete() {
		return round($this->_flete,2);	
	}

	function getSeguro() {
		return round($this->_seguro,2);	
	}
	

	function getSubtotal() {
		return round($this->_subtotalfle,2);	
	}

	function getTotalIVA() {
		return round($this->_totaliva,2);	
	}

	function getTasaPostal() {
		return round($this->_tasapos,2);	
	}
	
	function getTotalAPagar() {
		return round($this->_totalpag,2);	
	}
		
	function getError() {		
		return $this->mensaje_de_error;	
	}
	
	function CalcularTarifa() {
		//$sescodservicio,$id_ciudad_origen, $id_ciudad_destino, $cant_piezas, $peso_bruto, $valor_declarado, $valor_mercancia
		$sescodservicio = $this->_sescodservicio;
		$id_ciudad_origen = $this->_id_ciudad_origen;
		$id_ciudad_destino = $this->_id_ciudad_destino;
		$peso_bruto = $this->_peso_bruto;
		$valor_mercancia = $this->_valor_mercancia;				
		$valor_declarado = $this->_valor_mercancia;

		$today = date("Y-m-d");		
		
		// validaciones
		if($peso_bruto<0) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "El Peso Bruto no puede ser negativo";
			return false;	
		}
		if($id_ciudad_origen==0) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "La ciudad de origen no puede ser cero";
			return false;
		}	
		if($id_ciudad_destino==0) {
			$this->hayerror = true;	
			$this->mensaje_de_error = "La ciudad de destino no puede ser cero";
			return false;
		}	
		if(	$sescodservicio!=1 && $sescodservicio!=2 ) {
			$this->hayerror = true;
			$this->mensaje_de_error = "El codigo de servicio debe ser 1 o 2";					
			return false;
		}
		
		// ********************************** CALCULOS COMUNES *****************************
		// ivanac (igual cod)
		$query = "select funiva('$today', 1,$id_ciudad_origen) as ivanac";
		$ivanac = floatval(db::getScalar($query));			
		
		$query = "SELECT funcomplemento('$today', 1,$id_ciudad_origen) as complementonac";
		$complementonac = floatval(db::getScalar($query));
			
		// codigo de oficina operaciones destino
		$codoficinaopedes = intval(db::getScalar("SELECT codoficinaope FROM ciudad WHERE codciudad = '$id_ciudad_destino'"));
		
		// codtipopes (explicar)			
		$query = "	SELECT origendestino.codtipopes FROM origendestino
						INNER JOIN oficina ON origendestino.codciudaddes=oficina.codciudad
						WHERE origendestino.codciudadori= '$id_ciudad_origen'
						AND oficina.codoficina='$codoficinaopedes'";
		$codtipopes = intval(db::getScalar($query));
		
		//kilos de sobrepeso
		$query="SELECT (	CASE WHEN $peso_bruto*1000>funpesomax_age($sescodservicio,$codtipopes,0,0,'$today') 
								THEN 
									CEIL($peso_bruto-funpesomax_age($sescodservicio,$codtipopes,0,0,'$today')/1000) 
								ELSE 0 
							END
						) as kilossob";	
		$kilossob=db::getScalar($query);
		
		// basico		
		$query="	SELECT funbasiconac_age($sescodservicio, $peso_bruto*1000, $codtipopes, 0, $kilossob,
					funpesomax_age( $sescodservicio, $codtipopes, 0, 0, '$today'), '$today') AS basico";
		$basico= floatval(db::getScalar($query));
		$basico= round($basico+($basico*($complementonac/100)),2);
		
		// calcular traslado
		$codtraslado = intval(db::getScalar("SELECT codtraslado FROM ciudad WHERE codciudad = '$id_ciudad_destino'"));
		$query="SELECT funtraslado_age($codtraslado,'$today') AS traslado";
		$traslado = floatval(db::getScalar($query));
		$traslado= $traslado+ ($traslado*($complementonac/100));		
		
		$query = "SELECT funsobrepesonac_age($kilossob, $sescodservicio, $peso_bruto*1000, $codtipopes, '$today') AS sobrepeso";	
		$sobrepeso = db::getScalar($query);
		$sobrepeso=$sobrepeso+($sobrepeso*($complementonac/100));


		$query = "SELECT funfranqueopos($peso_bruto*1000,$codtipopes,$sescodservicio,'$today',0) as tasapos";
		$this->_tasapos = floatval(db::getScalar($query));
		
		
		$this->_seguro = 0;			
		if($this->_valor_declarado>0) {
			$query="	SELECT seguro,porcentaje FROM seguro 
						WHERE valormin<='$valor_declarado' AND valormax>='$valor_declarado' 
						AND '$today'>=fechaini ORDER BY seguro.fechaini DESC";
			$fila = db::getRow($query);	
			$this->_seguro = floatval($fila['seguro']);
			$porcentaje = floatval($fila['porcentaje']);		
			$this->_seguro = !empty($this->_seguro)?$this->_seguro:($valor_declarado*$porcentaje);
			$this->_seguro=$this->_seguro+($this->_seguro*($complementonac/100));
		}

		if($sescodservicio==2) {				
			$this->_flete=$basico+$sobrepeso+$traslado;		
			$this->_subtotalfle = $basico + $sobrepeso  + $traslado+ $this->_seguro;		
			$this->_totaliva = $this->_subtotalfle*($ivanac/100);
			$this->_totalpag=$this->_subtotalfle + $this->_totaliva + $this->_tasapos;
		}
		// solo para COD
		if($sescodservicio==1) {	
			$comision = 0;
			if($this->_valor_mercancia>0) {
				$query = "	SELECT comision,porcentaje FROM comision 
							WHERE $valor_mercancia>=valormin AND $valor_mercancia<=valormax and modalidad=2 
							AND '$today'>=fechaini order by comision.fechaini desc";
				$fila = db::getRow($query);
				$comision = floatval($fila['comision']);
				$comision = $comision>0?$comision:(floatval($fila['porcentaje'])*$valor_mercancia/100);
			} else {
				if($sobrepeso>0) {
					$query = "	SELECT porcentaje FROM comision WHERE modalidad=1 AND porcentaje>0 AND '$today'>=fechaini 
								ORDER BY comision.fechaini DESC";
					$comision = floatval(db::getScalar($query))*$this->_subtotalfle/100;					
				} else {
					$query = "	SELECT comision FROM comision 
								WHERE modalidad=1 and comision>0 and '$today'>=fechaini 
								ORDER BY comision.fechaini DESC LIMIT 1";
					$comision = floatval(db::getScalar($query));
				}
			}				
			$comision=$comision+($comision*$complementonac/100);
			$this->_flete=$basico+$sobrepeso+$traslado+$comision;					
			$this->_subtotalfle = $this->_flete +  $this->_seguro;		
			$this->_totaliva = $this->_subtotalfle*($ivanac/100);
			$this->_totalpag=$this->_subtotalfle + $this->_totaliva + $this->_tasapos;		
		}
		// *******************************************************
		
		return true;
	}	
}


	

?>