<?php 

error_reporting(0);

// ******************************************************************
// (c) 2011 - Carlos De Oliveira - Zoom International Services C.A.
// ******************************************************************

define("ZOOM_FUNCTION_DOES_NOT_EXISTS",100);
define("ZOOM_FUNCTION_ACCESS_DENIED",200);
define("ZOOM_FUNCTION_METHOD_NOT_DEFINED",300);
define("ZOOM_METHOD_FILE_NOT_FOUND",400);
define("ZOOM_BAD_FORMAT",500);


class ZoomWebServices {
    var $methods, $files, $args, $strcall, $error_code, $error_message, $included;
	
	function getErrorCode() {
		switch($this->error_code) {
			case ZOOM_FUNCTION_DOES_NOT_EXISTS: 	return "La funcion no existe (".$this->strcall.")";		break;
			case ZOOM_FUNCTION_ACCESS_DENIED:		return "Acceso denegado para ".$this->strcall." (El servicio no esta definido)"; break;
			case ZOOM_FUNCTION_METHOD_NOT_DEFINED:	return "El metodo de la llamada ".$this->strcall." no esta definido";
			case ZOOM_METHOD_FILE_NOT_FOUND:		return "El metodo ".$this->strcall." no esta definido";
			case ZOOM_BAD_FORMAT:					return "El formato de la respuesta no es adecuado";
		}
		return "Error Desconocido";
	}
	
	function getParams($stream) {
		if(strpos($stream,"=")===false) return $stream;
		$piezas = explode("&",$stream);
		$ret  = array();
		foreach($piezas as $p) {
			$parte = explode("=",$p);
			$ret[$parte[0]] = $parte[1];
		}
		return json_encode($ret);
	}
	
    function ZoomWebServices() {
		$this->error_code = 0;
		$this->files = array();
		$this->included = array();
		$uri = $_SERVER['REQUEST_URI'];
		$uri = str_replace(".php","",$uri);
		$uri = explode("/",$uri);
        $this->strcall = end($uri);
		$this->args = $this->getParams(file_get_contents('php://input'));
		//registrar_log("registrando ".$this->strcall." argumentos - ".($this->args)." - ");
        $this->methods = array();
        header('Cache-Control: no-cache, must-revalidate');
        header('Content-type: application/json; charset=utf-8');
    }
   
    function Register($name,$file) {
        $this->methods[$name] = true;
		$this->files[$name] = APPDIR."funciones".DIRECTORY_SEPARATOR.$file;		
    }
   
    function Remove($name) {
        $this->methods[$name] = false;
    }
   
 	function setError($error = "") {
		$myerror = empty($error)?$this->getErrorCode():$error;
		header("HTTP/1.0 500 Internal server error");
		print json_encode(array(
					"message" => $myerror,
					"code" => $this->error_code,
					"status" => array("message" => "Internal server error", "code" => "500")						
				));						
	}
   
    function call($name, $args) {		
		//registrar_log("tratando de llamar a $name");
		if($this->error_code>0) {
            $this->setError();
			return false;
		}		
		if(empty($name)) $this->error_code = ZOOM_FUNCTION_METHOD_NOT_DEFINED; 
		if(!empty($name) && $this->methods[$name]!=true) $this->error_code = ZOOM_FUNCTION_ACCESS_DENIED;
		if(!empty($name) && !file_exists($this->files[$name])) $this->error_code = ZOOM_METHOD_FILE_NOT_FOUND;
        if ($this->error_code==0) {			
			if(!in_array($this->files[$name],$this->included)) {				
				include_once($this->files[$name]);
				$this->included[] = $this->files[$name];
			}
            $result = call_user_func_array($name, $args);
			if(!is_array($result)) $this->error_code = ZOOM_BAD_FORMAT;
			if(empty($result['error']) && $this->error_code==0) {				
				header("HTTP/1.0 200 OK");
    	        return json_encode($result['response']);
			} else {
				 $myerror = $result['error_msg'];
			}
			//registrar_log("no se pudo llamar a ".$name." ".serialize($error));
        } 		
		$this->setError($myerror);
    }
	
    function start() {
         print $this->call($this->strcall, json_decode($this->args));
    }
}

// funciones privadas para la generacion de respuesta

// funciones privada 
function ZoomWS_Error($mensaje) {
	$data = array();
	$data['error'] = 1;	
	$data['error_msg'] = $mensaje;
	$data['response'] = "";
	return $data;
}
// funcion privada
function ZoomWS_Response($response) {
	$data = array();
	$data['error'] = 0;
	$data['error_msg'] = ""; 
	$data['response'] = $response;
	return $data;
}

?>