<?php

/**
* Clase ProveedorDAL que implementa el manejo de los llamados a la Base de Datos de los servicios asociados a la Recolecta
*
* @author Ingeniero Luis Blanco
* @module Recolectas
* @modulegroup Servicios
* @package CLASES DAL
*/

include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'dal'.DIRECTORY_SEPARATOR.'class.main.dal.php');

class ProveedorDAL extends MainDAL {
    
     /**
      * ProveedorDAL::RestablecerValores()
      * 
      * @return
      */
     function RestablecerValores(){
        
        $Query = "DELETE FROM proveedor Where codcliente = '1017703' And codproveedor > '3400'";
        $ResulOperation = pg_exec($Query);
        
        $this->editMaximoRecolecta("3400");    
        
        $Query = "DELETE FROM proveedorsysguiae";        
        $ResulOperation = pg_exec($Query);
    }
    
    /**
     * ProveedorDAL::addProveedor()
     * 
     * @param mixed $Proveedor
     * @return
     */
    function addProveedor($Proveedor){
	
        $ProcessCompleted = MainClass::COD_OPERATION_SUCESFULLY;
        
        $Query  = "INSERT INTO proveedor(";
        $Query .= "codproveedor, codcliente, nombre, direccion, telefono, fax, inactivo,";  
        $Query .= "codciudad, codruta, contacto, urbanizacion, celular)"; 
                       
        $Query.="VALUES";
        $Query.="(";
        $Query.= $Proveedor->codProveedor ."," .$Proveedor->codClienteMaster .",'". AddSlashes($Proveedor->nombre). "','";        
        $Query.= AddSlashes($Proveedor->direccion)."','"; 
        $Query.= AddSlashes($Proveedor->telefono)."', '". $Proveedor->fax. "','". $Proveedor->inactivo ."',";        
        $Query.= $Proveedor->codCiudad.",". $Proveedor->codRuta.",'" . AddSlashes($Proveedor->contacto)."','" . AddSlashes($Proveedor->urbanizacion)."'"; 
        $Query.= ",'" . AddSlashes($Proveedor->telefonoCelular)."'";
        $Query.=")";        
        
        $this->register_dal_log($Query);
        
        $ResulOperation = pg_exec($Query);
        
        if(isset($ResulOperation) && $ResulOperation == ""){
            $ProcessCompleted = MainClass::COD_OPERATION_FAILED;
        }
       
        return $ProcessCompleted;
    }
    
    /**
     * ProveedorDAL::editProveedor()
     * 
     * @param mixed $Proveedor
     * @return
     */
    function editProveedor($Proveedor){
	
        $ProcessCompleted = MainClass::COD_OPERATION_SUCESFULLY;
        
        $Proveedor->nombre = AddSlashes($Proveedor->nombre);
        $Proveedor->direccion = AddSlashes($Proveedor->direccion);
        $Proveedor->telefono = AddSlashes($Proveedor->telefono);
        $Proveedor->contacto = AddSlashes($Proveedor->contacto);
        $Proveedor->urbanizacion = AddSlashes($Proveedor->urbanizacion);
        $Proveedor->telefonoCelular = Addslashes($Proveedor->telefonoCelular);
          
        
        $Query  = "UPDATE proveedor SET ";
        $Query .= "nombre = '$Proveedor->nombre', direccion = '$Proveedor->direccion', telefono = '$Proveedor->telefono', ";  
        $Query .= "fax = '$Proveedor->fax', inactivo = '$Proveedor->inactivo', codciudad = $Proveedor->codCiudad, ";
        $Query .= "celular = '$Proveedor->telefonoCelular' "; 
        $Query .= ",contacto = '$Proveedor->contacto' "; 
        $Query .= ",urbanizacion = '$Proveedor->contacto' "; 
                               
        $Query.="WHERE codproveedor = '$Proveedor->codProveedor' AND codcliente = '$Proveedor->codClienteMaster'";      
                 
        $this->register_dal_log($Query);         
                 
        $ResulOperation = pg_exec($Query);
        
        if(isset($ResulOperation) && $ResulOperation == ""){
            $ProcessCompleted = MainClass::COD_OPERATION_FAILED;
        }
       
        return $ProcessCompleted;
    }
    




    
    /**
     * ProveedorDAL::deleteProveedor()
     * 
     * @param mixed $Proveedor
     * @return
     */
 /*   function deleteProveedor($Proveedor){
	
        $ProcessCompleted = MainClass::COD_OPERATION_SUCESFULLY;
        
        $Proveedor->nombre = AddSlashes($Proveedor->nombre);
        $Proveedor->direccion = AddSlashes($Proveedor->direccion);
        $Proveedor->telefono = AddSlashes($Proveedor->telefono);
        $Proveedor->contacto = AddSlashes($Proveedor->contacto);
        $Proveedor->urbanizacion = AddSlashes($Proveedor->urbanizacion);
        $Proveedor->telefonoCelular = Addslashes($Proveedor->telefonoCelular);
          
        
        //$Query  = "UPDATE proveedor SET ";
        //$Query .= "nombre = '$Proveedor->nombre', direccion = '$Proveedor->direccion', telefono = '$Proveedor->telefono', ";  
        //$Query .= "fax = '$Proveedor->fax', inactivo = '$Proveedor->inactivo', codciudad = $Proveedor->codCiudad, ";
        //$Query .= "celular = '$Proveedor->telefonoCelular' "; 
        //$Query .= ",contacto = '$Proveedor->contacto' "; 
        //$Query .= ",urbanizacion = '$Proveedor->contacto' "; 
                               
        //$Query.="WHERE codproveedor = '$Proveedor->codProveedor' AND codcliente = '$Proveedor->codClienteMaster'";      
                 
		$Query='DELETE FROM proveedor WHERE codproveedor=1100379 AND codcliente=1100379';

        $this->register_dal_log($Query);         
                 
        $ResulOperation = pg_exec($Query);
        
        if(isset($ResulOperation) && $ResulOperation == ""){
            $ProcessCompleted = MainClass::COD_OPERATION_FAILED;
        }
       
        return $ProcessCompleted;
    }*/
    



    /**
     * ProveedorDAL::getProveedor()
     * 
     * @param mixed $codProveedor
     * @return
     */
    function getProveedor($codProveedor){
        
        $Query = "SELECT tbl_proveedor.codproveedor, tbl_proveedor.codcliente, tbl_proveedor.nombre, tbl_proveedor.direccion, tbl_proveedor.telefono, tbl_proveedor.fax, tbl_proveedor.inactivo, 
                  tbl_proveedor.codciudad, tbl_proveedor.codruta, tbl_proveedor.contacto, tbl_proveedor.urbanizacion, tbl_proveedor.celular,
                  tbl_ciudad.nombre AS nombreciudad, tbl_estado.nombre AS nombreestado, tbl_estado.codestado  
                  FROM proveedor AS tbl_proveedor ";
        $Query.= "INNER JOIN ciudad AS tbl_ciudad ON tbl_proveedor.codciudad = tbl_ciudad.codciudad ";
        $Query.= "INNER JOIN estado AS tbl_estado ON  tbl_estado.codestado = tbl_ciudad.codestado ";        
        $Query.= "WHERE tbl_proveedor.codproveedor = ". $codProveedor; 
        
        $this->register_dal_log($Query);
                
   	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;                 
    }
    
    /**
     * ProveedorDAL::getOficina_Cliente()
     * 
     * @param mixed $codCliente
     * @return
     */
    function getOficina_Cliente($codCliente){
        
        $Query = "SELECT tbl_cli.codcliente, tbl_cli.fecha, tbl_cli.codoficina, tbl_cli.nombre AS nombre_cliente, 
                  tbl_cli.rifci, tbl_cli.nit, tbl_cli.fechacre, tbl_cli.codactividadeco, tbl_cli.personaobl, 
                  tbl_cli.cargoobl, tbl_cli.direccionobl, tbl_cli.urbanizacionobl, tbl_cli.telefonoobl, 
                  tbl_cli.faxobl, tbl_cli.codruta, tbl_cli.codtipocli, tbl_cli.inactivo, tbl_cli.codtipobanc, 
                  tbl_cli.especial, tbl_cli.empleado, tbl_ofc.codoficina, tbl_ofc.nombre AS nombre_oficina, 
                  tbl_ofc.siglas, tbl_ofc.direccion, tbl_ofc.telefono1, tbl_ofc.telefono2, tbl_ofc.mail, 
                  tbl_ofc.codciudad, tbl_ofc.inactivo, tbl_ofc.codmunicipio, tbl_ofc.codparroquia, 
                  tbl_ofc.zipcode 
                  FROM cliente tbl_cli
                  INNER JOIN oficina tbl_ofc
                  ON tbl_cli.codoficina = tbl_ofc.codoficina ";
        $Query.= "WHERE tbl_cli.codcliente = '$codCliente'"; 
        
        $this->register_dal_log($Query);
        
	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;  
        
    }    
    
    /**
     * ProveedorDAL::getProveedor_Cliente()
     * 
     * @param mixed $codProveedor
     * @param mixed $codCliente
     * @return
     */
    function getProveedor_Cliente($codProveedor, $codCliente){
        
        $Query = "SELECT codproveedor, codcliente, nombre, direccion, telefono, fax, inactivo, 
                  codciudad, codruta, contacto, urbanizacion, celular
                  FROM proveedor ";
        $Query.= "WHERE codproveedor = '$codProveedor' AND codcliente = '$codCliente'"; 
        
        $this->register_dal_log($Query);
        
	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;                 
    }
    
    /**
     * ProveedorDAL::getProveedor_ClienteParents()
     * 
     * @param mixed $codProveedor
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getProveedor_ClienteParents($codProveedor, $codClienteMaster, $codCliente){
        
        $Query = "SELECT 
                  tbl_proveedor.codproveedor, tbl_proveedor.codcliente, tbl_proveedor.nombre, 
                  tbl_proveedor.direccion, tbl_proveedor.telefono, tbl_proveedor.fax, tbl_proveedor.inactivo, 
                  tbl_proveedor.codciudad, tbl_proveedor.codruta, tbl_proveedor.contacto, tbl_proveedor.urbanizacion,
	              tbl_proveedorsysguiae.codclientemaster, tbl_proveedorsysguiae.codcliente AS codclienteparent, tbl_proveedor.celular
                  FROM proveedor AS tbl_proveedor
                  INNER JOIN 
                  proveedorsysguiae AS tbl_proveedorsysguiae
                  ON tbl_proveedorsysguiae.codproveedor = tbl_proveedor.codproveedor ";
        $Query.= "WHERE tbl_proveedor.codproveedor = '$codProveedor' AND 
                  tbl_proveedorsysguiae.codclientemaster = '$codClienteMaster' AND 
                  tbl_proveedorsysguiae.codcliente = '$codCliente'"; 
               
        $this->register_dal_log($Query);
        
	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;                 
    }    
    
    /**
     * ProveedorDAL::getProveedores()
     * 
     * @param mixed $codCliente
     * @return
     */
    function getProveedores($codCliente){
   	    
        //Se agrega este query para obteber la informacion de la ciudad y el estado asociados al proveedor 
        $Query = "SELECT tbl_proveedor.codproveedor, tbl_proveedor.codcliente, tbl_proveedor.nombre, tbl_proveedor.direccion, tbl_proveedor.telefono, tbl_proveedor.fax, ";
        $Query.= "tbl_proveedor.inactivo, tbl_proveedor.codciudad, tbl_proveedor.codruta, tbl_proveedor.contacto, tbl_proveedor.urbanizacion, ";
        $Query.= "tbl_proveedor.celular , tbl_ciudad.nombre AS nombreciudad, tbl_ciudad.codoficinaope, tbl_estado.codestado, tbl_estado.nombre AS nombreestado "; 
        $Query.= "FROM proveedor tbl_proveedor ";
        $Query.= "INNER JOIN ciudad AS tbl_ciudad ON tbl_proveedor.codciudad = tbl_ciudad.codciudad ";
        $Query.= "INNER JOIN estado AS tbl_estado ON  tbl_estado.codestado = tbl_ciudad.codestado ";
        $Query.= "WHERE tbl_proveedor.codcliente =  $codCliente ";
        $Query.= "AND codproveedor NOT IN (SELECT codproveedor FROM proveedorsysguiae WHERE codclientemaster = $codCliente) AND tbl_proveedor.inactivo='f'"; 
        
        $this->register_dal_log($Query);
                        
        $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;                 
    }
    
    
    
    /**
     * ProveedorDAL::getProveedores_ClienteParents()
     * 
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getProveedores_ClienteParents($codClienteMaster, $codCliente){
                
        $Query = "SELECT ";
        $Query.= "tbl_proveedor.codproveedor, tbl_proveedor.codcliente, tbl_proveedor.nombre, "; 
        $Query.= "tbl_proveedor.direccion, tbl_proveedor.telefono, tbl_proveedor.fax, tbl_proveedor.inactivo, "; 
        $Query.= "tbl_proveedor.codciudad, tbl_proveedor.codruta, tbl_proveedor.contacto, tbl_proveedor.urbanizacion, ";
	    $Query.= "tbl_proveedorsysguiae.codclientemaster, tbl_proveedorsysguiae.codcliente AS codclienteparent, tbl_proveedor.celular, tbl_ciudad.nombre AS nombreciudad, tbl_ciudad.codoficinaope, tbl_estado.codestado, tbl_estado.nombre AS nombreestado  ";
        $Query.= "FROM proveedor AS tbl_proveedor ";
        $Query.= "INNER JOIN ";
        $Query.= "proveedorsysguiae AS tbl_proveedorsysguiae ";
        $Query.= "ON tbl_proveedorsysguiae.codproveedor = tbl_proveedor.codproveedor ";
        $Query.= "INNER JOIN ciudad AS tbl_ciudad ON tbl_proveedor.codciudad = tbl_ciudad.codciudad ";
        $Query.= "INNER JOIN estado AS tbl_estado ON  tbl_estado.codestado = tbl_ciudad.codestado ";
        
        
        $Query.= "WHERE tbl_proveedorsysguiae.codclientemaster = '$codClienteMaster' AND "; 
        $Query.= "tbl_proveedorsysguiae.codcliente = '$codCliente' ";
        $Query.= "Order By tbl_proveedor.codproveedor ASC"; 
        
        $this->register_dal_log($Query);
                   	    
	    $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;                 
    }
    
     /**
     * ProveedorDAL::getProveedores_ClienteByReport()
     * 
     * @param mixed $codCliente
     * @param mixed $nombreProveedor
     * @param mixed $estatus
     * @param mixed $codCiudad
     * @param mixed $contactoProveedor
     * @param mixed $cantidadRegistros
     * @param mixed $orderBy
     * @return
     */
    function getProveedores_ClienteByReport(
            $codCliente, 
            $nombreProveedor, 
            $estatus, 
            $codCiudad, 
            $nombreCiudad, 
            $contactoProveedor, 
            $cantidadRegistros, 
            $orderBy,
            $parentsOptionView){
        
        $Query = "SELECT tbl_proveedor.codproveedor, tbl_proveedor.codcliente, tbl_proveedor.nombre, tbl_proveedor.direccion, tbl_proveedor.telefono, tbl_proveedor.fax, tbl_proveedor.inactivo, 
                  tbl_proveedor.codciudad, tbl_proveedor.codruta, tbl_proveedor.contacto, tbl_proveedor.urbanizacion, tbl_proveedor.celular ";
                  
        $Query.= ", tbl_ciudad.nombre AS nombreciudad, tbl_ciudad.codoficinaope, tbl_estado.codestado, tbl_estado.nombre AS nombreestado ";                   
                  
        $Query.= "FROM proveedor AS tbl_proveedor ";
                  
        $Query.= "INNER JOIN ciudad AS tbl_ciudad ON tbl_proveedor.codciudad = tbl_ciudad.codciudad ";
        $Query.= "INNER JOIN estado AS tbl_estado ON  tbl_estado.codestado = tbl_ciudad.codestado ";
        
        $Query.= "WHERE tbl_proveedor.codcliente = $codCliente ";
        
        if($nombreProveedor != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_proveedor.nombre LIKE '%$nombreProveedor%' )";
        }
        
        if($estatus != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_proveedor.inactivo = '$estatus' )";
        }
        
        if($codCiudad != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_proveedor.codciudad = '$codCiudad' )";
        }
        
        if($nombreCiudad != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_ciudad.nombre  LIKE '%$nombreCiudad%' )";
        }
        
        if($contactoProveedor != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_proveedor.contacto LIKE '%$contactoProveedor%' )";
        }



        //Nueva Validacion en funcion de un parametro nuevo solicitado por el Cliente 
        //ZOOM propietario del Sistema Guia Electronica 
        //Si el cliente que genera la consulta es el Cliente Master Procedemos a validar 
        //el parametro de filtro parentsOptionView verificando que informacion desea 
        //obtener solo

        $this->register_dal_log("parentsOptionView: $parentsOptionView");


        if($parentsOptionView == MainClass::PARENTS_FILTER_ALL){

            //$Query.= "AND tbl_proveedor.codproveedor IN (SELECT codproveedor FROM proveedorsysguiae WHERE codclientemaster = $codCliente)";

        }elseif ($parentsOptionView == MainClass::PARENTS_FILTER_ONLY_CLIENTS) {

            $Query.= "AND tbl_proveedor.codproveedor IN (SELECT codproveedor FROM proveedorsysguiae WHERE codclientemaster = $codCliente AND codcliente <> $codCliente)";
        }else{

            $Query.= "OR tbl_proveedor.codproveedor IN (SELECT codproveedor FROM proveedorsysguiae WHERE codclientemaster = $codCliente AND codcliente = $codCliente)";
        }   

        
        if($orderBy != MainClass::COD_STRING_ALL){
            $Query.= " ORDER BY tbl_proveedor.$orderBy ASC ";
        }
        
        if($cantidadRegistros != MainClass::COD_STRING_ALL){
            $Query.= " LIMIT $cantidadRegistros";
        }         
                  
        $this->register_dal_log($Query); 
                      
	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;                 
    }
    
    
    /**
     * ProveedorDAL::getProveedores_ClienteParentsByReport()
     * 
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $nombreProveedor
     * @param mixed $estatus
     * @param mixed $codCiudad
     * @param mixed $contactoProveedor
     * @param mixed $cantidadRegistros
     * @param mixed $orderBy
     * @return
     */
    function getProveedores_ClienteParentsByReport($codClienteMaster, $codCliente, $nombreProveedor, $estatus, $codCiudad, $nombreCiudad, $contactoProveedor, $cantidadRegistros, $orderBy){
        
        $Query = "SELECT ";
        $Query.= "tbl_proveedor.codproveedor, tbl_proveedor.codcliente, tbl_proveedor.nombre, "; 
        $Query.= "tbl_proveedor.direccion, tbl_proveedor.telefono, tbl_proveedor.fax, tbl_proveedor.inactivo, "; 
        $Query.= "tbl_proveedor.codciudad, tbl_proveedor.codruta, tbl_proveedor.contacto, tbl_proveedor.urbanizacion, ";
	    $Query.= "tbl_proveedorsysguiae.codclientemaster, tbl_proveedorsysguiae.codcliente AS codclienteparent, tbl_proveedor.celular ";
        
        $Query.= ",tbl_ciudad.nombre AS nombreciudad, tbl_ciudad.codoficinaope, tbl_estado.codestado, tbl_estado.nombre AS nombreestado "; 
        $Query.= "FROM proveedor AS tbl_proveedor ";
        $Query.= "INNER JOIN ";
        $Query.= "proveedorsysguiae AS tbl_proveedorsysguiae ";
        $Query.= "ON tbl_proveedorsysguiae.codproveedor = tbl_proveedor.codproveedor ";
        
        $Query.= "INNER JOIN ciudad AS tbl_ciudad ON tbl_proveedor.codciudad = tbl_ciudad.codciudad ";
        $Query.= "INNER JOIN estado AS tbl_estado ON  tbl_estado.codestado = tbl_ciudad.codestado ";
        
        $Query.= "WHERE tbl_proveedorsysguiae.codclientemaster = '$codClienteMaster' AND "; 
        $Query.= "tbl_proveedorsysguiae.codcliente = '$codCliente' ";
        
        if($nombreProveedor != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_proveedor.nombre LIKE '%$nombreProveedor%' )";
        }
        
        if($estatus != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_proveedor.inactivo = '$estatus' )";
        }
        
        if($codCiudad != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_proveedor.codciudad = '$codCiudad' )";
        }
        
        if($nombreCiudad != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_ciudad.nombre  LIKE '%$nombreCiudad%' )";
        }
        
        if($contactoProveedor != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_proveedor.contacto LIKE '%$contactoProveedor%' )";
        }
        
        if($orderBy != MainClass::COD_STRING_ALL){
            $Query.= " ORDER BY tbl_proveedor.$orderBy ASC ";
        }
        
        if($cantidadRegistros != MainClass::COD_STRING_ALL){
            $Query.= " LIMIT $cantidadRegistros";
        }    
        
        $this->register_dal_log($Query);
		          	    
	    $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;                 
    }    
    
    /**
     * ProveedorDAL::getCodProveedor()
     * 
     * @return
     */
    function getCodProveedor(){
        
        $Query = "SELECT codmaximo, tabla, valormax FROM maximo  Where codmaximo = 4 for update";
        
        $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;
    }
    
    /**
     * ProveedorDAL::getEstado()
     * 
     * @return
     */
    function getEstado($codEstado){
        
        $Query = "SELECT codestado, nombre, codregion, urbanizacion, siglas, codpais, "; 
        $Query .= " codusuario, fechausu, horausu, codestadobcv, codestadoipo ";
        $Query .= "FROM estado WHERE codestado = $codEstado ";
        
        $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;
    }
    
    /**
     * ProveedorDAL::getEstadoByCiudad()
     * 
     * @return
     */
    function getEstadoByCiudad($codCiudad){
               
        $Query = "SELECT tbl_estado.codestado, tbl_estado.nombre AS nombreestado, tbl_estado.codregion, tbl_estado.urbanizacion, tbl_estado.siglas, tbl_estado.codpais, "; 
        $Query .= " tbl_estado.codusuario, tbl_estado.fechausu, tbl_estado.horausu, tbl_estado.codestadobcv, tbl_estado.codestadoipo, ";
        $Query .= " tbl_ciudad.nombre AS nombreciudad, tbl_ciudad.codoficinaope ";
        $Query .= " FROM estado AS tbl_estado ";
        $Query .= " INNER JOIN ciudad AS tbl_ciudad ON tbl_estado.codestado = tbl_ciudad.codestado ";
        
        $Query .= "WHERE tbl_ciudad.codciudad = $codCiudad ";
        
        $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;
    }
    
    /**
     * ProveedorDAL::editMaximoProveedor()
     * 
     * @param mixed $codProveedor
     * @return
     */
    function editMaximoProveedor($codProveedor){
        
        $ProcessCompleted = true;
        
        $Query  = " UPDATE maximo ";
        $Query .= " SET valormax = ". $codProveedor;
        $Query .= " WHERE codmaximo = 4";  

        $ResulOperation = pg_exec($Query);        
        return $ProcessCompleted;        
    }
    
    /**
     * ProveedorDAL::addProveedorSysGuiaElectronica()
     * 
     * @param mixed $Proveedor
     * @return
     */
    function addProveedorSysGuiaElectronica($Proveedor){
        
        $ProcessCompleted = true;
                      
        $Query  = "INSERT INTO proveedorsysguiae ";
        $Query .= "(codproveedor, codclientemaster, codcliente, inactivo, fechamod) ";
        $Query .= " VALUES ('$Proveedor->codProveedor', '$Proveedor->codClienteMaster', '$Proveedor->codCliente', '$Proveedor->inactivo', '". date('Y-m-d')."')";

        $ResulOperation = pg_exec($Query);
               
        return $ProcessCompleted;
    }
    
    /**
     * ProveedorDAL::editProveedorSysGuiaElectronica()
     * 
     * @param mixed $Proveedor
     * @return
     */
    function editProveedorSysGuiaElectronica($Proveedor){
        
        $ProcessCompleted = true;
        
        $Query  = "UPDATE proveedorsysguiae ";
        $Query .= "SET inactivo = '$Proveedor->inactivo', fechamod = '". date('Y-m-d')."'";
        $Query .= "WHERE  codrecolecta = '$Proveedor->codProveedor' AND codclientemaster = '$Proveedor->codClienteMaster' AND codcliente = '$Proveedor->codCliente' ";

        $ResulOperation = pg_exec($Query);
                       
        return $ProcessCompleted;
    }
    
}//END CLASS ProveedorDAL

?>