<?php

/**
* Clase RecolectaDAL que implementa el manejo de los llamados a la Base de Datos de los servicios asociados a la Recolecta
*
* @author Ingeniero Luis Blanco
* @module Recolectas
* @modulegroup Servicios
* @package CLASES DAL
*/

include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'dal'.DIRECTORY_SEPARATOR.'class.main.dal.php');

class RecolectaDAL extends MainDAL {
    
    /**
     * RecolectaDAL::RestablecerValores()
     * 
     * @return
     */   
    function RestablecerValores(){
        
        $Query = "DELETE FROM recolecta Where codcliente = '1017703' And codproveedor = '3070'";
        $ResulOperation = pg_exec($Query);
        
        $this->editMaximoRecolecta("85001148");
        
        $Query = "DELETE FROM trackingrecolecta WHERE fecha = '2016-02-14'";        
        $ResulOperation = pg_exec($Query);
        
        $Query = "DELETE FROM recolectasysguiae";        
        $ResulOperation = pg_exec($Query);   
    }    
    
    /**
     * RecolectaDAL::addRecolecta()
     * 
     * @return
     */
    function addRecolecta($Recolecta){
	
    	$ProcessCompleted = MainClass::COD_OPERATION_SUCESFULLY;
        
        $Query  = "INSERT INTO recolecta(";
        $Query .= "codrecolecta, codcliente, codproveedor, fecha,";  
        $Query .= "horadesde, codusuario, contenido, observacion,"; 
        $Query .= "fechasol, horasol, inactivo, nombrepro,"; 
        $Query .= "direccionpro, codciudadpro, codrutapro, telefonopro,"; 
        $Query .= "contactopro, codtipoveh, horahasta, urbanizacionpro, codtipoenv,"; 
        $Query .= "codcasillero, codtipomod, fechamod)";
        
        $Query.="VALUES";
        $Query.="(";
        $Query.= $Recolecta->codRecolecta ."," .$Recolecta->codClienteMaster .",". $Recolecta->codProveedor .",'". $Recolecta->fechaRecolecta. "','";        
        $Query.= $Recolecta->horaDesde ."'," .$Recolecta->codUsuario .", '".AddSlashes($Recolecta->contenido)."', '".AddSlashes($Recolecta->observacion)."','";
        $Query.= date('Y-m-d') ."','". date("h:i a")."','" .$Recolecta->inactivo ."','" . AddSlashes($Recolecta->nombreProveedor)."', '";
        $Query.= AddSlashes($Recolecta->direccionProveedor)."','". AddSlashes($Recolecta->codCiudadProveedor)."', '". $Recolecta->codRutaProveedor. "','". $Recolecta->telefonoProveedor ."','";
        $Query.= AddSlashes($Recolecta->contactoProveedor)."','". AddSlashes($Recolecta->codTipoVehiculo)."', '". $Recolecta->horaHasta. "', '". AddSlashes($Recolecta->urbanizacionProveedor) ."','" .$Recolecta->codTipoEnvio ."',";
        $Query.= $Recolecta->codCasillero.",'". $Recolecta->codTipoMod."','". date('Y-m-d')."'";
        $Query.=")";
                
        $this->register_dal_log($Query);
        
        $ResulOperation = pg_exec($Query);
        
        if(isset($ResulOperation) && $ResulOperation == ""){
            $ProcessCompleted = MainClass::COD_OPERATION_FAILED;
        }
       
        return $ProcessCompleted;	
    }
        
    /**
     * RecolectaDAL::editRecolecta()
     * 
     * @return
     */
    function editRecolecta($Recolecta){
	
    	$ProcessCompleted = MainClass::COD_OPERATION_SUCESFULLY;
        
        $Recolecta->contenido = AddSlashes($Recolecta->contenido);
        $Recolecta->observacion = AddSlashes($Recolecta->observacion);
        $Recolecta->nombreProveedor = AddSlashes($Recolecta->nombreProveedor);
        $Recolecta->direccionProveedor = AddSlashes($Recolecta->direccionProveedor);
        $Recolecta->codCiudadProveedor = AddSlashes($Recolecta->codCiudadProveedor);
        $Recolecta->contactoProveedor = AddSlashes($Recolecta->contactoProveedor);
        $Recolecta->codTipoVehiculo = AddSlashes($Recolecta->codTipoVehiculo);
        $Recolecta->urbanizacionProveedor = AddSlashes($Recolecta->urbanizacionProveedor);
                
        $Query  = "UPDATE recolecta SET ";
        $Query .= "codproveedor = '$Recolecta->codProveedor', fecha='$Recolecta->fechaRecolecta', horadesde= '$Recolecta->horaDesde', ";  
        $Query .= "codusuario = '$Recolecta->codUsuario', contenido = '$Recolecta->contenido', "; 
        $Query .= "observacion = '$Recolecta->observacion', fechasol = '$Recolecta->fechaSolicitud', horasol= '$Recolecta->horaSolicitud', ";
        $Query .= "inactivo = '$Recolecta->inactivo', nombrepro = '$Recolecta->nombreProveedor', direccionpro = '$Recolecta->direccionProveedor', codciudadpro = '$Recolecta->codCiudadProveedor', "; 
        $Query .= "codrutapro = '$Recolecta->codRutaProveedor', telefonopro = '$Recolecta->telefonoProveedor', contactopro = '$Recolecta->contactoProveedor', codtipoveh = '$Recolecta->codTipoVehiculo', horahasta = '$Recolecta->horaHasta', urbanizacionpro = '$Recolecta->urbanizacionProveedor', "; 
        $Query .= "codtipoenv = '$Recolecta->codTipoEnvio', guia = '$Recolecta->guiaRecolecta', ";
        $Query .= "correo = '$Recolecta->correo', codcasillero = '$Recolecta->codCasillero', codtipomod = '$Recolecta->codTipoMod', ";
        $Query .= "fechamod = '". date('Y-m-d')."' ";
                
        $Query.="WHERE codrecolecta = '$Recolecta->codRecolecta' AND codcliente = '$Recolecta->codClienteMaster'";
        
        $this->register_dal_log($Query);
        
        $ResulOperation = pg_exec($Query);
        
        if(isset($ResulOperation) && $ResulOperation == ""){
            $ProcessCompleted = MainClass::COD_OPERATION_FAILED;
        }
       
        return $ProcessCompleted;	
    }
        
    /**
     * RecolectaDAL::cancelRecolecta()
     * 
     * @return
     */
    function cancelRecolecta($Recolecta){
	
    	$ProcessCompleted = MainClass::COD_OPERATION_SUCESFULLY;
                
        $Query  = "UPDATE recolecta SET ";
        $Query .= "codproveedor = '$Recolecta->codProveedor', fecha='$Recolecta->fechaRecolecta',  ";  
        $Query .= "codusuario = '$Recolecta->codUsuario', contenido = '$Recolecta->contenido', "; 
        $Query .= "observacion = '$Recolecta->observacion', fechasol = '$Recolecta->fechaSolicitud', ";
        $Query .= "inactivo = '$Recolecta->inactivo', ";
        $Query .= "codtipomod = '$Recolecta->codTipoMod', ";
        $Query .= "fechamod = '". date('Y-m-d')."' ";
                
        $Query.="WHERE codrecolecta = '$Recolecta->codRecolecta' AND codcliente = '$Recolecta->codClienteMaster'";
               
        $this->register_dal_log($Query);
        
        $ResulOperation = pg_exec($Query);
        
        if(isset($ResulOperation) && $ResulOperation == ""){
            $ProcessCompleted = MainClass::COD_OPERATION_FAILED;
        }
       
        return $ProcessCompleted;	
    }    
     
     /**
      * RecolectaDAL::getRecolectas()
      *
      * @param mixed  codCliente 
      * @param mixed  codCliente 
      * @param mixed  codRecolecta 
      * @param mixed  fechaDesdeSolicitud 
      * @param mixed  fechaHastaSolicitud 
      * @param mixed  fechaDesdeRecolecta 
      * @param mixed  fechaHastaRecolecta 
      * @param mixed  estatus 
      * @param mixed  codTipoEnvio 
      * @param mixed  cantidadRegistros 
      * @param mixed  orderBy
      * @return
      */
     function getRecolectas(
        $codCliente, 
        $codRecolecta, 
        $fechaDesdeSolicitud, 
        $fechaHastaSolicitud, 
        $fechaDesdeRecolecta, 
        $fechaHastaRecolecta, 
        $estatus, 
        $codTipoEnvio, 
        $cantidadRegistros, 
        $orderBy,
        $parentsOptionView){
        
        $Query = "SELECT codrecolecta, codcliente, codproveedor, fecha, horadesde, recolecta.codusuario, 
                 contenido, observacion, fechasol, horasol, recolecta.inactivo, nombrepro, 
                 direccionpro, codciudadpro, codrutapro, telefonopro, contactopro, 
                 codtipoveh, horahasta, urbanizacionpro, codtipoenv, guia, correo, 
                 codcasillero, codtipomod, fechamod, tbl_ciudad.nombre AS nombreciudadproveedor
                 FROM recolecta ";
        
        $Query.= "INNER JOIN ciudad AS tbl_ciudad ON recolecta.codciudadpro = tbl_ciudad.codciudad ";         
        $Query.= "WHERE codcliente = $codCliente AND recolecta.inactivo =  'f' AND recolecta.guia = 'f' "; 
        
        //Nueva Validacion en funcion de un parametro nuevo solicitado por el Cliente 
        //ZOOM propietario del Sistema Guia Electronica 
        //Si el cliente que genera la consulta es el Cliente Master Procedemos a validar 
        //el parametro de filtro parentsOptionView verificando que informacion desea 
        //obtener solo

        if($parentsOptionView == MainClass::PARENTS_FILTER_ALL){

            $Query.= "AND codrecolecta IN (SELECT codrecolecta FROM recolectasysguiae WHERE codclientemaster = $codCliente)";

        }elseif ($parentsOptionView == MainClass::PARENTS_FILTER_ONLY_CLIENTS) {

            $Query.= "AND codrecolecta IN (SELECT codrecolecta FROM recolectasysguiae WHERE codclientemaster = $codCliente AND codcliente <> $codCliente)";
        }else{

            $Query.= "AND codrecolecta IN (SELECT codrecolecta FROM recolectasysguiae WHERE codclientemaster = $codCliente AND codcliente = $codCliente)";
        }
   

        if($codRecolecta != MainClass::COD_STRING_ALL){
            $Query.= " AND ( recolecta.codrecolecta = '$codRecolecta' )";
        }   
        
        if($fechaDesdeSolicitud != MainClass::COD_STRING_ALL && $fechaHastaSolicitud != MainClass::COD_STRING_ALL){
            $Query.= " AND ( recolecta.fechasol BETWEEN '$fechaDesdeSolicitud' AND '$fechaHastaSolicitud')";
        }      
        
        if($fechaDesdeRecolecta != MainClass::COD_STRING_ALL && $fechaHastaRecolecta != MainClass::COD_STRING_ALL){
            $Query.= " AND ( recolecta.fecha BETWEEN '$fechaDesdeRecolecta' AND '$fechaHastaRecolecta')";
        }
                
        if($estatus != MainClass::COD_STRING_ALL){
            $Query.= " AND ( recolecta.inactivo = '$estatus' )";
        }
        
        if($codTipoEnvio != MainClass::COD_STRING_ALL){
            $Query.= " AND ( recolecta.codtipoenv = '$codTipoEnvio' )";
        }        
        
        if($orderBy != MainClass::COD_STRING_ALL){
            $Query.= " ORDER BY $orderBy ASC ";
        }else{
            $Query.= "ORDER BY codrecolecta ASC";
        }               
        
        if($cantidadRegistros != MainClass::COD_STRING_ALL){
            $Query.= " LIMIT $cantidadRegistros";
        }        
        
        $this->register_dal_log($Query);        
        
   	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;                 
    }

    /**
     * RecolectaDAL::getRecolectas_Cliente()
     * 
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */    
    function getRecolectas_Cliente(
        $codClienteMaster, 
        $codCliente, 
        $codRecolecta, 
        $fechaDesdeSolicitud, 
        $fechaHastaSolicitud, 
        $fechaDesdeRecolecta, 
        $fechaHastaRecolecta, 
        $estatus, 
        $codTipoEnvio, 
        $cantidadRegistros, 
        $orderBy){
        
        $Query = "SELECT tbl_recolecta.codrecolecta, tbl_recolecta.codcliente, tbl_recolecta.codproveedor, 
                  tbl_recolecta.fecha, tbl_recolecta.horadesde, tbl_recolecta.codusuario, tbl_recolecta.
                  contenido, tbl_recolecta.observacion, tbl_recolecta.fechasol, tbl_recolecta.horasol, tbl_recolecta.inactivo, 
                  tbl_recolecta.nombrepro, tbl_recolecta.direccionpro, tbl_recolecta.codciudadpro, tbl_recolecta.codrutapro, 
                  tbl_recolecta.telefonopro, tbl_recolecta.contactopro, tbl_recolecta.codtipoveh, tbl_recolecta.horahasta, 
                  tbl_recolecta.urbanizacionpro, tbl_recolecta.codtipoenv, tbl_recolecta.guia, tbl_recolecta.correo, 
                  tbl_recolecta.codcasillero, tbl_recolecta.codtipomod, tbl_recolecta.fechamod,
            	  tbl_recolectasysguiae.codclientemaster, tbl_recolectasysguiae.codcliente AS codclienteparent, tbl_ciudad.nombre AS nombreciudadproveedor	   
                  FROM recolecta AS tbl_recolecta
                  INNER JOIN recolectasysguiae AS tbl_recolectasysguiae
                  ON tbl_recolecta.codrecolecta = tbl_recolectasysguiae.codrecolecta
                  INNER JOIN ciudad AS tbl_ciudad ON tbl_recolecta.codciudadpro = tbl_ciudad.codciudad  
                  WHERE tbl_recolectasysguiae.codclientemaster = $codClienteMaster AND
                  tbl_recolectasysguiae.codcliente = $codCliente AND 
                  tbl_recolecta.inactivo = 'f' AND tbl_recolecta.guia = 'f' ";
        
        
        if($codRecolecta != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_recolecta.codrecolecta = '$codRecolecta' )";
        }         
        
        if($fechaDesdeSolicitud != MainClass::COD_STRING_ALL && $fechaHastaSolicitud != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_recolecta.fechasol BETWEEN '$fechaDesdeSolicitud' AND '$fechaHastaSolicitud')";
        }      
        
        if($fechaDesdeRecolecta != MainClass::COD_STRING_ALL && $fechaHastaRecolecta != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_recolecta.fecha BETWEEN '$fechaDesdeRecolecta' AND '$fechaHastaRecolecta')";
        }      
        
        if($estatus != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_recolecta.inactivo = '$estatus' )";
        }
        
        if($codTipoEnvio != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_recolecta.codtipoenv = '$codTipoEnvio' )";
        } 
        
        if($orderBy != MainClass::COD_STRING_ALL){
            $Query.= " ORDER BY tbl_recolecta.$orderBy ASC ";
        }
        
        if($cantidadRegistros != MainClass::COD_STRING_ALL){
            $Query.= " LIMIT $cantidadRegistros";
        }       
        
        $this->register_dal_log("Metodo: getRecolectas_Cliente");
        $this->register_dal_log($Query);
        
        $dataBaseResult = pg_query($Query);
        return $dataBaseResult;
    }  
    
    /**
     * RecolectaDAL::getRecolecta()
     * 
     * @param mixed $codRecolecta
     * @param mixed $codCliente
     * @return
     */    
    function getRecolecta($codRecolecta, $codCliente){
        
        $Query = "SELECT codrecolecta, codcliente, codproveedor, fecha, horadesde, recolecta.codusuario, 
                 contenido, observacion, fechasol, horasol, recolecta.inactivo, nombrepro, 
                 direccionpro, codciudadpro, codrutapro, telefonopro, contactopro, 
                 codtipoveh, horahasta, urbanizacionpro, codtipoenv, guia, correo, 
                 codcasillero, codtipomod, fechamod, tbl_ciudad.nombre AS nombreciudadproveedor
                 FROM recolecta 
                 INNER JOIN ciudad AS tbl_ciudad ON recolecta.codciudadpro = tbl_ciudad.codciudad
                 ";
        $Query.= "WHERE codrecolecta = ". $codRecolecta ." AND codcliente = ". $codCliente; 
        $Query.= "AND codrecolecta IN (SELECT codrecolecta FROM recolectasysguiae WHERE codclientemaster = $codCliente)";
        $Query.= "ORDER BY codrecolecta ASC";
                
   	               
	    $dataBaseResult = pg_query($Query);	                
        return $dataBaseResult;                 
    }
            
    /**
     * RecolectaDAL::getRecolecta()
     * 
     * @param mixed $codRecolecta
     * @param mixed $codCliente
     * @return
     */    
    function getRecolectaSysGuiaE($codRecolecta, $codClienteMaster, $codCliente){
        
        $Query = "SELECT codrecolecta, codclientemaster, codcliente, inactivo, fechamod
  FROM recolectasysguiae  ";
        $Query.= "WHERE codrecolecta =  $codRecolecta  AND codclientemaster = $codClienteMaster AND codcliente = $codCliente"; 
        
	    $dataBaseResult = pg_query($Query);	                
        return $dataBaseResult;                 
    }
    
    /**
     * RecolectaDAL::getRecolecta_Cliente()
     * 
     * @param mixed $codRecolecta
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */    
    function getRecolecta_Cliente($codRecolecta, $codClienteMaster, $codCliente){
        
        $Query = "SELECT tbl_recolecta.codrecolecta, tbl_recolecta.codcliente, tbl_recolecta.codproveedor, 
                  tbl_recolecta.fecha, tbl_recolecta.horadesde, tbl_recolecta.codusuario, tbl_recolecta.
                  contenido, tbl_recolecta.observacion, tbl_recolecta.fechasol, tbl_recolecta.horasol, tbl_recolecta.inactivo, 
                  tbl_recolecta.nombrepro, tbl_recolecta.direccionpro, tbl_recolecta.codciudadpro, tbl_recolecta.codrutapro, 
                  tbl_recolecta.telefonopro, tbl_recolecta.contactopro, tbl_recolecta.codtipoveh, tbl_recolecta.horahasta, 
                  tbl_recolecta.urbanizacionpro, tbl_recolecta.codtipoenv, tbl_recolecta.guia, tbl_recolecta.correo, 
                  tbl_recolecta.codcasillero, tbl_recolecta.codtipomod, tbl_recolecta.fechamod,
            	  tbl_recolectasysguiae.codclientemaster, tbl_recolectasysguiae.codcliente AS codclienteparent,
                  tbl_ciudad.nombre AS nombreciudadproveedor	   
                  FROM recolecta AS tbl_recolecta
                  INNER JOIN recolectasysguiae AS tbl_recolectasysguiae
                  ON tbl_recolecta.codrecolecta = tbl_recolectasysguiae.codrecolecta
                  INNER JOIN ciudad AS tbl_ciudad ON tbl_recolecta.codciudadpro = tbl_ciudad.codciudad 
                  WHERE 
                  tbl_recolecta.codrecolecta = $codRecolecta AND
                  tbl_recolectasysguiae.codclientemaster = $codClienteMaster AND
                  tbl_recolectasysguiae.codcliente = $codCliente
                  ORDER BY tbl_recolecta.codrecolecta ASC";
        
        $this->register_dal_log($Query);
        
        $dataBaseResult = pg_query($Query);
        return $dataBaseResult;
    }  
    
    /**
     * RecolectaDAL::getGuia_Recolecta()
     * 
     * @param mixed $codRecolecta
     * @return
     */    
    function getGuia_Recolecta($codRecolecta){
        
        $Query = "SELECT codguia FROM guia ";
        $Query.= "WHERE codguia = '$codRecolecta'"; 
        
        $dataBaseResult = pg_query($Query);
        return $dataBaseResult;                 
    }
    
    /**
     * RecolectaDAL::getRecolecta_x_codRecolecta()
     * 
     * @param mixed $codRecolecta
     * @return
     */    
    function getRecolecta_x_codRecolecta($codRecolecta){
        
        $Query = "SELECT codrecolecta, codcliente, codproveedor, fecha, horadesde, codusuario, 
                 contenido, observacion, fechasol, horasol, inactivo, nombrepro, 
                 direccionpro, codciudadpro, codrutapro, telefonopro, contactopro, 
                 codtipoveh, horahasta, urbanizacionpro, codtipoenv, guia, correo, 
                 codcasillero, codtipomod, fechamod
                 FROM recolecta ";
        $Query.= "WHERE codrecolecta = '$codRecolecta' AND inactivo <> 'f' AND inactivo <> NULL"; 
        $Query.= " ORDER BY codrecolecta ASC";
                        
   	    $dataBaseResponse = array();
	    $dataBaseResult = pg_query($Query);	
                
        return $dataBaseResult;                 
    }
    
    /**
     * RecolectaDAL::getCliente()
     * 
     * @param mixed $codCliente
     * @return
     */    
    function getCliente($codCliente){
        
        $Query = "SELECT codcliente, fecha, codoficina, nombre, rifci, nit, fechacre, 
               codactividadeco, personaobl, cargoobl, direccionobl, urbanizacionobl, 
               telefonoobl, faxobl, codruta, mail, codtipocli, capital, zonaven, 
               paginaweb, fechaani, creditosol, denominacionsoc, inactivo, ciudadobl, 
               codestadoobl, codtipopag, tipo, fecharei, observacion, codpais, 
               vip, codciudadobl, fechamod, facturasuc, creditodias, porcentajecod, 
               zipcode, comisionage, bancario, codtipobanc, especial, empleado, 
               oficina, validaofides, nivelweb, codmunicipioobl, codparroquiaobl, 
               twitter, codcasilleroglo
               FROM cliente  ";
        $Query.= "WHERE codcliente = ". $codCliente; 
           	    
	    $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;                 
    }
    
    /**
     * RecolectaDAL::getHoraMaximaRecolecta_Proveedor()
     * 
     * @param mixed $codProveedor
     * @param mixed $codCliente
     * @return
     */    
    function getHoraMaximaRecolecta_Proveedor($codProveedor, $codCliente){
        
        $Query  = "SELECT proveedor.nombre, proveedor.direccion, proveedor.codciudad, ciudad.nombre as ciudad, ";
        $Query .= "proveedor.codruta, proveedor.telefono, proveedor.contacto, proveedor.urbanizacion, oficina.codoficina, ";
        $Query .= "oficina.horamaxrecolecta FROM proveedor, ciudad, oficina ";
        $Query .= "WHERE proveedor.codciudad = ciudad.codciudad AND ";
        $Query .= "ciudad.codoficinaope = oficina.codoficina ";
        $Query .= "AND proveedor.codproveedor = " .$codProveedor ." ";
        $Query .= "AND proveedor.codcliente = " .$codCliente ." ";    
               
        
        $dataBaseResult = pg_query($Query);	
        return $dataBaseResult; 
    }
    
    /**
     * RecolectaDAL::getHoraMaximaRecolecta_Cliente()
     * 
     * @param mixed $codCliente
     * @return
     */    
    function getHoraMaximaRecolecta_Cliente($codCliente){
        
        $Query  = "SELECT cliente.nombre, cliente.direccionobl, cliente.codciudadobl, ciudad.nombre as ciudad, cliente.codruta, cliente.telefonoobl, ";
        $Query .= "ciudad.nombre as ciudad, cliente.codruta, cliente.telefonoobl, cliente.personaobl, cliente.urbanizacionobl, oficina.codoficina, oficina.horamaxrecolecta ";
        $Query .= "FROM cliente, ciudad, oficina ";
        $Query .= "WHERE cliente.codciudadobl = ciudad.codciudad AND ciudad.codoficinaope = oficina.codoficina AND ";
        $Query .= "cliente.codcliente = " . $codCliente;       
       
        $dataBaseResult = pg_query($Query);	
        return $dataBaseResult; 
    }
    
    /**
     * RecolectaDAL::getCodRecolecta()
     * 
     * @return
     */    
    function getCodRecolecta(){
        
        $Query = "SELECT codmaximo, tabla, valormax FROM maximo  Where codmaximo = 3 for update";
        
        $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;
    }
    
    /**
     * RecolectaDAL::getRecolectas_Cliente()
     * 
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */    
    function getRecolectas_ClienteByReport($codClienteMaster, $codCliente, $codRecolecta, $fechaDesdeSolicitud, $fechaHastaSolicitud, $fechaDesdeRecolecta, $fechaHastaRecolecta, $estatus, $codTipoEnvio, $cantidadRegistros, $orderBy){
        
        $Query = "SELECT tbl_recolecta.codrecolecta, tbl_recolecta.codcliente, tbl_recolecta.codproveedor, 
                  tbl_recolecta.fecha, tbl_recolecta.horadesde, tbl_recolecta.codusuario, tbl_recolecta.
                  contenido, tbl_recolecta.observacion, tbl_recolecta.fechasol, tbl_recolecta.horasol, tbl_recolecta.inactivo, 
                  tbl_recolecta.nombrepro, tbl_recolecta.direccionpro, tbl_recolecta.codciudadpro, tbl_recolecta.codrutapro, 
                  tbl_recolecta.telefonopro, tbl_recolecta.contactopro, tbl_recolecta.codtipoveh, tbl_recolecta.horahasta, 
                  tbl_recolecta.urbanizacionpro, tbl_recolecta.codtipoenv, tbl_recolecta.guia, tbl_recolecta.correo, 
                  tbl_recolecta.codcasillero, tbl_recolecta.codtipomod, tbl_recolecta.fechamod,
            	  tbl_recolectasysguiae.codclientemaster, tbl_recolectasysguiae.codcliente AS codclienteparent	   
                  FROM recolecta AS tbl_recolecta
                  INNER JOIN recolectasysguiae AS tbl_recolectasysguiae
                  ON tbl_recolecta.codrecolecta = tbl_recolectasysguiae.codrecolecta
                  WHERE 
                  tbl_recolectasysguiae.codclientemaster = $codClienteMaster AND
                  tbl_recolectasysguiae.codcliente = $codCliente ";
                  
        if($codRecolecta != MainClass::COD_STRING_ALL){
            $Query.= " AND ( codrecolecta = '$codRecolecta' )";
        }         
        
        if($fechaDesdeSolicitud != MainClass::COD_STRING_ALL && $fechaHastaSolicitud != MainClass::COD_STRING_ALL){
            $Query.= " AND ( fechasol BETWEEN '$fechaDesdeSolicitud' AND '$fechaHastaSolicitud')";
        }      
        
        if($fechaDesdeRecolecta != MainClass::COD_STRING_ALL && $fechaHastaRecolecta != MainClass::COD_STRING_ALL){
            $Query.= " AND ( fecha BETWEEN '$fechaDesdeRecolecta' AND '$fechaHastaRecolecta')";
        }      
        
        if($estatus != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_recolecta.inactivo = '$estatus' )";
        }
        
        if($codTipoEnvio != MainClass::COD_STRING_ALL){
            $Query.= " AND ( tbl_recolecta.codtipoenv = '$codTipoEnvio' )";
        } 
        
        if($orderBy != MainClass::COD_STRING_ALL){
            $Query.= " ORDER BY tbl_recolecta.$orderBy ASC ";
        }
        
        
        
        if($cantidadRegistros != MainClass::COD_STRING_ALL){
            $Query.= " LIMIT $cantidadRegistros";
        }
        
        $this->register_dal_log($Query);
                         
        $dataBaseResult = pg_query($Query);
        return $dataBaseResult;
    }
    
     /**
      * RecolectaDAL::getRecolectasByReport()
      *
      * @param mixed  $codCliente, 
      * @param mixed  $codRecolecta,
      * @param mixed  $fechaDesdeSolicitud, 
      * @param mixed  $fechaHastaSolicitud, 
      * @param mixed  $fechaDesdeRecolecta, 
      * @param mixed  $fechaHastaRecolecta, 
      * @param mixed  $estatus, 
      * @param mixed  $codTipoEnvio, 
      * @param mixed  $cantidadRegistros , 
      * @param mixed  $orderBy
      * @return
      */
     function getRecolectasByReport(
        $codCliente, 
        $codRecolecta,
        $fechaDesdeSolicitud, 
        $fechaHastaSolicitud, 
        $fechaDesdeRecolecta, 
        $fechaHastaRecolecta, 
        $estatus, 
        $codTipoEnvio, 
        $cantidadRegistros, 
        $orderBy,
        $parentsOptionView){
        
        $Query = "SELECT codrecolecta, codcliente, codproveedor, fecha, horadesde, codusuario, 
                 contenido, observacion, fechasol, horasol, inactivo, nombrepro, 
                 direccionpro, codciudadpro, codrutapro, telefonopro, contactopro, 
                 codtipoveh, horahasta, urbanizacionpro, codtipoenv, guia, correo, 
                 codcasillero, codtipomod, fechamod
                 FROM recolecta ";
        $Query.= "WHERE codcliente = $codCliente ";
        
        
        if($codRecolecta != MainClass::COD_STRING_ALL){
            $Query.= " AND ( codrecolecta = '$codRecolecta' )";
        }   
        
        if($fechaDesdeSolicitud != MainClass::COD_STRING_ALL && $fechaHastaSolicitud != MainClass::COD_STRING_ALL){
            $Query.= " AND ( fechasol BETWEEN '$fechaDesdeSolicitud' AND '$fechaHastaSolicitud')";
        }      
        
        if($fechaDesdeRecolecta != MainClass::COD_STRING_ALL && $fechaHastaRecolecta != MainClass::COD_STRING_ALL){
            $Query.= " AND ( fecha BETWEEN '$fechaDesdeRecolecta' AND '$fechaHastaRecolecta')";
        }
                
        if($estatus != MainClass::COD_STRING_ALL){
            $Query.= " AND ( inactivo = '$estatus' )";
        }
        
        if($codTipoEnvio != MainClass::COD_STRING_ALL){
            $Query.= " AND ( codtipoenv = '$codTipoEnvio' )";
        }        
        
        
        //Nueva Validacion en funcion de un parametro nuevo solicitado por el Cliente 
        //ZOOM propietario del Sistema Guia Electronica 
        //Si el cliente que genera la consulta es el Cliente Master Procedemos a validar 
        //el parametro de filtro parentsOptionView verificando que informacion desea 
        //obtener solo

        if($parentsOptionView == MainClass::PARENTS_FILTER_ALL){

            $Query.= "AND codrecolecta IN (SELECT codrecolecta FROM recolectasysguiae WHERE codclientemaster = $codCliente)";

        }elseif ($parentsOptionView == MainClass::PARENTS_FILTER_ONLY_CLIENTS) {

            $Query.= "AND codrecolecta IN (SELECT codrecolecta FROM recolectasysguiae WHERE codclientemaster = $codCliente AND codcliente <> $codCliente)";
        }else{

            $Query.= "AND codrecolecta IN (SELECT codrecolecta FROM recolectasysguiae WHERE codclientemaster = $codCliente AND codcliente = $codCliente)";
        }             
        
        if($orderBy != MainClass::COD_STRING_ALL){
            $Query.= " ORDER BY $orderBy ASC ";
        }               
        
        if($cantidadRegistros != MainClass::COD_STRING_ALL){
            $Query.= " LIMIT $cantidadRegistros";
        }       
        
        $this->register_dal_log($Query);
                                
   	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;                 
    }
    
    /**
     * RecolectaDAL::getDates_Oficina()
     * 
     * @param mixed $codOficina
     * @param mixed $dateRecolecta
     * @return
     */    
    function getDates_Oficina($codOficina, $dateRecolecta){
        
        $Query = "SELECT codferiado, codoficina, fecha FROM feriado WHERE codoficina IN (0, ".$codOficina.") AND fecha='".$dateRecolecta."'";
		
        $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;        
    }
    
    /**
     * RecolectaDAL::editMaximoRecolecta()
     * 
     * @param mixed $codRecolecta
     * @return
     */    
    function editMaximoRecolecta($codRecolecta){
        
        $ProcessCompleted = true;

        $codRecolecta++;
        
        $Query  = " UPDATE maximo ";
        $Query .= " SET valormax = ". $codRecolecta;
        $Query .= " WHERE codmaximo = 3";  

        $ResulOperation = pg_exec($Query);        
        return $ProcessCompleted;        
    }
    
    /**
     * RecolectaDAL::addTrackingRecolecta()
     * 
     * @param mixed $codRecolecta
     * @param mixed $estatusRecolecta
     * @param mixed $codUsuario
     * @param mixed $fechaAccion
     * @param mixed $horaAccion
     * @param mixed $observacioRecolecta
     * @return
     */   
    function addTrackingRecolecta($codRecolecta, $estatusRecolecta, $codUsuario, $fechaAccion, $horaAccion, $observacioRecolecta){
        
        $ProcessCompleted = true;
        
        $Query  = "INSERT INTO trackingrecolecta ";
        $Query .= "(codguia, estatus, codusuario, fecha, hora, observacion) ";
        $Query .= " VALUES ('$codRecolecta', '$estatusRecolecta', '$codUsuario', '$fechaAccion', '$horaAccion', '$observacioRecolecta')";
                
        $ResulOperation = pg_exec($Query);
               
        return $ProcessCompleted;
    }
    
    /**
     * RecolectaDAL::addRecolectaSysGuiaElectronica()
     * 
     * @param mixed $Recolecta
     * @return
     */    
    function addRecolectaSysGuiaElectronica($Recolecta){
        
        $ProcessCompleted = true;
        
        $Query  = "INSERT INTO recolectasysguiae ";
        $Query .= "(codrecolecta, codclientemaster, codcliente, inactivo, fechamod) ";
        $Query .= " VALUES ('$Recolecta->codRecolecta', '$Recolecta->codClienteMaster', '$Recolecta->codCliente', '$Recolecta->inactivo', '". date('Y-m-d')."')";

        $ResulOperation = pg_exec($Query);
               
        return $ProcessCompleted;
    }
    
    /**
     * RecolectaDAL::editRecolectaSysGuiaElectronica()
     * 
     * @param mixed $Recolecta
     * @return
     */    
    function editRecolectaSysGuiaElectronica($Recolecta){
        
        $ProcessCompleted = true;
        
        $Query  = "UPDATE recolectasysguiae ";
        $Query .= "SET inactivo = '$Recolecta->inactivo', fechamod = '". date('Y-m-d')."'";
        $Query .= "WHERE  codrecolecta = '$Recolecta->codRecolecta' AND codclientemaster = '$Recolecta->codClienteMaster' AND codcliente = '$Recolecta->codCliente' ";

        $ResulOperation = pg_exec($Query);
                       
        return $ProcessCompleted;
    }
    

}//END CLASS RecolectaDAL

?>