<?php

/**
* Clase Recolecta clase que contiene los atributos asociados a una recolecta
*
* @author Ingeniero Luis Blanco
* @module Recolectas
* @modulegroup Servicios
* @package CLASES BASES
*/
class Recolecta {
     
  /**
   Identificador unico asigando a la Recolecta
  */   
  var $codRecolecta;
  
    		
  /**
   Identificador unico asigando al Cliente Master que esta asociado en el Sistema Guia Electronica y que es el cliente asignado dentro del Sistema Recolecta
  */
  var $codClienteMaster;
  
  /**
   Identificador nico asignado al Cliente este cdigo de Cliente corresponde a los clientes del cliente Master del Sistema Gua Electrnica
  */
  var $codCliente;
  
  /**
   Identificador unico asigando al Proveedor asociado a la recolecta
  */
  var $codProveedor;  
  
  /**
   Identificador unico asigando al Usuario que ejecuta el servicio
  */
  var $codUsuario;		
  
  /**
   Fecha de la Recolecta
  */
  var $fechaRecolecta;	
  
  /**
   Fecha de la Recolecta
  */
  var $horaDesde;
   
  /**
   Propiedad que indica si la recolecta tiene algun contenido asociado. Ejemplo: ARCHIVOS, 4 MAQUINAS DE ESCRIBIR, DOCUMENTOS, REPUESTOS, MEDICAMENTOS, etc
  */
  var $contenido;
  
  /**
   Propiedad que indica si la recolecta tiene alguna observacion adicional. Ejemplo: CAJA GRANDE ENVIAR VLN-0999, PASAR ANTES DE LAS 4 PM YA QUE HASTA ESA HORA LABORAN, Etc. 
  */
  var $observacion;
  
  /**
   Propiedad que indica la Fecha de la Solicitud 
  */
  var $fechaSolicitud;
  
  /**
   Propiedad que indica la Hora de la Solicitud 
  */
  var $horaSolicitud;
  
  /**
   Propiedad que indica si la recolecta esta activa o inactiva 
  */
  var $inactivo;
  
  /**
   Propiedad que indica el nombre del Proveedor asociado a la recolecta
  */
  var $nombreProveedor;
  
  /**
   Propiedad que indica la direccion del Proveedor asociado a la recolecta
  */
  var $direccionProveedor;
  
  /**
   Propiedad que indica el codigo de la ciudad asociada al proveedor de  la recolecta
  */
  var $codCiudadProveedor;
  
  /**
   Propiedad que indica el codigo de la ruta del proveedor asociado a la recolecta
  */
  var $codRutaProveedor;
  
  /**
   Propiedad que indica el telefono del proveedoa asociado a la recolecta
  */
  var $telefonoProveedor;
  
  /**
   Propiedad que indica el nombre de contacto asociado al proveedor asignado a la recolecta
  */
  var $contactoProveedor;
  
  /**
   Propiedad que indica el codigo del tipo de vehiculo asociado a la recolecta
  */
  var $codTipoVehiculo;
  
  /**
   Propiedad que indica la hora hasta donde es valido realizar la recolecta
  */
  var $horaHasta;
  
  /**
   Propiedad que indica la urbanizacion asociada al proveedor asignado a la recolecta
  */
  var $urbanizacionProveedor;
  
  /**
   Propiedad que indica el Tipo de Envio asociado a la recolecta la informacion de esta propiedad proviene de la tabla  tipoenv
  */
  var $codTipoEnvio;
  
  /**
   Propiedad que indica el codigo del Casillero asignado 
  */
  var $codCasillero;
  
  /**
   Propiedad que indica el codigo del Servicio asociado a la recolecta los valores posibles son:
   GUIA y Casillero 
  */
  var $codServicio;
  
  /**
   Esta propiedad tiene valor por defecto 1
  */
  var $codTipoMod;
  
   /**
   Propiedad que indica la fecha en la que se ejecuta la accion Guardar o Modificar, se actualiza con esta dos acciones
  */
  var $fechaMod;  
  
  /**
   Propiedad que indica el numero de guia asociado a la recolecta en caso de que exista
  */
  var $guiaRecolecta;  
  
  /**
   Propiedad que indica el correo asociado a la recolecta
  */
  var $correo; 
  
    /**
   Propiedad que indica el nombre de la Ciudad 
  */
  var $nombreCiudadProveedor; 


}//END CLASS Recolecta

?>