<?php

/**
* Clase que implementa los Servicios Web asociados a la recolectas
*
* @author Ingeniero Luis Blanco
* @module Recolectas
* @modulegroup Servicios
* @package SERVICIOS
*/

include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'mainclass'.DIRECTORY_SEPARATOR.'class.mainclass.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'mainclass'.DIRECTORY_SEPARATOR.'class.entitieresponse.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'mainclass'.DIRECTORY_SEPARATOR.'class.entitylistresponse.manager.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'business'.DIRECTORY_SEPARATOR.'class.recolecta.manager.php');
include_once (APPDIR.'include'.DIRECTORY_SEPARATOR.'business'.DIRECTORY_SEPARATOR.'class.proveedor.manager.php');


    /**
     * addRecolecta()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codRecolecta
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $codProveedor
     * @param mixed $fechaRecolecta
     * @param mixed $horaDesde
     * @param mixed $contenido
     * @param mixed $observacion
     * @param mixed $fechaSolicitud
     * @param mixed $horaSolicitud
     * @param mixed $inactivo
     * @param mixed $codTipoVehiculo
     * @param mixed $horaHasta
     * @param mixed $codTipoEnvio
     * @param mixed $codCasillero
     * @param mixed $codTipoMod
     * @param mixed $fechaMod
     * @param mixed $codServicio
     * @return
     */
    function addRecolecta($codUsuario, $tokenAuthorization, $codRecolecta, $codClienteMaster, $codCliente, $codProveedor, $fechaRecolecta, $horaDesde,
    $contenido, $observacion, $fechaSolicitud, $horaSolicitud, $inactivo, $codTipoVehiculo, $horaHasta,
    $codTipoEnvio, $codCasillero, $codTipoMod, $fechaMod, $codServicio){
    
    
    	$Recolecta = new Recolecta();
        //Asignacion de variables en el objeto Recolecta
        $Recolecta->codRecolecta = $codRecolecta;
        $Recolecta->codClienteMaster = $codClienteMaster;
        $Recolecta->codCliente = $codCliente;
        $Recolecta->codProveedor = $codProveedor;
        $Recolecta->fechaRecolecta = $fechaRecolecta;
        $Recolecta->horaDesde = $horaDesde;
        
        $Recolecta->codUsuario = $codUsuario;
            
        $Recolecta->contenido = $contenido;
        $Recolecta->observacion = $observacion;
        $Recolecta->fechaSolicitud = $fechaSolicitud;
        $Recolecta->horaSolicitud = $horaSolicitud;
        $Recolecta->inactivo = $inactivo;   
        $Recolecta->codTipoVehiculo = $codTipoVehiculo;
        
        $Recolecta->codServicio = $codServicio;    
        $Recolecta->horaHasta = $horaHasta;
        $Recolecta->codTipoEnvio = $codTipoEnvio;
        $Recolecta->codCasillero = $codCasillero;
        $Recolecta->codTipoMod = $codTipoMod;
        $Recolecta->fechaMod = $fechaMod;
        
        $EntitieResponse = new EntitieResponse();
        $RecolectaBusiness = new RecolectaBusiness();   
                
        $EntitieResponse = $RecolectaBusiness->addRecolecta($Recolecta, $codUsuario, $tokenAuthorization);  
        
    	return ZoomWS_Response($EntitieResponse);	
    }

    /**
     * editRecolecta()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codRecolecta
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $codProveedor
     * @param mixed $fechaRecolecta
     * @param mixed $horaDesde
     * @param mixed $contenido
     * @param mixed $observacion
     * @param mixed $fechaSolicitud
     * @param mixed $horaSolicitud
     * @param mixed $inactivo
     * @param mixed $codTipoVehiculo
     * @param mixed $horaHasta
     * @param mixed $codTipoEnvio
     * @param mixed $codCasillero
     * @param mixed $codTipoMod
     * @param mixed $fechaMod
     * @param mixed $codServicio
     * @return
     */
    function editRecolecta($codUsuario, $tokenAuthorization, $codRecolecta, $codClienteMaster, $codCliente, $codProveedor, $fechaRecolecta, $horaDesde,
                            $contenido, $observacion, $fechaSolicitud, $horaSolicitud, $inactivo, $codTipoVehiculo, $horaHasta,
                            $codTipoEnvio, $codCasillero, $codTipoMod, $fechaMod, $codServicio){
	
    	//Asignacion de variables en el objeto Recolecta
        $Recolecta = new Recolecta();
        //Asignacion de variables en el objeto Recolecta
        $Recolecta->codRecolecta = $codRecolecta;
        $Recolecta->codClienteMaster = $codClienteMaster;
        $Recolecta->codCliente = $codCliente;
        $Recolecta->codProveedor = $codProveedor;
        $Recolecta->fechaRecolecta = $fechaRecolecta;
        $Recolecta->horaDesde = $horaDesde;
        
        $Recolecta->codUsuario = $codUsuario;
            
        $Recolecta->contenido = $contenido;
        $Recolecta->observacion = $observacion;
        $Recolecta->fechaSolicitud = $fechaSolicitud;
        $Recolecta->horaSolicitud = $horaSolicitud;
        $Recolecta->inactivo = $inactivo;   
        $Recolecta->codTipoVehiculo = $codTipoVehiculo;
        
        $Recolecta->codServicio = $codServicio;    
        $Recolecta->horaHasta = $horaHasta;   
        $Recolecta->codTipoEnvio = $codTipoEnvio;
        $Recolecta->codCasillero = $codCasillero;
        $Recolecta->codTipoMod = $codTipoMod;
        $Recolecta->fechaMod = $fechaMod;
        
        $EntitieResponse = new EntitieResponse();
        $RecolectaBusiness = new RecolectaBusiness();
        
        $EntitieResponse = $RecolectaBusiness->editRecolecta($Recolecta, $codUsuario, $tokenAuthorization);
    
    	return ZoomWS_Response($EntitieResponse);	
    }

    /**
     * cancelRecolecta()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codRecolecta
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $codProveedor
     * @param mixed $fechaRecolecta
     * @param mixed $contenido
     * @param mixed $observacion
     * @param mixed $fechaSolicitud
     * @param mixed $codTipoMod
     * @param mixed $fechaMod
     * @return
     */
    function cancelRecolecta($codUsuario, $tokenAuthorization, $codRecolecta, $codClienteMaster, $codCliente, $codProveedor,
                                $fechaRecolecta, $contenido, $observacion, $fechaSolicitud, $codTipoMod, $fechaMod){
		   
        //Asignacion de variables en el objeto Recolecta
        $Recolecta = new Recolecta();
        //Asignacion de variables en el objeto Recolecta
        $Recolecta->codRecolecta = $codRecolecta;
        $Recolecta->codClienteMaster = $codClienteMaster;
        $Recolecta->codCliente = $codCliente;
        $Recolecta->codProveedor = $codProveedor;
        $Recolecta->fechaRecolecta = $fechaRecolecta;
            
        $Recolecta->codUsuario = $codUsuario;
            
        $Recolecta->contenido = $contenido;
        $Recolecta->observacion = $observacion;
        $Recolecta->fechaSolicitud = $fechaSolicitud;           
        
        $Recolecta->codTipoMod = $codTipoMod;
        $Recolecta->fechaMod = $fechaMod;
        
        $EntitieResponse = new EntitieResponse();
        $RecolectaBusiness = new RecolectaBusiness();
        
        $EntitieResponse = $RecolectaBusiness->cancelRecolecta($Recolecta, $codUsuario, $tokenAuthorization);
    
    	return ZoomWS_Response($EntitieResponse);	
    }


    /**
     * getRecolecta()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codRecolecta
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getRecolecta($codUsuario, $tokenAuthorization, $codRecolecta, $codClienteMaster, $codCliente){
	     
        $EntitieResponse = new EntitieResponse(); 
        $RecolectaBusinessClass = new RecolectaBusiness();    
        $EntitieResponse = $RecolectaBusinessClass->getRecolecta($codRecolecta, $codClienteMaster, $codCliente, $codUsuario, $tokenAuthorization);
    	
    	return ZoomWS_Response($EntitieResponse);		
    }

    /**
     * getRecolectas()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getRecolectas($codUsuario, $tokenAuthorization, $codClienteMaster, $codCliente){
	
    	$RecolectaList = new EntitieListResponse();
        $RecolectaBusinessClass = new RecolectaBusiness();    
        $RecolectaList = $RecolectaBusinessClass->getRecolectas($codClienteMaster, $codCliente, $codUsuario, $tokenAuthorization);
    	
    	return ZoomWS_Response($RecolectaList);	
    }

    /**
     * addProveedor()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $nombre
     * @param mixed $direccion
     * @param mixed $telefono
     * @param mixed $fax
     * @param mixed $estatus
     * @param mixed $codCiudad
     * @param mixed $codRuta
     * @param mixed $contacto
     * @param mixed $urbanizacion
     * @return
     */
    function addProveedor($codUsuario, $tokenAuthorization, $codClienteMaster, $codCliente, $nombre, $direccion, $telefono,
                            $fax, $estatus, $codCiudad, $codRuta, $contacto, $urbanizacion){
	    
        //Asignacion de variables en el objeto Proveedor
        $Proveedor = new Proveedor();
        
        $Proveedor->codClienteMaster = $codClienteMaster;
        $Proveedor->codCliente = $codCliente;
        $Proveedor->nombre = $nombre;
        $Proveedor->direccion = $direccion;
        $Proveedor->telefono = $telefono;
        $Proveedor->fax = $fax;
        $Proveedor->inactivo = $estatus;
        $Proveedor->codCiudad = $codCiudad;
        $Proveedor->codRuta = $codRuta;
        $Proveedor->contacto = $contacto;
        $Proveedor->urbanizacion = $urbanizacion;
        
       	$EntitieResponse = new EntitieResponse();     
        $ProveedorBusiness = new ProveedorBusiness();    
        $EntitieResponse = $ProveedorBusiness->addProveedor($Proveedor, $codUsuario, $tokenAuthorization);           
    
    	return ZoomWS_Response($EntitieResponse);	
    }

    /**
     * editProveedor()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codProveedor
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @param mixed $nombre
     * @param mixed $direccion
     * @param mixed $telefono
     * @param mixed $fax
     * @param mixed $estatus
     * @param mixed $codCiudad
     * @param mixed $codRuta
     * @param mixed $contacto
     * @param mixed $urbanizacion
     * @return
     */
    function editProveedor($codUsuario, $tokenAuthorization, $codProveedor, $codClienteMaster, $codCliente, $nombre, $direccion, $telefono,
                            $fax, $estatus, $codCiudad, $codRuta, $contacto, $urbanizacion){
	    
        //Asignacion de variables en el objeto Proveedor
        $Proveedor = new Proveedor();
        
        $Proveedor->codProveedor = $codProveedor;
        $Proveedor->codClienteMaster = $codClienteMaster;
        $Proveedor->codCliente = $codCliente;
        $Proveedor->nombre = $nombre;
        $Proveedor->direccion = $direccion;
        $Proveedor->telefono = $telefono;
        $Proveedor->fax = $fax;
        $Proveedor->inactivo = $estatus;
        $Proveedor->codCiudad = $codCiudad;
        $Proveedor->codRuta = $codRuta;
        $Proveedor->contacto = $contacto;
        $Proveedor->urbanizacion = $urbanizacion;
        
       	$EntitieResponse = new EntitieResponse();     
        $ProveedorBusiness = new ProveedorBusiness();    
        $EntitieResponse = $ProveedorBusiness->editProveedor($Proveedor, $codUsuario, $tokenAuthorization);           
               
    	return ZoomWS_Response($EntitieResponse);	
    }

    /**
     * getProveedor()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codProveedor
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getProveedor($codUsuario, $tokenAuthorization, $codProveedor, $codClienteMaster, $codCliente){
		    
        $EntitieResponse = new EntitieResponse();        
        $ProveedorBusinessClass = new ProveedorBusiness();
        $EntitieResponse = $ProveedorBusinessClass->getProveedor($codProveedor, $codClienteMaster, $codCliente, $codUsuario, $tokenAuthorization);
        
    	return ZoomWS_Response($EntitieResponse);	
    }

    /**
     * getProveedores()
     * 
     * @param mixed $codUsuario
     * @param mixed $tokenAuthorization
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getProveedores($codUsuario, $tokenAuthorization, $codClienteMaster, $codCliente){
	
    	$ProveedorList = new EntitieListResponse();
        $ProveedorBusinessClass = new ProveedorBusiness();
        $ProveedorList = $ProveedorBusinessClass->getProveedores($codClienteMaster, $codCliente, $codUsuario, $tokenAuthorization);  
        
    	return ZoomWS_Response($ProveedorList);	
    }

?>