<?php
error_reporting(0);

// ******************************************************************
// (c) 2011 - Carlos De Oliveira - Zoom International Services C.A.
// ******************************************************************

define("ZOOM_FUNCTION_DOES_NOT_EXISTS",100);
define("ZOOM_FUNCTION_ACCESS_DENIED",200);
define("ZOOM_FUNCTION_METHOD_NOT_DEFINED",300);
define("ZOOM_METHOD_FILE_NOT_FOUND",400);
define("ZOOM_BAD_FORMAT",500);


class ZoomWebServices {
    var $methods, $files, $args, $strcall, $error_code, $error_message, $included;
	
	function getErrorCode() {
		switch($this->error_code) {
			case ZOOM_FUNCTION_DOES_NOT_EXISTS: 	return "La funcion no existe (".$this->strcall.")";		break;
			case ZOOM_FUNCTION_ACCESS_DENIED:		return "Acceso denegado para ".$this->strcall." (El servicio no esta definido)"; break;
			case ZOOM_FUNCTION_METHOD_NOT_DEFINED:	return "El metodo de la llamada ".$this->strcall." no esta definido";
			case ZOOM_METHOD_FILE_NOT_FOUND:		return "El metodo ".$this->strcall." no esta definido";
			case ZOOM_BAD_FORMAT:					return "El formato de la respuesta no es adecuado";
		}
		return "Error Desconocido";
	}

	function getParams($stream) {
		if(strpos($stream,"=")===false) return $stream;
		$piezas = explode("&",$stream);
		$ret  = array();
		foreach($piezas as $p) {
			$parte = explode("=",$p);
			$ret[$parte[0]] = $parte[1];
		}
		return json_encode($ret);
	}
	
    function ZoomWebServices() {
		$this->error_code = 0;
		$this->files = array();
		$this->included = array();
		$uri = $_SERVER['REQUEST_URI'];
		$uri = str_replace(".php","",$uri);
		$uri = explode("/",$uri);
        $this->strcall = end($uri);
		
		//getCiudades?callback=jQuery16209705582427660488_1343828108906&id=ccs1&_=1343828109578
		//getNewEbox?callback=jQuery16203873169401422236_1343851135959&tienda=9&hasta=21-04-2009&_=1343851166278
		if(isset($_GET['callback'])){ // Si es una peticin cross-domain
			$valor=explode("?",$this->strcall);
			$valor=explode("&",$valor[1]);
			//registrar_log("registrando ".$this->strcall." argumentos - ".$valor[1]."&".$valor[2]." - ");
			$contar=count($valor);
			for($i=1;$i<$contar-1;$i++){
				if($i==1){
					$param=$valor[$i];
				}
				else{
					$param=$param."&".$valor[$i];
				}
				
			}
			//registrar_log("registrando ".$this->strcall." argumentos - ".$param." - ");
			$this->args = $this->getParams($param);
			//registrar_log("registrando ".$this->strcall." argumentos - ".($this->args)." - ");
		}
		else{
			$this->args = $this->getParams(file_get_contents('php://input'));
		}
		//registrar_log("registrando ".$this->strcall." argumentos - ".($this->args)." - ");
        $this->methods = array();
        header('Cache-Control: no-cache, must-revalidate');
        header('Content-type: application/json; charset=utf-8');
		
		//header('Access-Control-Allow-Headers: *');
    }
   
    function Register($name,$file) {
        $this->methods[$name] = true;
		$this->files[$name] = APPDIR."funciones".DIRECTORY_SEPARATOR.$file;		
    }
   
    function Remove($name) {
        $this->methods[$name] = false;
    }
   
 	/*function setError($error = "") {
		$myerror = empty($error)?$this->getErrorCode():$error;
		header("HTTP/1.0 500 Internal server error");
		print json_encode(array("errormessage" => $myerror,"code" => $this->error_code,"status" => array("message" => "Internal server error", "code" => "500")));
	}*/

	/* Metodo Modifica por EDGAR GUEVARA 27/03/2014
		* Se modifico para que se es devuelto un error que sea por un WS y no por error con el servidor
		* Sea devuelto con codigo http 200 o succes eso quiere decir que si el cliente tiene que preguntar el momento de recibir
		* respueta si en el arreglo JSON hay o no un mensaje de error, de haber es un erro propio de un WS de no haber es una respuesta satisfactoria
		* Pero en cambio si la respuesta es un HTTP 500 o 400 significa que hubo un error a nivel del servidor, esto quiere decir que no se llego a realizar
		* ninguna operacion con el WS.
		*/
	function setError($error = "") {
		//var_dump($myerror);
		if (empty($error)) {
			$myerror = empty($error) ? $this->getErrorCode() : $error;
			header("HTTP/1.0 500 Internal server error");
			print json_encode(array("errormessage" => $myerror, "code" => $this->error_code, "status" => array("message" => "Internal server error", "code" => "500")));
		}else{
			$myerror = $error;
			//print json_encode(array("errormessage" => $myerror, "code" => "" . $this->error_code . ""));
			print json_encode(array("errormessage" => $myerror));
		}
	}


    function call($name, $args) {		
		//registrar_log("tratando de llamar a $name");
		//registrar_log($enviar);
		
		if(isset($_GET['callback'])){ // Si es una peticin cross-domain
           $name=explode("?",$name);
		   $name=$name[0];
		   //registrar_log("tratando de llamar a $name");
        }
		
		/*  AGREGADO POR FELIX UTRERA -- 10-07-2012
			Conversion del parametro $args a array. En PHP5 dicho valor no puede ser convertido por lo que usamos la funcion "object_2_array".
		*/
		
		$args=object_2_array($args);
		//registrar_log("tratando de llamar a ".$args."");
		if($this->error_code>0) {
            $this->setError();
			return false;
		}		
		if(empty($name)) $this->error_code = ZOOM_FUNCTION_METHOD_NOT_DEFINED; 
		if(!empty($name) && $this->methods[$name]!=true) $this->error_code = ZOOM_FUNCTION_ACCESS_DENIED;
		if(!empty($name) && !file_exists($this->files[$name])) $this->error_code = ZOOM_METHOD_FILE_NOT_FOUND;
        if ($this->error_code==0) {			
			if(!in_array($this->files[$name],$this->included)) {				
				include_once($this->files[$name]);
				$this->included[] = $this->files[$name];
			}
            $result = call_user_func_array($name, $args);
			//registrar_log("tratando de llamar a ".$name."");
			//registrar_log("tratando de llamar a ".$args."");
			if(!is_array($result)) $this->error_code = ZOOM_BAD_FORMAT;
			if(empty($result['error']) && $this->error_code==0) {				
				header("HTTP/1.0 200 OK");
				if(isset($_GET['callback'])){ // Si es una peticin cross-domain
					 return $_GET['callback'].'('.json_encode($result['response']).');';
				}
				else{
					return json_encode($result['response']);
				}
			} else {
				if(isset($_GET['callback'])){ // Si es una peticin cross-domain
					$myerror=array("errormessage"=>$result['error_msg']);
					$myerror=json_encode($myerror);
					return $_GET['callback'].'('.$myerror.');';

				}
				else{
					$myerror = $result['error_msg'];
				}
			}
			//registrar_log("no se pudo llamar a ".$name." ".serialize($error));
			//registrar_log("no se pudo llamar a ".$name;
        } 		
		$this->setError($myerror);
    }
	
    function start() {
         print $this->call($this->strcall, json_decode($this->args));
    }
}

// funciones privadas para la generacion de respuesta

// funciones privada 
function ZoomWS_Error($mensaje) {
	$data = array();
	$data['error'] = 1;	
	$data['error_msg'] = $mensaje;
	$data['response'] = "";
	return $data;
}
// funcion privada
function ZoomWS_Response($response) {
	$data = array();
	$data['error'] = 0;
	$data['error_msg'] = ""; 
	$data['response'] = $response;
	return $data;
}

//FUNCION QUE PERMITE CONVERTIR UN OBJETO de tipo stdClass a tipo array -- AGREGADO POR FELIX UTRERA -- 10-07-2012 
function object_2_array($result) 
{ 
	$array = array(); 
	foreach ($result as $key=>$value) 
	{ 
		if (is_object($value)) 
		{ 
			$array[$key]=object_2_array($value); 
		} 
		elseif (is_array($value)) 
		{ 
			$array[$key]=object_2_array($value); 
		} 
		else 
		{ 
			$array[$key]=$value; 
		} 
	} 
	return $array; 
}
?>