<?php

/**
* Clase RecolectaDAL que implementa el manejo de los llamados a la Base de Datos de los servicios asociados a la Recolecta
*
* @author Ingeniero Luis Blanco
* @module Recolectas
* @modulegroup Servicios
* @package CLASES DAL
*/
class ProveedorDAL {
    
     /**
      * ProveedorDAL::RestablecerValores()
      * 
      * @return
      */
     function RestablecerValores(){
        
        $Query = "DELETE FROM proveedor Where codcliente = '1017703' And codproveedor > '3400'";
        $ResulOperation = pg_exec($Query);
        
        $this->editMaximoRecolecta("3400");    
        
        $Query = "DELETE FROM proveedorsysguiae";        
        $ResulOperation = pg_exec($Query);
    }
    
    /**
     * ProveedorDAL::addProveedor()
     * 
     * @param mixed $Proveedor
     * @return
     */
    function addProveedor($Proveedor){
	
        $ProcessCompleted = MainClass::COD_OPERATION_SUCESFULLY;
        
        $Query  = "INSERT INTO proveedor(";
        $Query .= "codproveedor, codcliente, nombre, direccion, telefono, fax, inactivo,";  
        $Query .= "codciudad, codruta, contacto, urbanizacion)"; 
                       
        $Query.="VALUES";
        $Query.="(";
        $Query.= $Proveedor->codProveedor ."," .$Proveedor->codClienteMaster .",'". AddSlashes($Proveedor->nombre). "','";        
        $Query.= AddSlashes($Proveedor->direccion)."','"; 
        $Query.= AddSlashes($Proveedor->telefono)."', '". $Proveedor->fax. "','". $Proveedor->inactivo ."',";        
        $Query.= $Proveedor->codCiudad.",". $Proveedor->codRuta.",'" . AddSlashes($Proveedor->contacto)."','" . AddSlashes($Proveedor->urbanizacion)."'"; 
        $Query.=")";        
        
        $ResulOperation = pg_exec($Query);
        
        if(isset($ResulOperation) && $ResulOperation == ""){
            $ProcessCompleted = MainClass::COD_OPERATION_FAILED;
        }
       
        return $ProcessCompleted;
    }
    
    /**
     * ProveedorDAL::editProveedor()
     * 
     * @param mixed $Proveedor
     * @return
     */
    function editProveedor($Proveedor){
	
        $ProcessCompleted = MainClass::COD_OPERATION_SUCESFULLY;
        
        $Proveedor->nombre = AddSlashes($Proveedor->nombre);
        $Proveedor->direccion = AddSlashes($Proveedor->direccion);
        $Proveedor->telefono = AddSlashes($Proveedor->telefono);
        $Proveedor->contacto = AddSlashes($Proveedor->contacto);
        $Proveedor->urbanizacion = AddSlashes($Proveedor->urbanizacion);
        
        $Query  = "UPDATE proveedor SET ";
        $Query .= "nombre = '$Proveedor->nombre', direccion = '$Proveedor->direccion', telefono = '$Proveedor->telefono', ";  
        $Query .= "fax = '$Proveedor->fax', inactivo = '$Proveedor->inactivo', codciudad = $Proveedor->codCiudad "; 
                       
        $Query.="WHERE codproveedor = '$Proveedor->codProveedor' AND codcliente = '$Proveedor->codClienteMaster'";      
                 
        $ResulOperation = pg_exec($Query);
        
        if(isset($ResulOperation) && $ResulOperation == ""){
            $ProcessCompleted = MainClass::COD_OPERATION_FAILED;
        }
       
        return $ProcessCompleted;
    }
    
    /**
     * ProveedorDAL::getProveedor()
     * 
     * @param mixed $codProveedor
     * @return
     */
    function getProveedor($codProveedor){
        
        $Query = "SELECT codproveedor, codcliente, nombre, direccion, telefono, fax, inactivo, 
                  codciudad, codruta, contacto, urbanizacion
                  FROM proveedor ";
        $Query.= "WHERE codproveedor = ". $codProveedor; 
                
   	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;                 
    }
    
    /**
     * ProveedorDAL::getOficina_Cliente()
     * 
     * @param mixed $codCliente
     * @return
     */
    function getOficina_Cliente($codCliente){
        
        $Query = "SELECT tbl_cli.codcliente, tbl_cli.fecha, tbl_cli.codoficina, tbl_cli.nombre AS nombre_cliente, 
                  tbl_cli.rifci, tbl_cli.nit, tbl_cli.fechacre, tbl_cli.codactividadeco, tbl_cli.personaobl, 
                  tbl_cli.cargoobl, tbl_cli.direccionobl, tbl_cli.urbanizacionobl, tbl_cli.telefonoobl, 
                  tbl_cli.faxobl, tbl_cli.codruta, tbl_cli.codtipocli, tbl_cli.inactivo, tbl_cli.codtipobanc, 
                  tbl_cli.especial, tbl_cli.empleado, tbl_ofc.codoficina, tbl_ofc.nombre AS nombre_oficina, 
                  tbl_ofc.siglas, tbl_ofc.direccion, tbl_ofc.telefono1, tbl_ofc.telefono2, tbl_ofc.mail, 
                  tbl_ofc.codciudad, tbl_ofc.inactivo, tbl_ofc.codmunicipio, tbl_ofc.codparroquia, 
                  tbl_ofc.zipcode 
                  FROM cliente tbl_cli
                  INNER JOIN oficina tbl_ofc
                  ON tbl_cli.codoficina = tbl_ofc.codoficina ";
        $Query.= "WHERE tbl_cli.codcliente = '$codCliente'"; 
        
	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;  
        
    }    
    
    /**
     * ProveedorDAL::getProveedor_Cliente()
     * 
     * @param mixed $codProveedor
     * @param mixed $codCliente
     * @return
     */
    function getProveedor_Cliente($codProveedor, $codCliente){
        
        $Query = "SELECT codproveedor, codcliente, nombre, direccion, telefono, fax, inactivo, 
                  codciudad, codruta, contacto, urbanizacion
                  FROM proveedor ";
        $Query.= "WHERE codproveedor = '$codProveedor' AND codcliente = '$codCliente'"; 
        
	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;                 
    }
    
    /**
     * ProveedorDAL::getProveedor_ClienteParents()
     * 
     * @param mixed $codProveedor
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getProveedor_ClienteParents($codProveedor, $codClienteMaster, $codCliente){
        
        $Query = "SELECT 
                  tbl_proveedor.codproveedor, tbl_proveedor.codcliente, tbl_proveedor.nombre, 
                  tbl_proveedor.direccion, tbl_proveedor.telefono, tbl_proveedor.fax, tbl_proveedor.inactivo, 
                  tbl_proveedor.codciudad, tbl_proveedor.codruta, tbl_proveedor.contacto, tbl_proveedor.urbanizacion,
	              tbl_proveedorsysguiae.codclientemaster, tbl_proveedorsysguiae.codcliente AS codclienteparent
                  FROM proveedor AS tbl_proveedor
                  INNER JOIN 
                  proveedorsysguiae AS tbl_proveedorsysguiae
                  ON tbl_proveedorsysguiae.codproveedor = tbl_proveedor.codproveedor ";
        $Query.= "WHERE tbl_proveedor.codproveedor = '$codProveedor' AND 
                  tbl_proveedorsysguiae.codclientemaster = '$codClienteMaster' AND 
                  tbl_proveedorsysguiae.codcliente = '$codCliente'"; 
        
	    $dataBaseResult = pg_query($Query);
        return $dataBaseResult;                 
    }    
    
    /**
     * ProveedorDAL::getProveedores()
     * 
     * @param mixed $codCliente
     * @return
     */
    function getProveedores($codCliente){
        
        $Query = "SELECT codproveedor, codcliente, nombre, direccion, telefono, fax, inactivo, "; 
        $Query.= "codciudad, codruta, contacto, urbanizacion ";
        $Query.= "FROM proveedor ";
        $Query.= "WHERE codcliente = ". $codCliente; 
        $Query.= "AND codproveedor NOT IN (SELECT codproveedor FROM proveedorsysguiae WHERE codclientemaster = $codCliente)";
           	    
	    $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;                 
    }
    
    /**
     * ProveedorDAL::getProveedores_ClienteParents()
     * 
     * @param mixed $codClienteMaster
     * @param mixed $codCliente
     * @return
     */
    function getProveedores_ClienteParents($codClienteMaster, $codCliente){
        
        $Query = "SELECT ";
        $Query.= "tbl_proveedor.codproveedor, tbl_proveedor.codcliente, tbl_proveedor.nombre, "; 
        $Query.= "tbl_proveedor.direccion, tbl_proveedor.telefono, tbl_proveedor.fax, tbl_proveedor.inactivo, "; 
        $Query.= "tbl_proveedor.codciudad, tbl_proveedor.codruta, tbl_proveedor.contacto, tbl_proveedor.urbanizacion, ";
	    $Query.= "tbl_proveedorsysguiae.codclientemaster, tbl_proveedorsysguiae.codcliente AS codclienteparent ";
        $Query.= "FROM proveedor AS tbl_proveedor ";
        $Query.= "INNER JOIN ";
        $Query.= "proveedorsysguiae AS tbl_proveedorsysguiae ";
        $Query.= "ON tbl_proveedorsysguiae.codproveedor = tbl_proveedor.codproveedor ";
        $Query.= "WHERE tbl_proveedorsysguiae.codclientemaster = '$codClienteMaster' AND "; 
        $Query.= "tbl_proveedorsysguiae.codcliente = '$codCliente' ";
        $Query.= "Order By tbl_proveedor.codproveedor ASC"; 
           	    
	    $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;                 
    }       
    
    /**
     * ProveedorDAL::getCodProveedor()
     * 
     * @return
     */
    function getCodProveedor(){
        
        $Query = "SELECT codmaximo, tabla, valormax FROM maximo  Where codmaximo = 4 for update";
        
        $dataBaseResult = pg_query($Query);	
        return $dataBaseResult;
    }
    
    /**
     * ProveedorDAL::editMaximoProveedor()
     * 
     * @param mixed $codProveedor
     * @return
     */
    function editMaximoProveedor($codProveedor){
        
        $ProcessCompleted = true;
        
        $Query  = " UPDATE maximo ";
        $Query .= " SET valormax = ". $codProveedor;
        $Query .= " WHERE codmaximo = 4";  

        $ResulOperation = pg_exec($Query);        
        return $ProcessCompleted;        
    }
    
    /**
     * ProveedorDAL::addProveedorSysGuiaElectronica()
     * 
     * @param mixed $Proveedor
     * @return
     */
    function addProveedorSysGuiaElectronica($Proveedor){
        
        $ProcessCompleted = true;
                      
        $Query  = "INSERT INTO proveedorsysguiae ";
        $Query .= "(codproveedor, codclientemaster, codcliente, inactivo, fechamod) ";
        $Query .= " VALUES ('$Proveedor->codProveedor', '$Proveedor->codClienteMaster', '$Proveedor->codCliente', '$Proveedor->inactivo', '". date('Y-m-d')."')";

        $ResulOperation = pg_exec($Query);
               
        return $ProcessCompleted;
    }
    
    /**
     * ProveedorDAL::editProveedorSysGuiaElectronica()
     * 
     * @param mixed $Proveedor
     * @return
     */
    function editProveedorSysGuiaElectronica($Proveedor){
        
        $ProcessCompleted = true;
        
        $Query  = "UPDATE proveedorsysguiae ";
        $Query .= "SET inactivo = '$Proveedor->inactivo', fechamod = '". date('Y-m-d')."'";
        $Query .= "WHERE  codrecolecta = '$Proveedor->codProveedor' AND codclientemaster = '$Proveedor->codClienteMaster' AND codcliente = '$Proveedor->codCliente' ";

        $ResulOperation = pg_exec($Query);
                       
        return $ProcessCompleted;
    }
    
    /**
     * ProveedorDAL::imprime()
     * 
     * @param mixed $valorImprimir
     * @return
     */
    function imprime($valorImprimir){
	   echo "<br> $valorImprimir <br>";
    }
    
    /**
     * ProveedorDAL::imprimeObjeto()
     * 
     * @param mixed $objectoImprimir
     * @return
     */
    function imprimeObjeto($objectoImprimir){
        var_dump($objectoImprimir);
    }
    
    /**
     * ProveedorDAL::imprimeVariable()
     * 
     * @param mixed $variableImprimir
     * @param mixed $valorImprimir
     * @return
     */
    function imprimeVariable($variableImprimir, $valorImprimir){
	   echo "<br> El valor de la variable $variableImprimir es: $valorImprimir <br>";
    }    
    
    /**
     * ProveedorDAL::imprimeVariableResaltada()
     * 
     * @param mixed $variableImprimir
     * @param mixed $valorImprimir
     * @return
     */
    function imprimeVariableResaltada($variableImprimir, $valorImprimir){
	   echo "<br> El valor de la variable <strong>$variableImprimir</strong> es: <strong>$valorImprimir</strong> <br>";
    }
    
    /**
     * ProveedorDAL::imprimeTipoDatoVariable()
     * 
     * @param mixed $variableImprimir
     * @param mixed $valorImprimir
     * @return
     */
    function imprimeTipoDatoVariable($variableImprimir, $valorImprimir){        
        echo "<br> El valor de la variable <strong>$variableImprimir</strong>; con valor:  <strong>$valorImprimir</strong>; El tipo de Dato es: <strong>" . gettype ($valorImprimir) . "</strong><br />\n";
    }

}//END CLASS RecolectaDAL

?>