<?php

/**
* Clase que implementa el manejo de Mtodos Genricos de las clases
*
* @author Ingeniero Luis Blanco
* @module Recolectas
* @modulegroup Servicios
* @package SERVICIOS
*/

class MainClass {  
    	
	/**
	CodeResponse Propiedad para indica el codigo del Mensaje asociado a la respuesta del servicio. 
	*/  
	var $codResponse;
	
	/**
	Message Propiedad para indica el mensaje asociado a la respuesta del servicio. 
	*/  
	var $messageResponse;
       
    function imprime($valorImprimir){
	   echo $valorImprimir . "<br>";
    }
    
    function imprimeObjeto($objectoImprimir){
        var_dump($objectoImprimir);
    }
    
    function imprimeVariable($variableImprimir, $valorImprimir){
	   echo "<br> El valor de la variable $variableImprimir es: $valorImprimir <br>";
    }  
    
    /**
	Constantes de Autenticacion  
	*/
    const COD_USUARIO_WEBSERVICES = "999";
    const COD_TOKEN_AUTHORIZATION = "CB014068-24E5-4861-B9CD-866AC0B14B0D";
        
    /**
	Constantes de Mensajes asociadas al Tracking  
	*/
    const MSG_RECOLECTA_TRACKING_ADD_VALUE = "INGRESO";
    const MSG_RECOLECTA_TRACKING_ADD_TEXT = "Recolecta realizada por el Sistema de Guia Electronica";
    const MSG_RECOLECTA_TRACKING_EDIT_VALUE = "EDICION";
    const MSG_RECOLECTA_TRACKING_EDIT_TEXT = "Recolecta modificada por el Sistema de Guia Electronica";
    const MSG_RECOLECTA_TRACKING_CANCEL_VALUE = "ANULACION";
    const MSG_RECOLECTA_TRACKING_CANCEL_TEXT = "Recolecta anulada por el Sistema de Guia Electronica";
    
    /**
	Constantes de validacion de operaciones en los servicios
	*/
    const COD_SERVICIO_GUIA = "GUIA";
    const COD_SERVICIO_CASILLERO = "CASILLERO";
    const COD_TIPO_ENVIO_DOCUMENTO = "D";
    const COD_TIPO_ENVIO_MERCANCIA = "M";    
    
    const COD_OPERATION_SUCESFULLY = "true";
    const COD_OPERATION_FAILED = "false";
    const COD_STRING_EMPTY = "";
    const COD_DATE_EMPTY = "1999-01-01";
    const COD_ENTITY_ID = "-1";
    const COD_ENTITY_ACTIVO_STRING = "activo";
    const COD_ENTITY_ACTIVO_VALUE = "f";
    const COD_ENTITY_INACTIVO_VALUE = "t";
    const COD_ENTITY_REPLACE_VALUE = "codEntityReplace";
    
    /**
	Constantes asociadas a las entidades que estan definidas en servicio
	*/    
    const ENTITY_NAME_RECOLECTA = "Recolecta";
    const ENTITY_NAME_PROVEEDOR = "Proveedor";
    const ENTITY_NAME_LIBRETA = "Libreta";
    
    
     /**
	Constantes asociadas a las respuestas de los servicios 
	*/
    
    
    
    const COD_RESPONSE_SUCCESSFULLY = "COD_000";
    const MSG_RESPONSE_SUCCESSFULLY = "Consulta Realizada Exitosamente."; 
    
    /**
     * SUCCESSFULLY editRecolecta Code: CODE_001, Recolecta creada Exitosamente.
     */
    const COD_RESPONSE_SUCCESSFULLY_001 = "COD_001";
    const MSG_RESPONSE_SUCCESSFULLY_001 = "Recolecta creada Exitosamente.";
    
    /**
     * SUCCESSFULLY editRecolecta Code: CODE_002, Recolecta editada Exitosamente.
     */
    const COD_RESPONSE_SUCCESSFULLY_002 = "COD_002";
    const MSG_RESPONSE_SUCCESSFULLY_002 = "Recolecta editada Exitosamente.";
    
    /**
     * SUCCESSFULLY addProveedor Code: CODE_003, Recolecta anulada Exitosamente.
     */
    const COD_RESPONSE_SUCCESSFULLY_003 = "COD_003";
    const MSG_RESPONSE_SUCCESSFULLY_003 = "Recolecta anulada Exitosamente.";
    
     /**
     * SUCCESSFULLY editProveedor Code: CODE_004, Recolecta creada Exitosamente.
     */
    const COD_RESPONSE_SUCCESSFULLY_004 = "COD_004";
    const MSG_RESPONSE_SUCCESSFULLY_004 = "Proveedor creado Exitosamente.";
    
    /**
     * SUCCESSFULLY editRecolecta Code: CODE_005, Recolecta creada Exitosamente.
     */
    const COD_RESPONSE_SUCCESSFULLY_005 = "COD_005";
    const MSG_RESPONSE_SUCCESSFULLY_005 = "Proveedor editado Exitosamente.";
    
    
    /**
     * Error addRecolecta Code: CODE_001, Codigo de Cliente no valido.
     */
    const COD_RESPONSE_ERROR_001 = "CODE_001";
    const MSG_RESPONSE_ERROR_001 = "Codigo de Cliente no valido."; 
    
    /**
     * Error editRecolecta Code: CODE_002, La recolecta no existe dentro del Sistema.
     */    
    const COD_RESPONSE_ERROR_002 = "CODE_002";
    const MSG_RESPONSE_ERROR_002 = "La recolecta no existe dentro del Sistema.";
    
     /**
     * Error getRecolecta o getRecolectas Code: CODE_003, El cliente no tiene recolectas asociadas o activas.
     */ 
    const COD_RESPONSE_ERROR_003 = "CODE_003";
    const MSG_RESPONSE_ERROR_003 = "El cliente no tiene recolectas asociadas o activas.";
    
    /**
     * Error addRecolecta Code: CODE_004, la recolecta no pudo salvarse.
     */
    const COD_RESPONSE_ERROR_004 = "CODE_004";
    const MSG_RESPONSE_ERROR_004 = "Error al insertar en la Base de Datos. La Recolecta no fue guardada en el sistema.";
    
    /**
     * Error addRecolecta Code: CODE_005, el codigo de la recolecta ya existe.
     */
    const COD_RESPONSE_ERROR_005 = "CODE_005";
    const MSG_RESPONSE_ERROR_005 = "El codigo de la recolecta ya existe.";
    
    /**
     * Error addRecolecta Code: CODE_006,la fecha de la recolecta es menor a la fecha actual en el servidor.
     */
    const COD_RESPONSE_ERROR_006 = "CODE_006";
    const MSG_RESPONSE_ERROR_006 = "Fecha invalida la fecha de la recolecta es menor a la fecha actual en el servidor.";
    
    /**
     * Error addRecolecta Code: CODE_007,  el Codigo del casillero no ha sido asignado y el tipo de Servicio seleccionado es Casillero.
     */
    const COD_RESPONSE_ERROR_007 = "CODE_007";
    const MSG_RESPONSE_ERROR_007 = "Error al salvar la Recolecta. El Codigo del casillero no ha sido asignado y el tipo de Servicio seleccionado es Casillero.";
    
    /**
     * Error addRecolecta Code: CODE_008, el Codigo del servicio no ha sido asignado.
     */
    const COD_RESPONSE_ERROR_008 = "CODE_008";
    const MSG_RESPONSE_ERROR_008 = "Error al salvar la Recolecta. El Codigo del servicio no ha sido asignado.";
    
    /**
     * Error addRecolecta Code: CODE_009, Error al salvar la Recolecta. El proveedor no pertenece al cliente seleccionado.
     */
    const COD_RESPONSE_ERROR_009 = "CODE_009";
    const MSG_RESPONSE_ERROR_009 = "Error al salvar la Recolecta. El proveedor no pertenece al cliente seleccionado.";
    
     /**
     * Error addRecolecta Code: CODE_010, Error al salvar la Recolecta. El proveedor no ha sido asignado.
     */
    const COD_RESPONSE_ERROR_010 = "CODE_010";
    const MSG_RESPONSE_ERROR_010 = "Error al salvar la Recolecta. El proveedor no ha sido asignado.";
    
     /**
     * Error addRecolecta Code: CODE_011, Error al salvar la Recolecta. El codigo de Tipo de Envio no ha sido asignado.
     */
    const COD_RESPONSE_ERROR_011 = "CODE_011";
    const MSG_RESPONSE_ERROR_011 = "Error al salvar la Recolecta. El codigo de Tipo de Envio no ha sido asignado.";
    
     /**
     * Error addRecolecta Code: CODE_011, Error al salvar la Recolecta. El codigo de Tipo de Envio no es valido debe escoger entre Documento o Mercancia.
     */
    const COD_RESPONSE_ERROR_012 = "CODE_012";
    const MSG_RESPONSE_ERROR_012 = "Error al salvar la Recolecta. El codigo de Tipo de Envio no es valido debe escoger entre Documento o Mercancia.";
    
    /**
     * Error addRecolecta Code: CODE_013, Error al salvar la Recolecta. El codigo del Proveedor es invalido. No existe o no esta asociado al cliente especificado.
     */
    const COD_RESPONSE_ERROR_013 = "CODE_013";
    const MSG_RESPONSE_ERROR_013 = "Error al salvar la Recolecta. El codigo del Proveedor es invalido. No existe o no esta asociado al cliente especificado.";
    
    /**
     * Error addRecolecta Code: CODE_013, Error al editar la Recolecta. El codigo de la recolecta es invalido. No existe o no esta asociado al cliente especificado.
     */
    const COD_RESPONSE_ERROR_014 = "CODE_014";
    const MSG_RESPONSE_ERROR_014 = "Error al editar la Recolecta. El codigo de la recolecta es invalido. No existe o no esta asociado al cliente especificado.";
    
    /**
     * Error cancelRecolecta Code: CODE_013, Error al editar la Recolecta. El codigo de la recolecta es invalido. No existe o no esta asociado al cliente especificado.
     */
    const COD_RESPONSE_ERROR_015 = "CODE_015";
    const MSG_RESPONSE_ERROR_015 = "Error al anular la Recolecta. La Fecha de Modificacion es superior a la Fecha de la Recolecta, no es posible anular la Recolecta.";
    
    /**
     * Error cancelRecolecta Code: CODE_016, Error al anular la Recolecta. El codigo de la recolecta es invalido. No existe o no esta asociado al cliente especificado.
     */
    const COD_RESPONSE_ERROR_016 = "CODE_016";
    const MSG_RESPONSE_ERROR_016 = "Error al anular la Recolecta. La recolecta no puede ser anulada, ya que tiene un numero de guia asociada.";
    
    
    /**
     * Error addProveedor Code: CODE_017, El proveedor no existe dentro del Sistema.
     */    
    const COD_RESPONSE_ERROR_017 = "CODE_017";
    const MSG_RESPONSE_ERROR_017 = "El proveedor no existe dentro del Sistema.";
    
    /**
     * Error addProveedor Code: CODE_018, El nombre del proveedor no ha sido asignado..
     */    
    const COD_RESPONSE_ERROR_018 = "CODE_018";
    const MSG_RESPONSE_ERROR_018 = "El nombre del proveedor no ha sido asignado.";
    
    /**
     * Error addProveedor Code: CODE_019, La direccion del proveedor no ha sido asignado.
     */    
    const COD_RESPONSE_ERROR_019 = "CODE_019";
    const MSG_RESPONSE_ERROR_019 = "La direccion del proveedor no ha sido asignada.";
    
    /**
     * Error addProveedor Code: CODE_020, La direccion del proveedor no ha sido asignado.
     */    
    const COD_RESPONSE_ERROR_020 = "CODE_020";
    const MSG_RESPONSE_ERROR_020 = "El estatus  no ha sido asignado.";
    
    /**
     * Error addProveedor Code: CODE_021, La direccion del proveedor no ha sido asignado.
     */    
    const COD_RESPONSE_ERROR_021 = "CODE_021";
    const MSG_RESPONSE_ERROR_021 = "El codigo de la ciudad no ha sido asignado.";
    
    /**
     * Error addProveedor Code: CODE_022, El codigo de la ruta no ha sido asignado.
     */    
    const COD_RESPONSE_ERROR_022 = "CODE_022";
    const MSG_RESPONSE_ERROR_022 = "El codigo de la ruta no ha sido asignado.";
    
    /**
     * Error addProveedor Code: CODE_023, El codigo de la ruta no ha sido asignado.
     */    
    const COD_RESPONSE_ERROR_023 = "CODE_023";
    const MSG_RESPONSE_ERROR_023 = "El contacto del proveedor no ha sido asignado.";
    
    /**
     * Error addProveedor Code: CODE_024, La urbanizacion del proveedor no ha sido asignado.
     */    
    const COD_RESPONSE_ERROR_024 = "CODE_024";
    const MSG_RESPONSE_ERROR_024 = "La urbanizacion del proveedor no ha sido asignado.";
    
    /**
     * Error addProveedor Code: CODE_025, El codigo de la ciudad asociada al proveedor no coincide con el cod de la ciudad del cliente.
     */    
    const COD_RESPONSE_ERROR_025 = "CODE_025";
    const MSG_RESPONSE_ERROR_025 = "El codigo de la ciudad asociada al proveedor no coincide con el codigo de la ciudad del cliente.";
    
    /**
     * Error editProveedor Code: CODE_026, Error al editar el Proveedor. El codigo del proveedor es invalido. No existe o no esta asociado al cliente especificado.
     */
    const COD_RESPONSE_ERROR_026 = "CODE_026";
    const MSG_RESPONSE_ERROR_026 = "Error al editar el Proveedor. El codigo del proveedor es invalido. No existe o no esta asociado al cliente especificado.";
    
    /**
     * Error addRecolecta Code: CODE_004, la recolecta no pudo salvarse.
     */
    const COD_RESPONSE_ERROR_027 = "CODE_027";
    const MSG_RESPONSE_ERROR_027 = "Error al insertar en la Base de Datos. El Proveedor no fue guardado en el sistema.";
    
    
    /**
     * Constante para definir el Mensaje de Error asociado a la conexin con la Base de Datos
     */
    const COD_RESPONSE_ERROR_099 = "CODE_099";
    const MSG_RESPONSE_ERROR_099 = "Error de autenticacion al momento de ejecutar el servicio."; 
    
    /**
     * Constante para definir el Mensaje de Error asociado a la conexin con la Base de Datos
     */
    const COD_RESPONSE_ERROR_100 = "CODE_100";
    const MSG_RESPONSE_ERROR_100 = "Error de conexin con la base de datos."; 
        
}//END CLASS MainClass

?>